<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Instance_IDType' => '\\StructType\\Instance_IDType',
            'InstanceObjectType' => '\\StructType\\InstanceObjectType',
            'Workday_Common_HeaderType' => '\\StructType\\Workday_Common_HeaderType',
            'External_Integration_ID_DataType' => '\\StructType\\External_Integration_ID_DataType',
            'IDType' => '\\StructType\\IDType',
            'Organization_WWSType' => '\\StructType\\Organization_WWSType',
            'Server_Timestamp_GetType' => '\\StructType\\Server_Timestamp_GetType',
            'Server_TimestampType' => '\\StructType\\Server_TimestampType',
            'Effective_And_Updated_DateTime_DataType' => '\\StructType\\Effective_And_Updated_DateTime_DataType',
            'Response_FilterType' => '\\StructType\\Response_FilterType',
            'Response_ResultsType' => '\\StructType\\Response_ResultsType',
            'Transaction_Log_CriteriaType' => '\\StructType\\Transaction_Log_CriteriaType',
            'Business_Process_Comment_DataType' => '\\StructType\\Business_Process_Comment_DataType',
            'Request_One_Time_Payment_Sub_Business_ProcessType' => '\\StructType\\Request_One_Time_Payment_Sub_Business_ProcessType',
            'Business_Sub_Process_ParametersType' => '\\StructType\\Business_Sub_Process_ParametersType',
            'Business_Process_ParametersType' => '\\StructType\\Business_Process_ParametersType',
            'Person_Name_DataType' => '\\StructType\\Person_Name_DataType',
            'Legal_Name_DataType' => '\\StructType\\Legal_Name_DataType',
            'Person_Name_Detail_DataType' => '\\StructType\\Person_Name_Detail_DataType',
            'Person_Name_Prefix_DataType' => '\\StructType\\Person_Name_Prefix_DataType',
            'Person_Name_Suffix_DataType' => '\\StructType\\Person_Name_Suffix_DataType',
            'Preferred_Name_DataType' => '\\StructType\\Preferred_Name_DataType',
            'Additional_Name_DataType' => '\\StructType\\Additional_Name_DataType',
            'Personal_Information_DataType' => '\\StructType\\Personal_Information_DataType',
            'Person_Military_Service_DataType' => '\\StructType\\Person_Military_Service_DataType',
            'One-Time_Payment_DataType' => '\\StructType\\One_Time_Payment_DataType',
            'Person_Identification_DataType' => '\\StructType\\Person_Identification_DataType',
            'Person_Qualification_DataType' => '\\StructType\\Person_Qualification_DataType',
            'Contact_Information_DataType' => '\\StructType\\Contact_Information_DataType',
            'Address_Information_DataType' => '\\StructType\\Address_Information_DataType',
            'Phone_Information_DataType' => '\\StructType\\Phone_Information_DataType',
            'Email_Address_Information_DataType' => '\\StructType\\Email_Address_Information_DataType',
            'Instant_Messenger_Information_DataType' => '\\StructType\\Instant_Messenger_Information_DataType',
            'Web_Address_Information_DataType' => '\\StructType\\Web_Address_Information_DataType',
            'Address_Line_Information_DataType' => '\\StructType\\Address_Line_Information_DataType',
            'Submunicipality_Information_DataType' => '\\StructType\\Submunicipality_Information_DataType',
            'Subregion_Information_DataType' => '\\StructType\\Subregion_Information_DataType',
            'Communication_Method_Usage_Information_DataType' => '\\StructType\\Communication_Method_Usage_Information_DataType',
            'Communication_Usage_Type_DataType' => '\\StructType\\Communication_Usage_Type_DataType',
            'Edit_Assign_Position_Organization_Sub_Business_ProcessType' => '\\StructType\\Edit_Assign_Position_Organization_Sub_Business_ProcessType',
            'National_IDType' => '\\StructType\\National_IDType',
            'Government_IDType' => '\\StructType\\Government_IDType',
            'Visa_IDType' => '\\StructType\\Visa_IDType',
            'Passport_IDType' => '\\StructType\\Passport_IDType',
            'License_IDType' => '\\StructType\\License_IDType',
            'Custom_IDType' => '\\StructType\\Custom_IDType',
            'National_ID_DataType' => '\\StructType\\National_ID_DataType',
            'Visa_ID_DataType' => '\\StructType\\Visa_ID_DataType',
            'Government_ID_DataType' => '\\StructType\\Government_ID_DataType',
            'Passport_ID_DataType' => '\\StructType\\Passport_ID_DataType',
            'License_ID_DataType' => '\\StructType\\License_ID_DataType',
            'Custom_ID_DataType' => '\\StructType\\Custom_ID_DataType',
            'Job_HistoryType' => '\\StructType\\Job_HistoryType',
            'Certification_AchievementType' => '\\StructType\\Certification_AchievementType',
            'TrainingType' => '\\StructType\\TrainingType',
            'Professional_Affiliation_SkillType' => '\\StructType\\Professional_Affiliation_SkillType',
            'Job_History_Achievement_DataType' => '\\StructType\\Job_History_Achievement_DataType',
            'Competency_Achievement_Data__v10_Type' => '\\StructType\\Competency_Achievement_Data__v10_Type',
            'Certification_Achievement_DataType' => '\\StructType\\Certification_Achievement_DataType',
            'Training_Achievement_DataType' => '\\StructType\\Training_Achievement_DataType',
            'Professional_Affiliation_Organization_DataType' => '\\StructType\\Professional_Affiliation_Organization_DataType',
            'Work_Experience_DataType' => '\\StructType\\Work_Experience_DataType',
            'Proposed_Base_Pay_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Base_Pay_Plan_Assignment_Container_DataType',
            'Compensatable_Guidelines_DataType' => '\\StructType\\Compensatable_Guidelines_DataType',
            'Proposed_Base_Pay_Plan_Assignment_DataType' => '\\StructType\\Proposed_Base_Pay_Plan_Assignment_DataType',
            'Proposed_Salary_Unit_Plan_Assignment_DataType' => '\\StructType\\Proposed_Salary_Unit_Plan_Assignment_DataType',
            'Proposed_Salary_Unit_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Salary_Unit_Plan_Assignment_Container_DataType',
            'Proposed_Allowance_Plan_Assignment_DataType' => '\\StructType\\Proposed_Allowance_Plan_Assignment_DataType',
            'Proposed_Allowance_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Allowance_Plan_Assignment_Container_DataType',
            'Proposed_Allowance_Unit_Plan_Assignment_DataType' => '\\StructType\\Proposed_Allowance_Unit_Plan_Assignment_DataType',
            'Proposed_Allowance_Unit_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Allowance_Unit_Plan_Assignment_Container_DataType',
            'Proposed_Bonus_Plan_Assignment_DataType' => '\\StructType\\Proposed_Bonus_Plan_Assignment_DataType',
            'Proposed_Bonus_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Bonus_Plan_Assignment_Container_DataType',
            'Proposed_Merit_Plan_Assignment_DataType' => '\\StructType\\Proposed_Merit_Plan_Assignment_DataType',
            'Proposed_Merit_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Merit_Plan_Assignment_Container_DataType',
            'Proposed_Commission_Plan_Assignment_DataType' => '\\StructType\\Proposed_Commission_Plan_Assignment_DataType',
            'Proposed_Commission_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Commission_Plan_Assignment_Container_DataType',
            'Assign_Position_Organization_Event_DataType' => '\\StructType\\Assign_Position_Organization_Event_DataType',
            'Military_Service_Sub_DataType' => '\\StructType\\Military_Service_Sub_DataType',
            'Get_Applicants_RequestType' => '\\StructType\\Get_Applicants_RequestType',
            'Applicant_Request_ReferencesType' => '\\StructType\\Applicant_Request_ReferencesType',
            'Applicant_Response_GroupType' => '\\StructType\\Applicant_Response_GroupType',
            'Get_Applicants_ResponseType' => '\\StructType\\Get_Applicants_ResponseType',
            'Applicants_Response_DataType' => '\\StructType\\Applicants_Response_DataType',
            'Applicant_WWSType' => '\\StructType\\Applicant_WWSType',
            'Pre-Hire_Data_WWSType' => '\\StructType\\Pre_Hire_Data_WWSType',
            'Attachment_Data_WWSType' => '\\StructType\\Attachment_Data_WWSType',
            'Recruiting_DataType' => '\\StructType\\Recruiting_DataType',
            'Pre-Hire_Resume_Detail_DataType' => '\\StructType\\Pre_Hire_Resume_Detail_DataType',
            'Pre-Hire_Resume_DataType' => '\\StructType\\Pre_Hire_Resume_DataType',
            'Propose_Compensation_For_Employment_Sub_Business_ProcessType' => '\\StructType\\Propose_Compensation_For_Employment_Sub_Business_ProcessType',
            'Compensation_Proposed_For_Employment_DataType' => '\\StructType\\Compensation_Proposed_For_Employment_DataType',
            'Put_Applicant_RequestType' => '\\StructType\\Put_Applicant_RequestType',
            'Put_Applicant_ResponseType' => '\\StructType\\Put_Applicant_ResponseType',
            'Transaction_Type_ReferencesType' => '\\StructType\\Transaction_Type_ReferencesType',
            'Request_Compensation_Default_Sub_Business_ProcessType' => '\\StructType\\Request_Compensation_Default_Sub_Business_ProcessType',
            'Compensation_Default_DataType' => '\\StructType\\Compensation_Default_DataType',
            'Proposed_Base_Pay_Plan_Job_Assignment_DataType' => '\\StructType\\Proposed_Base_Pay_Plan_Job_Assignment_DataType',
            'Proposed_Base_Pay_Plan_Job_Assignment_Container_DataType' => '\\StructType\\Proposed_Base_Pay_Plan_Job_Assignment_Container_DataType',
            'Create_Position_RequestType' => '\\StructType\\Create_Position_RequestType',
            'Create_Position_DataType' => '\\StructType\\Create_Position_DataType',
            'Position_Definition_DataType' => '\\StructType\\Position_Definition_DataType',
            'Position_Group_Restriction_DataType' => '\\StructType\\Position_Group_Restriction_DataType',
            'Create_Position_ResponseType' => '\\StructType\\Create_Position_ResponseType',
            'Exception_DataType' => '\\StructType\\Exception_DataType',
            'Get_Positions_RequestType' => '\\StructType\\Get_Positions_RequestType',
            'Position_Request_ReferencesType' => '\\StructType\\Position_Request_ReferencesType',
            'Position_Request_CriteriaType' => '\\StructType\\Position_Request_CriteriaType',
            'Position_Response_GroupType' => '\\StructType\\Position_Response_GroupType',
            'Get_Positions_ResponseType' => '\\StructType\\Get_Positions_ResponseType',
            'Positions_Response_DataType' => '\\StructType\\Positions_Response_DataType',
            'Position_RestrictionType' => '\\StructType\\Position_RestrictionType',
            'Position_DataType' => '\\StructType\\Position_DataType',
            'Default_Position_Organization_Assignments_DataType' => '\\StructType\\Default_Position_Organization_Assignments_DataType',
            'Worker_For_Filled_PositionType' => '\\StructType\\Worker_For_Filled_PositionType',
            'Proposed_Stock_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Stock_Plan_Assignment_Container_DataType',
            'Proposed_Stock_Plan_Assignment_DataType' => '\\StructType\\Proposed_Stock_Plan_Assignment_DataType',
            'Organization_Request_CriteriaType' => '\\StructType\\Organization_Request_CriteriaType',
            'Organization_Response_GroupType' => '\\StructType\\Organization_Response_GroupType',
            'Get_Organizations_RequestType' => '\\StructType\\Get_Organizations_RequestType',
            'Organization_Response_DataType' => '\\StructType\\Organization_Response_DataType',
            'Get_Organizations_ResponseType' => '\\StructType\\Get_Organizations_ResponseType',
            'Organization_WWS_DataType' => '\\StructType\\Organization_WWS_DataType',
            'Organization_Hierarchy_DataType' => '\\StructType\\Organization_Hierarchy_DataType',
            'Supervisory_Org_DataType' => '\\StructType\\Supervisory_Org_DataType',
            'Application_Instance_Exceptions_DataType' => '\\StructType\\Application_Instance_Exceptions_DataType',
            'Application_Instance_Related_Exceptions_DataType' => '\\StructType\\Application_Instance_Related_Exceptions_DataType',
            'Organization_Assignments_DataType' => '\\StructType\\Organization_Assignments_DataType',
            'Organization_Roles_WWS_DataType' => '\\StructType\\Organization_Roles_WWS_DataType',
            'Organization_Role_Assignment_WWS_DataType' => '\\StructType\\Organization_Role_Assignment_WWS_DataType',
            'Position_Details_DataType' => '\\StructType\\Position_Details_DataType',
            'Applicant_Request_CriteriaType' => '\\StructType\\Applicant_Request_CriteriaType',
            'Field_And_Parameter_Criteria_DataType' => '\\StructType\\Field_And_Parameter_Criteria_DataType',
            'Document_Field_Result_DataType' => '\\StructType\\Document_Field_Result_DataType',
            'Qualifications_from_Position_Restrictions_DataType' => '\\StructType\\Qualifications_from_Position_Restrictions_DataType',
            'Competency_Profile_for_JobType' => '\\StructType\\Competency_Profile_for_JobType',
            'Competency_Profile_for_Job_DataType' => '\\StructType\\Competency_Profile_for_Job_DataType',
            'Certification_Profile_for_JobType' => '\\StructType\\Certification_Profile_for_JobType',
            'Certification_Profile_for_Job_DataType' => '\\StructType\\Certification_Profile_for_Job_DataType',
            'Education_Profile_for_JobType' => '\\StructType\\Education_Profile_for_JobType',
            'Education_Profile_for_Job_DataType' => '\\StructType\\Education_Profile_for_Job_DataType',
            'Language_Profile_for_JobType' => '\\StructType\\Language_Profile_for_JobType',
            'Language_Profile_for_Job_DataType' => '\\StructType\\Language_Profile_for_Job_DataType',
            'Language_Ability_DataType' => '\\StructType\\Language_Ability_DataType',
            'Responsibility_Profile_for_JobType' => '\\StructType\\Responsibility_Profile_for_JobType',
            'Responsibility_Profile_for_Job_DataType' => '\\StructType\\Responsibility_Profile_for_Job_DataType',
            'Training_Profile_for_JobType' => '\\StructType\\Training_Profile_for_JobType',
            'Training_Profile_for_Job_DataType' => '\\StructType\\Training_Profile_for_Job_DataType',
            'Work_Experience_for_JobType' => '\\StructType\\Work_Experience_for_JobType',
            'Work_Experience_Profile_for_Job_DataType' => '\\StructType\\Work_Experience_Profile_for_Job_DataType',
            'Language_Achievement_DataType' => '\\StructType\\Language_Achievement_DataType',
            'Language_AbilityType' => '\\StructType\\Language_AbilityType',
            'Job_Profile_Summary_DataType' => '\\StructType\\Job_Profile_Summary_DataType',
            'Position_Group_Restriction_Summary_DataType' => '\\StructType\\Position_Group_Restriction_Summary_DataType',
            'Job_Profile_Exempt_DataType' => '\\StructType\\Job_Profile_Exempt_DataType',
            'Attachment_WWS_DataType' => '\\StructType\\Attachment_WWS_DataType',
            'Competency_Qualification_Profile_Replacement_DataType' => '\\StructType\\Competency_Qualification_Profile_Replacement_DataType',
            'Education_Qualification_Profile_Replacement_DataType' => '\\StructType\\Education_Qualification_Profile_Replacement_DataType',
            'Training_Qualification_Profile_Replacement_DataType' => '\\StructType\\Training_Qualification_Profile_Replacement_DataType',
            'Responsibility_Qualification_Profile_Replacement_DataType' => '\\StructType\\Responsibility_Qualification_Profile_Replacement_DataType',
            'Work_Experience_Qualification_Profile_Replacement_DataType' => '\\StructType\\Work_Experience_Qualification_Profile_Replacement_DataType',
            'Certification_Qualification_Profile_Replacement_DataType' => '\\StructType\\Certification_Qualification_Profile_Replacement_DataType',
            'Language_Qualification_Profile_Replacement_DataType' => '\\StructType\\Language_Qualification_Profile_Replacement_DataType',
            'Language_Ability_Profile_DataType' => '\\StructType\\Language_Ability_Profile_DataType',
            'Edit_Position_Restrictions_DataType' => '\\StructType\\Edit_Position_Restrictions_DataType',
            'Edit_Position_Restrictions_RequestType' => '\\StructType\\Edit_Position_Restrictions_RequestType',
            'Edit_Positon_Restriction_ResponseType' => '\\StructType\\Edit_Positon_Restriction_ResponseType',
            'Edit_Position_Restriction_Event_DataType' => '\\StructType\\Edit_Position_Restriction_Event_DataType',
            'Internal_Project_ExperienceType' => '\\StructType\\Internal_Project_ExperienceType',
            'Internal_Project_Experience_DataType' => '\\StructType\\Internal_Project_Experience_DataType',
            'EducationType' => '\\StructType\\EducationType',
            'Education_Achievement_DataType' => '\\StructType\\Education_Achievement_DataType',
            'Qualification_Data_for_Position_Restriction_or_Job_ProfileType' => '\\StructType\\Qualification_Data_for_Position_Restriction_or_Job_ProfileType',
            'Responsibility_Qualification_ReplacementType' => '\\StructType\\Responsibility_Qualification_ReplacementType',
            'Work_Experience_Qualification_ReplacementType' => '\\StructType\\Work_Experience_Qualification_ReplacementType',
            'Education_Qualification_ReplacementType' => '\\StructType\\Education_Qualification_ReplacementType',
            'Language_Qualification_ReplacementType' => '\\StructType\\Language_Qualification_ReplacementType',
            'Competency_Qualification_ReplacementType' => '\\StructType\\Competency_Qualification_ReplacementType',
            'Certification_Qualification_ReplacementType' => '\\StructType\\Certification_Qualification_ReplacementType',
            'Training_Qualification_ReplacementType' => '\\StructType\\Training_Qualification_ReplacementType',
            'Assign_Organization_Roles_Sub_Business_ProcessType' => '\\StructType\\Assign_Organization_Roles_Sub_Business_ProcessType',
            'Assign_Organization_Roles_Event_DataType' => '\\StructType\\Assign_Organization_Roles_Event_DataType',
            'Role_AssignmentType' => '\\StructType\\Role_AssignmentType',
            'Organization_Role_Assignment_DataType' => '\\StructType\\Organization_Role_Assignment_DataType',
            'Local_Person_Name_Detail_DataType' => '\\StructType\\Local_Person_Name_Detail_DataType',
            'Costing_Allocation_Interval_DataType' => '\\StructType\\Costing_Allocation_Interval_DataType',
            'Costing_Allocation_Detail_Replacement_DataType' => '\\StructType\\Costing_Allocation_Detail_Replacement_DataType',
            'Create_Requisition_RequestType' => '\\StructType\\Create_Requisition_RequestType',
            'Create_Job_Requisition_DataType' => '\\StructType\\Create_Job_Requisition_DataType',
            'Create_Job_Requisition_ResponseType' => '\\StructType\\Create_Job_Requisition_ResponseType',
            'Assign_Pay_Group_for_Position_Restriction_DataType' => '\\StructType\\Assign_Pay_Group_for_Position_Restriction_DataType',
            'Assign_Pay_Group_for_Position_Restrictions_Sub_Business_ProcessType' => '\\StructType\\Assign_Pay_Group_for_Position_Restrictions_Sub_Business_ProcessType',
            'Job_Requisition_DataType' => '\\StructType\\Job_Requisition_DataType',
            'Check_Position_Budget_Sub_Business_ProcessType' => '\\StructType\\Check_Position_Budget_Sub_Business_ProcessType',
            'Job_Requisition_Attachment_DataType' => '\\StructType\\Job_Requisition_Attachment_DataType',
            'Job_Requisition_Data_for_Create_and_EditType' => '\\StructType\\Job_Requisition_Data_for_Create_and_EditType',
            'Edit_Job_Requisition_RequestType' => '\\StructType\\Edit_Job_Requisition_RequestType',
            'Edit_Job_Requisition_DataType' => '\\StructType\\Edit_Job_Requisition_DataType',
            'Edit_Job_Requisition_ResponseType' => '\\StructType\\Edit_Job_Requisition_ResponseType',
            'Contingent_Worker_Cost_Information_DataType' => '\\StructType\\Contingent_Worker_Cost_Information_DataType',
            'Edit_Job_Requisition_Event_DataType' => '\\StructType\\Edit_Job_Requisition_Event_DataType',
            'Job_Requisition_AttachmentsType' => '\\StructType\\Job_Requisition_AttachmentsType',
            'Recruiting_Instruction_DataType' => '\\StructType\\Recruiting_Instruction_DataType',
            'Financials_Business_Sub_Process_ParametersType' => '\\StructType\\Financials_Business_Sub_Process_ParametersType',
            'Assign_Costing_Allocation_Event_DataType' => '\\StructType\\Assign_Costing_Allocation_Event_DataType',
            'Assign_Costing_Allocation_Sub_Business_ProcessType' => '\\StructType\\Assign_Costing_Allocation_Sub_Business_ProcessType',
            'Costing_Interval_Update_KeyType' => '\\StructType\\Costing_Interval_Update_KeyType',
            'Job_Requisition_Request_ReferencesType' => '\\StructType\\Job_Requisition_Request_ReferencesType',
            'Job_Requisition_Request_CriteriaType' => '\\StructType\\Job_Requisition_Request_CriteriaType',
            'Job_Requisition_Response_GroupType' => '\\StructType\\Job_Requisition_Response_GroupType',
            'Get_Job_Requisitions_RequestType' => '\\StructType\\Get_Job_Requisitions_RequestType',
            'Job_RequisitionType' => '\\StructType\\Job_RequisitionType',
            'Job_Requisition_Response_DataType' => '\\StructType\\Job_Requisition_Response_DataType',
            'Get_Job_Requisitions_ResponseType' => '\\StructType\\Get_Job_Requisitions_ResponseType',
            'Job_Requisition_Data_2Type' => '\\StructType\\Job_Requisition_Data_2Type',
            'Job_Requisition_Definition_DataType' => '\\StructType\\Job_Requisition_Definition_DataType',
            'Job_Requisition_Restrictions_DataType' => '\\StructType\\Job_Requisition_Restrictions_DataType',
            'Positions_DataType' => '\\StructType\\Positions_DataType',
            'Background_Check_Overall_Status_DataType' => '\\StructType\\Background_Check_Overall_Status_DataType',
            'Proposed_Period_Salary_Plan_Assignment_DataType' => '\\StructType\\Proposed_Period_Salary_Plan_Assignment_DataType',
            'Proposed_Period_Salary_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Period_Salary_Plan_Assignment_Container_DataType',
            'Person_Disability_Status_DataType' => '\\StructType\\Person_Disability_Status_DataType',
            'Put_Import_Process_ResponseType' => '\\StructType\\Put_Import_Process_ResponseType',
            'Certification_Attachment_DataType' => '\\StructType\\Certification_Attachment_DataType',
            'Candidate_DataType' => '\\StructType\\Candidate_DataType',
            'Put_Candidate_RequestType' => '\\StructType\\Put_Candidate_RequestType',
            'Put_Candidate_ResponseType' => '\\StructType\\Put_Candidate_ResponseType',
            'Candidate_Name_DataType' => '\\StructType\\Candidate_Name_DataType',
            'Candidate_Contact_DataType' => '\\StructType\\Candidate_Contact_DataType',
            'Candidate_Social_Media_Account_DataType' => '\\StructType\\Candidate_Social_Media_Account_DataType',
            'Candidate_Request_ReferencesType' => '\\StructType\\Candidate_Request_ReferencesType',
            'Candidate_Request_CriteriaType' => '\\StructType\\Candidate_Request_CriteriaType',
            'Candidate_Response_GroupType' => '\\StructType\\Candidate_Response_GroupType',
            'Get_Candidates_RequestType' => '\\StructType\\Get_Candidates_RequestType',
            'CandidateType' => '\\StructType\\CandidateType',
            'Candidate_Response_DataType' => '\\StructType\\Candidate_Response_DataType',
            'Get_Candidates_ResponseType' => '\\StructType\\Get_Candidates_ResponseType',
            'Candidate_Status_DataType' => '\\StructType\\Candidate_Status_DataType',
            'Job_Requisition_Organizations_DataType' => '\\StructType\\Job_Requisition_Organizations_DataType',
            'Candidate_Skill_DataType' => '\\StructType\\Candidate_Skill_DataType',
            'Job_Requisition_Organizations_Data_for_Business_ProcessType' => '\\StructType\\Job_Requisition_Organizations_Data_for_Business_ProcessType',
            'Candidate_Experience_DataType' => '\\StructType\\Candidate_Experience_DataType',
            'Candidate_Resume_DataType' => '\\StructType\\Candidate_Resume_DataType',
            'Candidate_Education_DataType' => '\\StructType\\Candidate_Education_DataType',
            'Candidate_Job_Applied_To_DataType' => '\\StructType\\Candidate_Job_Applied_To_DataType',
            'Candidate_Photo_DataType' => '\\StructType\\Candidate_Photo_DataType',
            'Unpost_Job_RequestType' => '\\StructType\\Unpost_Job_RequestType',
            'Unpost_Job_ResponseType' => '\\StructType\\Unpost_Job_ResponseType',
            'Post_Job_Business_Process_DataType' => '\\StructType\\Post_Job_Business_Process_DataType',
            'Post_Job_ResponseType' => '\\StructType\\Post_Job_ResponseType',
            'Job_Posting_Site_DataType' => '\\StructType\\Job_Posting_Site_DataType',
            'Post_Job_RequestType' => '\\StructType\\Post_Job_RequestType',
            'Unpost_Job_Business_Process_DataType' => '\\StructType\\Unpost_Job_Business_Process_DataType',
            'Job_Posting_Reference_DataType' => '\\StructType\\Job_Posting_Reference_DataType',
            'Job_Posting_DataType' => '\\StructType\\Job_Posting_DataType',
            'Update_Job_Posting_Business_Process_DataType' => '\\StructType\\Update_Job_Posting_Business_Process_DataType',
            'Update_Job_Posting_RequestType' => '\\StructType\\Update_Job_Posting_RequestType',
            'Update_Job_Posting_ResponseType' => '\\StructType\\Update_Job_Posting_ResponseType',
            'Update_Job_Posting_DataType' => '\\StructType\\Update_Job_Posting_DataType',
            'Close_Job_Requisition_DataType' => '\\StructType\\Close_Job_Requisition_DataType',
            'Close_Job_Requisition_RequestType' => '\\StructType\\Close_Job_Requisition_RequestType',
            'Close_Job_Requisition_ResponseType' => '\\StructType\\Close_Job_Requisition_ResponseType',
            'Put_Candidate_Attachment_RequestType' => '\\StructType\\Put_Candidate_Attachment_RequestType',
            'Candidate_Attachment_Request_ReferencesType' => '\\StructType\\Candidate_Attachment_Request_ReferencesType',
            'Candidate_Attachment_Response_GroupType' => '\\StructType\\Candidate_Attachment_Response_GroupType',
            'Get_Candidate_Attachments_RequestType' => '\\StructType\\Get_Candidate_Attachments_RequestType',
            'Candidate_Attachment_DataType' => '\\StructType\\Candidate_Attachment_DataType',
            'Candidate_Attachment_Response_DataType' => '\\StructType\\Candidate_Attachment_Response_DataType',
            'Get_Candidate_Attachments_ResponseType' => '\\StructType\\Get_Candidate_Attachments_ResponseType',
            'Candidate_Attachment_Request_CriteriaType' => '\\StructType\\Candidate_Attachment_Request_CriteriaType',
            'Put_Candidate_Attachment_ResponseType' => '\\StructType\\Put_Candidate_Attachment_ResponseType',
            'Candidate_Attachment_WWSType' => '\\StructType\\Candidate_Attachment_WWSType',
            'Job_Posting_Site_Request_ReferencesType' => '\\StructType\\Job_Posting_Site_Request_ReferencesType',
            'Job_Posting_Site_Request_CriteriaType' => '\\StructType\\Job_Posting_Site_Request_CriteriaType',
            'Job_Posting_Site_Response_GroupType' => '\\StructType\\Job_Posting_Site_Response_GroupType',
            'Get_Job_Posting_Sites_RequestType' => '\\StructType\\Get_Job_Posting_Sites_RequestType',
            'Job_Posting_SiteType' => '\\StructType\\Job_Posting_SiteType',
            'Job_Posting_Site_Response_DataType' => '\\StructType\\Job_Posting_Site_Response_DataType',
            'Get_Job_Posting_Sites_ResponseType' => '\\StructType\\Get_Job_Posting_Sites_ResponseType',
            'Put_Job_Posting_Site_RequestType' => '\\StructType\\Put_Job_Posting_Site_RequestType',
            'Put_Job_Posting_Site_ResponseType' => '\\StructType\\Put_Job_Posting_Site_ResponseType',
            'Job_Posting_Site_Detail_DataType' => '\\StructType\\Job_Posting_Site_Detail_DataType',
            'Application_Personal_Information_DataType' => '\\StructType\\Application_Personal_Information_DataType',
            'Post_Job_Sub_Business_ProcessType' => '\\StructType\\Post_Job_Sub_Business_ProcessType',
            'Unpost_Job_Sub_Business_ProcessType' => '\\StructType\\Unpost_Job_Sub_Business_ProcessType',
            'Put_Candidate_Photo_RequestType' => '\\StructType\\Put_Candidate_Photo_RequestType',
            'Put_Candidate_Photos_ResponseType' => '\\StructType\\Put_Candidate_Photos_ResponseType',
            'Get_Candidate_Photos_RequestType' => '\\StructType\\Get_Candidate_Photos_RequestType',
            'Get_Candidate_Photos_ResponseType' => '\\StructType\\Get_Candidate_Photos_ResponseType',
            'Candidate_Photos_Response_DataType' => '\\StructType\\Candidate_Photos_Response_DataType',
            'Candidate_PhotoType' => '\\StructType\\Candidate_PhotoType',
            'Background_Check_Package_DataType' => '\\StructType\\Background_Check_Package_DataType',
            'Put_Background_Check_Package_RequestType' => '\\StructType\\Put_Background_Check_Package_RequestType',
            'Put_Background_Check_Package_ResponseType' => '\\StructType\\Put_Background_Check_Package_ResponseType',
            'Background_Check_Package_Request_ReferencesType' => '\\StructType\\Background_Check_Package_Request_ReferencesType',
            'Background_Check_Package_Response_GroupType' => '\\StructType\\Background_Check_Package_Response_GroupType',
            'Get_Background_Check_Packages_RequestType' => '\\StructType\\Get_Background_Check_Packages_RequestType',
            'Background_Check_PackageType' => '\\StructType\\Background_Check_PackageType',
            'Background_Check_Package_Response_DataType' => '\\StructType\\Background_Check_Package_Response_DataType',
            'Get_Background_Check_Packages_ResponseType' => '\\StructType\\Get_Background_Check_Packages_ResponseType',
            'Background_Check_Package_Test_DataType' => '\\StructType\\Background_Check_Package_Test_DataType',
            'Background_Check_Package_TestType' => '\\StructType\\Background_Check_Package_TestType',
            'Manage_Job_Requisition_Freeze_RequestType' => '\\StructType\\Manage_Job_Requisition_Freeze_RequestType',
            'Manage_Job_Requisition_Freeze_DataType' => '\\StructType\\Manage_Job_Requisition_Freeze_DataType',
            'Manage_Job_Requisition_Freeze_ResponseType' => '\\StructType\\Manage_Job_Requisition_Freeze_ResponseType',
            'Recruiting_Prospect_DataType' => '\\StructType\\Recruiting_Prospect_DataType',
            'Package_Reference_DataType' => '\\StructType\\Package_Reference_DataType',
            'Put_Background_Check_RequestType' => '\\StructType\\Put_Background_Check_RequestType',
            'Put_Background_Check_ResponseType' => '\\StructType\\Put_Background_Check_ResponseType',
            'Test_Reference_DataType' => '\\StructType\\Test_Reference_DataType',
            'Background_Check_Request_CriteriaType' => '\\StructType\\Background_Check_Request_CriteriaType',
            'Background_Check_Request_ReferencesType' => '\\StructType\\Background_Check_Request_ReferencesType',
            'Get_Background_Check_RequestType' => '\\StructType\\Get_Background_Check_RequestType',
            'Get_Background_Check_ResponseType' => '\\StructType\\Get_Background_Check_ResponseType',
            'Background_Check_Response_DataType' => '\\StructType\\Background_Check_Response_DataType',
            'Background_Check_EventType' => '\\StructType\\Background_Check_EventType',
            'Assign_Employee_Collective_Agreement_Sub_Business_ProcessType' => '\\StructType\\Assign_Employee_Collective_Agreement_Sub_Business_ProcessType',
            'Collective_Agreement_Factor_Options_DataType' => '\\StructType\\Collective_Agreement_Factor_Options_DataType',
            'Collective_Agreement_Factor_1_DataType' => '\\StructType\\Collective_Agreement_Factor_1_DataType',
            'Collective_Agreement_Factor_2_DataType' => '\\StructType\\Collective_Agreement_Factor_2_DataType',
            'Collective_Agreement_Factor_3_DataType' => '\\StructType\\Collective_Agreement_Factor_3_DataType',
            'Collective_Agreement_Factor_4_DataType' => '\\StructType\\Collective_Agreement_Factor_4_DataType',
            'Collective_Agreement_Factor_5_DataType' => '\\StructType\\Collective_Agreement_Factor_5_DataType',
            'Job_Requisition_Questionnaire_DataType' => '\\StructType\\Job_Requisition_Questionnaire_DataType',
            'Candidate_Websites_DataType' => '\\StructType\\Candidate_Websites_DataType',
            'Candidate_Location_DataType' => '\\StructType\\Candidate_Location_DataType',
            'Assign_Employee_Collective_Agreement_Sub_DataType' => '\\StructType\\Assign_Employee_Collective_Agreement_Sub_DataType',
            'Job_Application_DataType' => '\\StructType\\Job_Application_DataType',
            'Job_Posting_Request_ReferencesType' => '\\StructType\\Job_Posting_Request_ReferencesType',
            'Job_Posting_Request_CriteriaType' => '\\StructType\\Job_Posting_Request_CriteriaType',
            'Job_Posting_Response_GroupType' => '\\StructType\\Job_Posting_Response_GroupType',
            'Get_Job_Postings_RequestType' => '\\StructType\\Get_Job_Postings_RequestType',
            'Job_PostingType' => '\\StructType\\Job_PostingType',
            'Job_Posting_Response_DataType' => '\\StructType\\Job_Posting_Response_DataType',
            'Get_Job_Postings_ResponseType' => '\\StructType\\Get_Job_Postings_ResponseType',
            'Job_Posting_Data_WWSType' => '\\StructType\\Job_Posting_Data_WWSType',
            'Compensatable_Default_Guidelines_DataType' => '\\StructType\\Compensatable_Default_Guidelines_DataType',
            'Job_Application_Attachment_DataType' => '\\StructType\\Job_Application_Attachment_DataType',
            'Job_Application_Attachment_ResponseType' => '\\StructType\\Job_Application_Attachment_ResponseType',
            'Business_Process_Attachment_DataType' => '\\StructType\\Business_Process_Attachment_DataType',
            'Specialty_Achievement_DataType' => '\\StructType\\Specialty_Achievement_DataType',
            'Dynamic_Business_Process_ParametersType' => '\\StructType\\Dynamic_Business_Process_ParametersType',
            'Background_Check_DataType' => '\\StructType\\Background_Check_DataType',
            'Questionnaire_Request_ReferencesType' => '\\StructType\\Questionnaire_Request_ReferencesType',
            'Questionnaire_Request_CriteriaType' => '\\StructType\\Questionnaire_Request_CriteriaType',
            'Get_Questionnaires_RequestType' => '\\StructType\\Get_Questionnaires_RequestType',
            'Questionnaire_DataType' => '\\StructType\\Questionnaire_DataType',
            'Questionnaire_Response_DataType' => '\\StructType\\Questionnaire_Response_DataType',
            'Get_Questionnaires_ResponseType' => '\\StructType\\Get_Questionnaires_ResponseType',
            'Questions_for_Questionnaire_DataType' => '\\StructType\\Questions_for_Questionnaire_DataType',
            'Multiple_Choice_Answer_Score_for_Questionnaire_DataType' => '\\StructType\\Multiple_Choice_Answer_Score_for_Questionnaire_DataType',
            'QuestionnaireType' => '\\StructType\\QuestionnaireType',
            'Assess_Candidate_Request_ReferencesType' => '\\StructType\\Assess_Candidate_Request_ReferencesType',
            'Assess_Candidate_Request_CriteriaType' => '\\StructType\\Assess_Candidate_Request_CriteriaType',
            'Get_Assess_Candidate_RequestType' => '\\StructType\\Get_Assess_Candidate_RequestType',
            'Assess_Candidate_Response_DataType' => '\\StructType\\Assess_Candidate_Response_DataType',
            'Get_Assess_Candidate_ResponseType' => '\\StructType\\Get_Assess_Candidate_ResponseType',
            'Recruiting_Assessment_DataType' => '\\StructType\\Recruiting_Assessment_DataType',
            'Recruiting_Assessment_Test_Result_DataType' => '\\StructType\\Recruiting_Assessment_Test_Result_DataType',
            'Assess_Candidate_RequestType' => '\\StructType\\Assess_Candidate_RequestType',
            'Assess_Candidate_ResponseType' => '\\StructType\\Assess_Candidate_ResponseType',
            'Candidate_CriteriaType' => '\\StructType\\Candidate_CriteriaType',
            'Assess_Candidate_Event_DataType' => '\\StructType\\Assess_Candidate_Event_DataType',
            'Job_Posting_Location_DataType' => '\\StructType\\Job_Posting_Location_DataType',
            'Job_Posting_Additional_Location_DataType' => '\\StructType\\Job_Posting_Additional_Location_DataType',
            'Assess_Candidate_EventType' => '\\StructType\\Assess_Candidate_EventType',
            'Create_Evergreen_Requisition_RequestType' => '\\StructType\\Create_Evergreen_Requisition_RequestType',
            'Create_Evergreen_Job_Requisition_DataType' => '\\StructType\\Create_Evergreen_Job_Requisition_DataType',
            'Create_Evergreen_Requisition_ResponseType' => '\\StructType\\Create_Evergreen_Requisition_ResponseType',
            'Evergreen_Job_Requisition_Data_for_Create_and_EditType' => '\\StructType\\Evergreen_Job_Requisition_Data_for_Create_and_EditType',
            'Evergreen_Job_Requisition_Request_ReferencesType' => '\\StructType\\Evergreen_Job_Requisition_Request_ReferencesType',
            'Evergreen_Job_Requisition_Request_CriteriaType' => '\\StructType\\Evergreen_Job_Requisition_Request_CriteriaType',
            'Evergreen_Job_Requisition_Response_GroupType' => '\\StructType\\Evergreen_Job_Requisition_Response_GroupType',
            'Get_Evergreen_Requisitions_RequestType' => '\\StructType\\Get_Evergreen_Requisitions_RequestType',
            'Get_Evergreen_Requisitions_ResponseType' => '\\StructType\\Get_Evergreen_Requisitions_ResponseType',
            'Evergreen_Job_Requisition_Response_DataType' => '\\StructType\\Evergreen_Job_Requisition_Response_DataType',
            'Evergreen_Job_RequisitionType' => '\\StructType\\Evergreen_Job_RequisitionType',
            'Evergreen_Job_Requisition_Data_2Type' => '\\StructType\\Evergreen_Job_Requisition_Data_2Type',
            'Edit_Evergreen_Requisition_RequestType' => '\\StructType\\Edit_Evergreen_Requisition_RequestType',
            'Edit_Evergreen_Requisition_DataType' => '\\StructType\\Edit_Evergreen_Requisition_DataType',
            'Edit_Evergreen_Requisition_Event_DataType' => '\\StructType\\Edit_Evergreen_Requisition_Event_DataType',
            'Edit_Evergreen_Requisition_ResponseType' => '\\StructType\\Edit_Evergreen_Requisition_ResponseType',
            'Role_Assignment_Effective_DataType' => '\\StructType\\Role_Assignment_Effective_DataType',
            'Skill_Qualification_ReplacementType' => '\\StructType\\Skill_Qualification_ReplacementType',
            'Skill_Qualification_Profile_Replacement_DataType' => '\\StructType\\Skill_Qualification_Profile_Replacement_DataType',
            'Skill_Profile_for_Job_DataType' => '\\StructType\\Skill_Profile_for_Job_DataType',
            'Skill_Profile_for_JobType' => '\\StructType\\Skill_Profile_for_JobType',
            'Close_Evergreen_Requisition_DataType' => '\\StructType\\Close_Evergreen_Requisition_DataType',
            'Close_Evergreen_Requisition_RequestType' => '\\StructType\\Close_Evergreen_Requisition_RequestType',
            'Close_Evergreen_Requisition_ResponseType' => '\\StructType\\Close_Evergreen_Requisition_ResponseType',
            'Relative_Name_DataType' => '\\StructType\\Relative_Name_DataType',
            'Move_Job_Requisition_DataType' => '\\StructType\\Move_Job_Requisition_DataType',
            'Move_Job_Requisition_RequestType' => '\\StructType\\Move_Job_Requisition_RequestType',
            'Move_Job_Requisition_ResponseType' => '\\StructType\\Move_Job_Requisition_ResponseType',
            'Effective_Dated_Web_Service_Additional_DataType' => '\\StructType\\Effective_Dated_Web_Service_Additional_DataType',
            'Edit_Position_Restrictions_Additional_Data_RequestType' => '\\StructType\\Edit_Position_Restrictions_Additional_Data_RequestType',
            'Edit_Position_Restrictions_Additional_Data_ResponseType' => '\\StructType\\Edit_Position_Restrictions_Additional_Data_ResponseType',
            'Edit_Job_Requisition_Additional_Data_RequestType' => '\\StructType\\Edit_Job_Requisition_Additional_Data_RequestType',
            'Edit_Job_Requisition_Additional_Data_ResponseType' => '\\StructType\\Edit_Job_Requisition_Additional_Data_ResponseType',
            'Candidate_Job_Application_DataType' => '\\StructType\\Candidate_Job_Application_DataType',
            'Job_Requisition_Custom_Object_DataType' => '\\StructType\\Job_Requisition_Custom_Object_DataType',
            'Position_Restrictions_Custom_Object_DataType' => '\\StructType\\Position_Restrictions_Custom_Object_DataType',
            'Recruiting_Agency_User_Request_ReferencesType' => '\\StructType\\Recruiting_Agency_User_Request_ReferencesType',
            'Recruiting_Agency_User_Response_GroupType' => '\\StructType\\Recruiting_Agency_User_Response_GroupType',
            'Get_Recruiting_Agency_Users_RequestType' => '\\StructType\\Get_Recruiting_Agency_Users_RequestType',
            'Recruiting_Agency_UserType' => '\\StructType\\Recruiting_Agency_UserType',
            'Recruiting_Agency_User_Response_DataType' => '\\StructType\\Recruiting_Agency_User_Response_DataType',
            'Get_Recruiting_Agency_Users_ResponseType' => '\\StructType\\Get_Recruiting_Agency_Users_ResponseType',
            'Recruiting_Agency_User_DataType' => '\\StructType\\Recruiting_Agency_User_DataType',
            'Put_Recruiting_Agency_User_RequestType' => '\\StructType\\Put_Recruiting_Agency_User_RequestType',
            'Put_Recruiting_Agency_User_ResponseType' => '\\StructType\\Put_Recruiting_Agency_User_ResponseType',
            'Recruiting_Agency_User_Attachment_DataType' => '\\StructType\\Recruiting_Agency_User_Attachment_DataType',
            'Move_Candidate_to_Linked_Job_Requisition_RequestType' => '\\StructType\\Move_Candidate_to_Linked_Job_Requisition_RequestType',
            'Move_Candidate_to_Linked_Job_Requisition_ResponseType' => '\\StructType\\Move_Candidate_to_Linked_Job_Requisition_ResponseType',
            'Put_Primary_Posting_RequestType' => '\\StructType\\Put_Primary_Posting_RequestType',
            'Put_Primary_Posting_ResponseType' => '\\StructType\\Put_Primary_Posting_ResponseType',
            'Move_Candidate_to_Linked_Evergreen_Requisition_RequestType' => '\\StructType\\Move_Candidate_to_Linked_Evergreen_Requisition_RequestType',
            'Move_Candidate_to_Linked_Evergreen_Requisition_ResponseType' => '\\StructType\\Move_Candidate_to_Linked_Evergreen_Requisition_ResponseType',
            'Prospect_Attachments_DataType' => '\\StructType\\Prospect_Attachments_DataType',
            'Custom_Organization_Assignment_DataType' => '\\StructType\\Custom_Organization_Assignment_DataType',
            'Job_Application_Request_ReferencesType' => '\\StructType\\Job_Application_Request_ReferencesType',
            'Job_Application_Request_CriteriaType' => '\\StructType\\Job_Application_Request_CriteriaType',
            'Job_Application_Response_GroupType' => '\\StructType\\Job_Application_Response_GroupType',
            'Get_Job_Application_Additional_Data_RequestType' => '\\StructType\\Get_Job_Application_Additional_Data_RequestType',
            'Job_ApplicationType' => '\\StructType\\Job_ApplicationType',
            'Job_Application_Additional_Data_Response_DataType' => '\\StructType\\Job_Application_Additional_Data_Response_DataType',
            'Get_Job_Application_Additional_Data_ResponseType' => '\\StructType\\Get_Job_Application_Additional_Data_ResponseType',
            'Non_Effective_Dated_Web_Service_Additional_DataType' => '\\StructType\\Non_Effective_Dated_Web_Service_Additional_DataType',
            'Job_Application_Custom_Object_DataType' => '\\StructType\\Job_Application_Custom_Object_DataType',
            'Put_Job_Application_Additional_Data_RequestType' => '\\StructType\\Put_Job_Application_Additional_Data_RequestType',
            'Put_Job_Application_Additional_Data_ResponseType' => '\\StructType\\Put_Job_Application_Additional_Data_ResponseType',
            'Candidate_Language_DataType' => '\\StructType\\Candidate_Language_DataType',
            'Candidate_Language_Skill_DataType' => '\\StructType\\Candidate_Language_Skill_DataType',
            'Recruiting_Agency_Request_ReferencesType' => '\\StructType\\Recruiting_Agency_Request_ReferencesType',
            'Recruiting_Agency_Request_CriteriaType' => '\\StructType\\Recruiting_Agency_Request_CriteriaType',
            'Get_Recruiting_Agencies_RequestType' => '\\StructType\\Get_Recruiting_Agencies_RequestType',
            'Recruiting_AgencyType' => '\\StructType\\Recruiting_AgencyType',
            'Recruiting_Agency_Response_DataType' => '\\StructType\\Recruiting_Agency_Response_DataType',
            'Get_Recruiting_Agencies_ResponseType' => '\\StructType\\Get_Recruiting_Agencies_ResponseType',
            'Recruiting_Agency_DataType' => '\\StructType\\Recruiting_Agency_DataType',
            'Recruiting_Agency_Attachment_DataType' => '\\StructType\\Recruiting_Agency_Attachment_DataType',
            'Recruiting_Agency_Career_Site_Configuration_DataType' => '\\StructType\\Recruiting_Agency_Career_Site_Configuration_DataType',
            'Put_Recruiting_Agency_RequestType' => '\\StructType\\Put_Recruiting_Agency_RequestType',
            'Put_Recruiting_Agency_ResponseType' => '\\StructType\\Put_Recruiting_Agency_ResponseType',
            'Questionnaire_Answer_DataType' => '\\StructType\\Questionnaire_Answer_DataType',
            'Multiple_Choice_Answer_DataType' => '\\StructType\\Multiple_Choice_Answer_DataType',
            'Questionnaires_Response_DataType' => '\\StructType\\Questionnaires_Response_DataType',
            'Candidate_Questionnaire_Response_DataType' => '\\StructType\\Candidate_Questionnaire_Response_DataType',
            'Submit_Recruiting_Agency_Candidate_RequestType' => '\\StructType\\Submit_Recruiting_Agency_Candidate_RequestType',
            'Submit_Recruiting_Agency_Candidate__ResponseType' => '\\StructType\\Submit_Recruiting_Agency_Candidate__ResponseType',
            'Recruiting_Agency_Candidate_Submission_DataType' => '\\StructType\\Recruiting_Agency_Candidate_Submission_DataType',
            'Recruiting_Agency_Candidate_Attachment_DataType' => '\\StructType\\Recruiting_Agency_Candidate_Attachment_DataType',
            'Requisition_Compensation_DataType' => '\\StructType\\Requisition_Compensation_DataType',
            'Request_Requisition_Compensation_Sub_ProcessType' => '\\StructType\\Request_Requisition_Compensation_Sub_ProcessType',
            'Move_Candidate_DataType' => '\\StructType\\Move_Candidate_DataType',
            'Move_Candidate_RequestType' => '\\StructType\\Move_Candidate_RequestType',
            'Move_Candidate_ResponseType' => '\\StructType\\Move_Candidate_ResponseType',
            'Move_Candidate_CriteriaType' => '\\StructType\\Move_Candidate_CriteriaType',
            'Person_Biographic_and_Demographic_Information_DataType' => '\\StructType\\Person_Biographic_and_Demographic_Information_DataType',
            'Candidate_Disability_Status_DataType' => '\\StructType\\Candidate_Disability_Status_DataType',
            'Candidate_Military_Service_Information_DataType' => '\\StructType\\Candidate_Military_Service_Information_DataType',
            'Candidate_Identification_DataType' => '\\StructType\\Candidate_Identification_DataType',
            'Get_Recruiting_Agency_Additional_Data_RequestType' => '\\StructType\\Get_Recruiting_Agency_Additional_Data_RequestType',
            'Get_Recruiting_Agency_Additional_Data_ResponseType' => '\\StructType\\Get_Recruiting_Agency_Additional_Data_ResponseType',
            'Recruiting_Agency_Additional_Data_Response_DataType' => '\\StructType\\Recruiting_Agency_Additional_Data_Response_DataType',
            'Recruiting_Agency_Custom_Object_DataType' => '\\StructType\\Recruiting_Agency_Custom_Object_DataType',
            'Put_Recruiting_Agency_Additional_Data_RequestType' => '\\StructType\\Put_Recruiting_Agency_Additional_Data_RequestType',
            'Put_Recruiting_Agency_Additional_Data_ResponseType' => '\\StructType\\Put_Recruiting_Agency_Additional_Data_ResponseType',
            'Recruiting_Agency_Additional_DataType' => '\\StructType\\Recruiting_Agency_Additional_DataType',
            'Award_and_Activity_Achievement_DataType' => '\\StructType\\Award_and_Activity_Achievement_DataType',
            'Award_and_ActivityType' => '\\StructType\\Award_and_ActivityType',
            'Job_Requisition_Interview_Team_Request_ReferencesType' => '\\StructType\\Job_Requisition_Interview_Team_Request_ReferencesType',
            'Job_Requisition_Interview_Team_Response_GroupType' => '\\StructType\\Job_Requisition_Interview_Team_Response_GroupType',
            'Get_Job_Requisition_Interview_Settings_RequestType' => '\\StructType\\Get_Job_Requisition_Interview_Settings_RequestType',
            'Job_Requisition_Interview_TeamType' => '\\StructType\\Job_Requisition_Interview_TeamType',
            'Job_Requisition_Interview_Team_Response_DataType' => '\\StructType\\Job_Requisition_Interview_Team_Response_DataType',
            'Get_Job_Requisition_Interview_Settings_ResponseType' => '\\StructType\\Get_Job_Requisition_Interview_Settings_ResponseType',
            'Job_Requisition_Interview_Team_DataType' => '\\StructType\\Job_Requisition_Interview_Team_DataType',
            'Job_Requisition_Interview_Team_Session_DataType' => '\\StructType\\Job_Requisition_Interview_Team_Session_DataType',
            'Put_Job_Requisition_Interview_Settings_RequestType' => '\\StructType\\Put_Job_Requisition_Interview_Settings_RequestType',
            'Put_Job_Requisition_Interview_Settings_ResponseType' => '\\StructType\\Put_Job_Requisition_Interview_Settings_ResponseType',
            'Job_Requisition_Interview_SessionType' => '\\StructType\\Job_Requisition_Interview_SessionType',
            'Interview_DataType' => '\\StructType\\Interview_DataType',
            'Put_Interview_RequestType' => '\\StructType\\Put_Interview_RequestType',
            'Put_Interview_ResponseType' => '\\StructType\\Put_Interview_ResponseType',
            'Interview_Session_Details_DataType' => '\\StructType\\Interview_Session_Details_DataType',
            'Interview_Session_DataType' => '\\StructType\\Interview_Session_DataType',
            'Interview_Request_ReferencesType' => '\\StructType\\Interview_Request_ReferencesType',
            'Interview_Response_GroupType' => '\\StructType\\Interview_Response_GroupType',
            'Get_Interviews_RequestType' => '\\StructType\\Get_Interviews_RequestType',
            'InterviewType' => '\\StructType\\InterviewType',
            'Interview_Response_DataType' => '\\StructType\\Interview_Response_DataType',
            'Get_Interviews_ResponseType' => '\\StructType\\Get_Interviews_ResponseType',
            'Interview_Request_CriteriaType' => '\\StructType\\Interview_Request_CriteriaType',
            'Proposed_Calculated_Plan_Assignment_DataType' => '\\StructType\\Proposed_Calculated_Plan_Assignment_DataType',
            'Proposed_Calculated_Plan_Assignment_Container_DataType' => '\\StructType\\Proposed_Calculated_Plan_Assignment_Container_DataType',
            'Organization_Assignments_for_Job_Requisition_DataType' => '\\StructType\\Organization_Assignments_for_Job_Requisition_DataType',
            'Evergreen_Job_Requisition_Organizations_Data_for_Business_ProcessType' => '\\StructType\\Evergreen_Job_Requisition_Organizations_Data_for_Business_ProcessType',
            'Recruiting_Agency_Payout_Terms_DataType' => '\\StructType\\Recruiting_Agency_Payout_Terms_DataType',
            'Salary_Over_the_Cap_Costing_Allocation_Detail_DataType' => '\\StructType\\Salary_Over_the_Cap_Costing_Allocation_Detail_DataType',
            'Referral_Candidate_Submission_DataType' => '\\StructType\\Referral_Candidate_Submission_DataType',
            'Refer_a_Candidate_RequestType' => '\\StructType\\Refer_a_Candidate_RequestType',
            'Refer_a_Candidate_ResponseType' => '\\StructType\\Refer_a_Candidate_ResponseType',
            'Referral_Details_DataType' => '\\StructType\\Referral_Details_DataType',
            'Refer_a_Candidate_Attachment_DataType' => '\\StructType\\Refer_a_Candidate_Attachment_DataType',
            'Job_Requisition_Assessment_DataType' => '\\StructType\\Job_Requisition_Assessment_DataType',
            'Inline_Assessment_DataType' => '\\StructType\\Inline_Assessment_DataType',
            'Employer_Notice_Period_DataType' => '\\StructType\\Employer_Notice_Period_DataType',
            'Employee_Notice_Period_DataType' => '\\StructType\\Employee_Notice_Period_DataType',
            'Override_Notice_Period_DataType' => '\\StructType\\Override_Notice_Period_DataType',
            'Candidate_Local_Name_Detail_DataType' => '\\StructType\\Candidate_Local_Name_Detail_DataType',
            'Interview_Feedback_DataType' => '\\StructType\\Interview_Feedback_DataType',
            'Put_Interview_Feedback_RequestType' => '\\StructType\\Put_Interview_Feedback_RequestType',
            'Put_Interview_Feedback_ResponseType' => '\\StructType\\Put_Interview_Feedback_ResponseType',
            'Interview_Feedback_Details_DataType' => '\\StructType\\Interview_Feedback_Details_DataType',
            'Interview_Feedback_DetailsType' => '\\StructType\\Interview_Feedback_DetailsType',
            'Interview_Feedback_Request_ReferencesType' => '\\StructType\\Interview_Feedback_Request_ReferencesType',
            'Interview_Feedback_Request_CriteriaType' => '\\StructType\\Interview_Feedback_Request_CriteriaType',
            'Interview_Feedback_Response_GroupType' => '\\StructType\\Interview_Feedback_Response_GroupType',
            'Get_Interview_Feedbacks_RequestType' => '\\StructType\\Get_Interview_Feedbacks_RequestType',
            'Interview_FeedbackType' => '\\StructType\\Interview_FeedbackType',
            'Interview_Feedback_Response_DataType' => '\\StructType\\Interview_Feedback_Response_DataType',
            'Get_Interview_Feedbacks_ResponseType' => '\\StructType\\Get_Interview_Feedbacks_ResponseType',
            'Competency_Assessment_DataType' => '\\StructType\\Competency_Assessment_DataType',
            'Edit_Notice_Periods_DataType' => '\\StructType\\Edit_Notice_Periods_DataType',
            'Edit_Notice_Periods_Sub_Business_ProcessType' => '\\StructType\\Edit_Notice_Periods_Sub_Business_ProcessType',
            'Applicant_Information_HVType' => '\\StructType\\Applicant_Information_HVType',
            'Import_Applicant_RequestType' => '\\StructType\\Import_Applicant_RequestType',
            'Put_Veteran_Status_ResponseType' => '\\StructType\\Put_Veteran_Status_ResponseType',
            'Veteran_StatusType' => '\\StructType\\Veteran_StatusType',
            'Veteran_Status_Response_DataType' => '\\StructType\\Veteran_Status_Response_DataType',
            'Veteran_Status_Request_ReferencesType' => '\\StructType\\Veteran_Status_Request_ReferencesType',
            'Put_Veteran_Status_RequestType' => '\\StructType\\Put_Veteran_Status_RequestType',
            'Get_Veteran_Statuses_ResponseType' => '\\StructType\\Get_Veteran_Statuses_ResponseType',
            'Veteran_Status_DataType' => '\\StructType\\Veteran_Status_DataType',
            'Get_Veteran_Statuses_RequestType' => '\\StructType\\Get_Veteran_Statuses_RequestType',
            'Veteran_Status_Request_CriteriaType' => '\\StructType\\Veteran_Status_Request_CriteriaType',
            'Put_Undo_Move_from_Hire_ResponseType' => '\\StructType\\Put_Undo_Move_from_Hire_ResponseType',
            'Put_Undo_Move_from_Hire_RequestType' => '\\StructType\\Put_Undo_Move_from_Hire_RequestType',
            'Questionnaire_Attachment_Answer_DataType' => '\\StructType\\Questionnaire_Attachment_Answer_DataType',
            'Recruiting_Self-Schedule_Calendar_Type_DataType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Type_DataType',
            'Recruiting_Self-Schedule_Calendar_Type_Request_CriteriaType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Type_Request_CriteriaType',
            'Recruiting_Self-Schedule_Calendar_Type_Response_DataType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Type_Response_DataType',
            'Recruiting_Self-Schedule_Calendar_Type_Request_ReferencesType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Type_Request_ReferencesType',
            'Recruiting_Self-Schedule_Calendar_TypeType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_TypeType',
            'Get_Recruiting_Self-Schedule_Calendar_Types_ResponseType' => '\\StructType\\Get_Recruiting_Self_Schedule_Calendar_Types_ResponseType',
            'Put_Recruiting_Self-Schedule_Calendar_Type_ResponseType' => '\\StructType\\Put_Recruiting_Self_Schedule_Calendar_Type_ResponseType',
            'Get_Recruiting_Self-Schedule_Calendar_Types_RequestType' => '\\StructType\\Get_Recruiting_Self_Schedule_Calendar_Types_RequestType',
            'Recruiting_Self-Schedule_Calendar_Type_Response_GroupType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Type_Response_GroupType',
            'Put_Recruiting_Self-Schedule_Calendar_Type_RequestType' => '\\StructType\\Put_Recruiting_Self_Schedule_Calendar_Type_RequestType',
            'Get_Assign_Recruiting_Self-Schedule_Calendars_RequestType' => '\\StructType\\Get_Assign_Recruiting_Self_Schedule_Calendars_RequestType',
            'Assign_Recruiting_Self-Schedule_Calendar_Request_ReferencesType' => '\\StructType\\Assign_Recruiting_Self_Schedule_Calendar_Request_ReferencesType',
            'Assign_Recruiting_Self-Schedule_Calendars_DataType' => '\\StructType\\Assign_Recruiting_Self_Schedule_Calendars_DataType',
            'Assign_Recruiting_Self-Schedule_CalendarType' => '\\StructType\\Assign_Recruiting_Self_Schedule_CalendarType',
            'Get_Assign_Recruiting_Self-Schedule_Calendars_ResponseType' => '\\StructType\\Get_Assign_Recruiting_Self_Schedule_Calendars_ResponseType',
            'Assign_Recruiting_Self-Schedule_Calendar_ResponseType' => '\\StructType\\Assign_Recruiting_Self_Schedule_Calendar_ResponseType',
            'Assign_Recruiting_Self-Schedule_Calendar_RequestType' => '\\StructType\\Assign_Recruiting_Self_Schedule_Calendar_RequestType',
            'Assign_Recruiting_Self-Schedule_Calendar_Response_DataType' => '\\StructType\\Assign_Recruiting_Self_Schedule_Calendar_Response_DataType',
            'Recruiting_Self-Schedule_Calendar_Response_DataType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Response_DataType',
            'Recruiting_Self-Schedule_CalendarType' => '\\StructType\\Recruiting_Self_Schedule_CalendarType',
            'Recruiting_Self-Schedule_Calendar_Request_ReferencesType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Request_ReferencesType',
            'Recruiting_Self-Schedule_Calendar_DataType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_DataType',
            'Get_Recruiting_Self-Schedule_Calendars_ResponseType' => '\\StructType\\Get_Recruiting_Self_Schedule_Calendars_ResponseType',
            'Get_Recruiting_Self-Schedule_Calendars_RequestType' => '\\StructType\\Get_Recruiting_Self_Schedule_Calendars_RequestType',
            'Recruiting_Self-Schedule_Calendar_Request_CriteriaType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Request_CriteriaType',
            'Recruiting_Self-Schedule_Calendar_Response_GroupType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_Response_GroupType',
            'Put_Recruiting_Self-Schedule_Calendar_RequestType' => '\\StructType\\Put_Recruiting_Self_Schedule_Calendar_RequestType',
            'Put_Recruiting_Self-Schedule_Calendar_ResponseType' => '\\StructType\\Put_Recruiting_Self_Schedule_Calendar_ResponseType',
            'Recruiting_Self-Service_Schedule_Assign_Role_DataType' => '\\StructType\\Recruiting_Self_Service_Schedule_Assign_Role_DataType',
            'Recruiting_Self-Service_Schedule_DataType' => '\\StructType\\Recruiting_Self_Service_Schedule_DataType',
            'Recruiting_Self-Service_Schedule_Excluded_Days_DataType' => '\\StructType\\Recruiting_Self_Service_Schedule_Excluded_Days_DataType',
            'Recruiting_Self-Service_Schedule_Excluded_DaysType' => '\\StructType\\Recruiting_Self_Service_Schedule_Excluded_DaysType',
            'Recruiting_Self-Service_ScheduleType' => '\\StructType\\Recruiting_Self_Service_ScheduleType',
            'Candidate_Pool_DataType' => '\\StructType\\Candidate_Pool_DataType',
            'Candidate_Pool_Membership_DataType' => '\\StructType\\Candidate_Pool_Membership_DataType',
            'Get_Recruiting_Assessment_Categories_RequestType' => '\\StructType\\Get_Recruiting_Assessment_Categories_RequestType',
            'Recruiting_Assessment_Category_Response_GroupType' => '\\StructType\\Recruiting_Assessment_Category_Response_GroupType',
            'Recruiting_Assessment_Category_DataType' => '\\StructType\\Recruiting_Assessment_Category_DataType',
            'Recruiting_Assessment_Category_Response_DataType' => '\\StructType\\Recruiting_Assessment_Category_Response_DataType',
            'Get_Recruiting_Assessment_Categories_ResponseType' => '\\StructType\\Get_Recruiting_Assessment_Categories_ResponseType',
            'Recruiting_Assessment_CategoryType' => '\\StructType\\Recruiting_Assessment_CategoryType',
            'Put_Recruiting_Assessment_Category_ResponseType' => '\\StructType\\Put_Recruiting_Assessment_Category_ResponseType',
            'Put_Recruiting_Assessment_Category_RequestType' => '\\StructType\\Put_Recruiting_Assessment_Category_RequestType',
            'Recruiting_Assessment_Category_Request_ReferencesType' => '\\StructType\\Recruiting_Assessment_Category_Request_ReferencesType',
            'Put_Recruiting_Assessment_Category_Security_Segment_RequestType' => '\\StructType\\Put_Recruiting_Assessment_Category_Security_Segment_RequestType',
            'Recruiting_Assessment_Category_Security_Segment_Request_CriteriaType' => '\\StructType\\Recruiting_Assessment_Category_Security_Segment_Request_CriteriaType',
            'Put_Recruiting_Assessment_Category_Security_Segment_ResponseType' => '\\StructType\\Put_Recruiting_Assessment_Category_Security_Segment_ResponseType',
            'Recruiting_Assessment_Category_Security_Segment_DataType' => '\\StructType\\Recruiting_Assessment_Category_Security_Segment_DataType',
            'Get_Recruiting_Assessment_Category_Security_Segments_ResponseType' => '\\StructType\\Get_Recruiting_Assessment_Category_Security_Segments_ResponseType',
            'Recruiting_Assessment_Category_Security_Segment_Response_DataType' => '\\StructType\\Recruiting_Assessment_Category_Security_Segment_Response_DataType',
            'Recruiting_Assessment_Category_Security_SegmentType' => '\\StructType\\Recruiting_Assessment_Category_Security_SegmentType',
            'Recruiting_Assessment_Category_Security_Segment_Response_GroupType' => '\\StructType\\Recruiting_Assessment_Category_Security_Segment_Response_GroupType',
            'Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType' => '\\StructType\\Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType',
            'Get_Recruiting_Assessment_Category_Security_Segments_RequestType' => '\\StructType\\Get_Recruiting_Assessment_Category_Security_Segments_RequestType',
            'Offer_ResponseType' => '\\StructType\\Offer_ResponseType',
            'Offer_DataType' => '\\StructType\\Offer_DataType',
            'Offer_Event_DataType' => '\\StructType\\Offer_Event_DataType',
            'Offer_RequestType' => '\\StructType\\Offer_RequestType',
            'Request_Stock_Offer_Sub_Business_ProcessType' => '\\StructType\\Request_Stock_Offer_Sub_Business_ProcessType',
            'Request_Stock_Grant_Offer_DataType' => '\\StructType\\Request_Stock_Grant_Offer_DataType',
            'Personal_Information_For_Country_DataType' => '\\StructType\\Personal_Information_For_Country_DataType',
            'Specialty_Achievement_Data_with_DatesType' => '\\StructType\\Specialty_Achievement_Data_with_DatesType',
            'Maintain_Candidate_List_Assignment_Response_DataType' => '\\StructType\\Maintain_Candidate_List_Assignment_Response_DataType',
            'Maintain_Candidate_List_Assignment_Subedit_DataType' => '\\StructType\\Maintain_Candidate_List_Assignment_Subedit_DataType',
            'Get_Maintain_Candidate_List_Assignment_RequestType' => '\\StructType\\Get_Maintain_Candidate_List_Assignment_RequestType',
            'Put_Maintain_Candidate_List_Assignment_RequestType' => '\\StructType\\Put_Maintain_Candidate_List_Assignment_RequestType',
            'Get_Maintain_Candidate_List_Assignment_ResponseType' => '\\StructType\\Get_Maintain_Candidate_List_Assignment_ResponseType',
            'Put_Maintain_Candidate_List_Assignment_ResponseType' => '\\StructType\\Put_Maintain_Candidate_List_Assignment_ResponseType',
            'Interview_Questionnaire_DataType' => '\\StructType\\Interview_Questionnaire_DataType',
            'Candidate_List_Assignment_Request_ReferencesType' => '\\StructType\\Candidate_List_Assignment_Request_ReferencesType',
            'Maintain_Candidate_List_Assignment_Request_CriteriaType' => '\\StructType\\Maintain_Candidate_List_Assignment_Request_CriteriaType',
            'Maintain_Candidate_List_Assignment_DataType' => '\\StructType\\Maintain_Candidate_List_Assignment_DataType',
            'Maintain_Candidate_List_Assignment_Get_DataType' => '\\StructType\\Maintain_Candidate_List_Assignment_Get_DataType',
            'Maintain_Candidate_List_Assignment_Response_GroupType' => '\\StructType\\Maintain_Candidate_List_Assignment_Response_GroupType',
            'Invalid_Reference_ID_DataType' => '\\StructType\\Invalid_Reference_ID_DataType',
            'Invalid_Reference_ID_ResponseType' => '\\StructType\\Invalid_Reference_ID_ResponseType',
            'Candidate_Legal_Name_DataType' => '\\StructType\\Candidate_Legal_Name_DataType',
            'Candidate_Preferred_Name_DataType' => '\\StructType\\Candidate_Preferred_Name_DataType',
            'Candidate_Name_Detail_DataType' => '\\StructType\\Candidate_Name_Detail_DataType',
            'Personal_Information_Common_DataType' => '\\StructType\\Personal_Information_Common_DataType',
            'Country_Personal_Information_DataType' => '\\StructType\\Country_Personal_Information_DataType',
            'Primary_Buttons_DataType' => '\\StructType\\Primary_Buttons_DataType',
            'Brand_Image_DataType' => '\\StructType\\Brand_Image_DataType',
            'Brand_DataType' => '\\StructType\\Brand_DataType',
            'Brand_General_Settings_DataType' => '\\StructType\\Brand_General_Settings_DataType',
            'Button_DataType' => '\\StructType\\Button_DataType',
            'Secondary_Buttons_DataType' => '\\StructType\\Secondary_Buttons_DataType',
            'Put_Site_Brand_ResponseType' => '\\StructType\\Put_Site_Brand_ResponseType',
            'Image_Banner_DataType' => '\\StructType\\Image_Banner_DataType',
            'Put_Site_Brand_RequestType' => '\\StructType\\Put_Site_Brand_RequestType',
            'Header_DataType' => '\\StructType\\Header_DataType',
            'Employment_Agreement_ResponseType' => '\\StructType\\Employment_Agreement_ResponseType',
            'Employment_Agreement_DataType' => '\\StructType\\Employment_Agreement_DataType',
            'Employment_Agreement_RequestType' => '\\StructType\\Employment_Agreement_RequestType',
            'Candidate_Certification_DataType' => '\\StructType\\Candidate_Certification_DataType',
            'Candidate_Specialty_Achievement_DataType' => '\\StructType\\Candidate_Specialty_Achievement_DataType',
            'Candidate_Certification_Skill_DataType' => '\\StructType\\Candidate_Certification_Skill_DataType',
            'Pre-Hire_Probation_Period_Length_DataType' => '\\StructType\\Pre_Hire_Probation_Period_Length_DataType',
            'Pre-Hire_Probation_Period_Sub_Business_ProcessType' => '\\StructType\\Pre_Hire_Probation_Period_Sub_Business_ProcessType',
            'Brand_Request_ReferencesType' => '\\StructType\\Brand_Request_ReferencesType',
            'BrandType' => '\\StructType\\BrandType',
            'Get_Site_Brands_ResponseType' => '\\StructType\\Get_Site_Brands_ResponseType',
            'Get_Site_Brands_RequestType' => '\\StructType\\Get_Site_Brands_RequestType',
            'Brand_Response_GroupType' => '\\StructType\\Brand_Response_GroupType',
            'Brand_Response_DataType' => '\\StructType\\Brand_Response_DataType',
            'Brand_Request_CriteriaType' => '\\StructType\\Brand_Request_CriteriaType',
            'Pre-Hire_Contract_Details_Sub_Business_ProcessType' => '\\StructType\\Pre_Hire_Contract_Details_Sub_Business_ProcessType',
            'Pre-Hire_Contract_Details_DataType' => '\\StructType\\Pre_Hire_Contract_Details_DataType',
            'Additional_Component_DataType' => '\\StructType\\Additional_Component_DataType',
            'Progress_Bar_DataType' => '\\StructType\\Progress_Bar_DataType',
            'Pre-Hire_Probation_Period_Review_LengthType' => '\\StructType\\Pre_Hire_Probation_Period_Review_LengthType',
            'Pre-Hire_Probation_Review_DataType' => '\\StructType\\Pre_Hire_Probation_Review_DataType',
            'Form_Fields_DataType' => '\\StructType\\Form_Fields_DataType',
            'Put_Job_Application_Template_Translation_ResponseType' => '\\StructType\\Put_Job_Application_Template_Translation_ResponseType',
            'Job_Application_Template_Request_ReferenceType' => '\\StructType\\Job_Application_Template_Request_ReferenceType',
            'Job_Application_Template_Translation_Response_DataType' => '\\StructType\\Job_Application_Template_Translation_Response_DataType',
            'Job_Application_Template_TranslationType' => '\\StructType\\Job_Application_Template_TranslationType',
            'Get_Job_Application_Template_Translation_RequestType' => '\\StructType\\Get_Job_Application_Template_Translation_RequestType',
            'Job_Application_Template_Translation_Request_CriteriaType' => '\\StructType\\Job_Application_Template_Translation_Request_CriteriaType',
            'Job_Application_Template_Translation_DataType' => '\\StructType\\Job_Application_Template_Translation_DataType',
            'Put_Job_Application_Template_Translation_RequestType' => '\\StructType\\Put_Job_Application_Template_Translation_RequestType',
            'Translated_Configurable_Fields_for_Job_Application_TemplateType' => '\\StructType\\Translated_Configurable_Fields_for_Job_Application_TemplateType',
            'Translated_Configurable_Field_DataType' => '\\StructType\\Translated_Configurable_Field_DataType',
            'Get_Job_Application_Template_Translation_ResponseType' => '\\StructType\\Get_Job_Application_Template_Translation_ResponseType',
            'Education_Attachment_DataType' => '\\StructType\\Education_Attachment_DataType',
            'Referral_Ownership_Details_DataType' => '\\StructType\\Referral_Ownership_Details_DataType',
            'Referral_DataType' => '\\StructType\\Referral_DataType',
            'Masked_Recruiting_Configuration_Request_ReferencesType' => '\\StructType\\Masked_Recruiting_Configuration_Request_ReferencesType',
            'Masked_Recruiting_Configuration_DataType' => '\\StructType\\Masked_Recruiting_Configuration_DataType',
            'Put_Masked_Recruiting_Configuration_ResponseType' => '\\StructType\\Put_Masked_Recruiting_Configuration_ResponseType',
            'Masked_Recruiting_ConfigurationType' => '\\StructType\\Masked_Recruiting_ConfigurationType',
            'Masked_Configuration_Item_DataType' => '\\StructType\\Masked_Configuration_Item_DataType',
            'Get_Masked_Recruiting_Configurations_ResponseType' => '\\StructType\\Get_Masked_Recruiting_Configurations_ResponseType',
            'Get_Masked_Recruiting_Configurations_RequestType' => '\\StructType\\Get_Masked_Recruiting_Configurations_RequestType',
            'Put_Masked_Recruiting_Configuration_RequestType' => '\\StructType\\Put_Masked_Recruiting_Configuration_RequestType',
            'Masked_Recruiting_Configuration_Response_DataType' => '\\StructType\\Masked_Recruiting_Configuration_Response_DataType',
            'Job_Requisition_Interview_Settings_DataType' => '\\StructType\\Job_Requisition_Interview_Settings_DataType',
            'Job_Requisition_Recommend_Interview_Settings_DataType' => '\\StructType\\Job_Requisition_Recommend_Interview_Settings_DataType',
            'Masked_Job_Requisition_Default_DataType' => '\\StructType\\Masked_Job_Requisition_Default_DataType',
            'Job_Requisition_Masking_Rule_Configuration_DataType' => '\\StructType\\Job_Requisition_Masking_Rule_Configuration_DataType',
            'Job_Requisition_Masking_Rule_Configuration_Request_ReferenceType' => '\\StructType\\Job_Requisition_Masking_Rule_Configuration_Request_ReferenceType',
            'Put_Masked_Job_Requisition_Default_ResponseType' => '\\StructType\\Put_Masked_Job_Requisition_Default_ResponseType',
            'Put_Masked_Job_Requisition_Default_RequestType' => '\\StructType\\Put_Masked_Job_Requisition_Default_RequestType',
            'Job_Requisition_Masking_Rule_ConfigurationType' => '\\StructType\\Job_Requisition_Masking_Rule_ConfigurationType',
            'Get_Masked_Job_Requisition_Defaults_RequestType' => '\\StructType\\Get_Masked_Job_Requisition_Defaults_RequestType',
            'Get_Masked_Job_Requisition_Defaults_ResponseType' => '\\StructType\\Get_Masked_Job_Requisition_Defaults_ResponseType',
            'Job_Requisition_Masking_Rule_Configuration_Response_DataType' => '\\StructType\\Job_Requisition_Masking_Rule_Configuration_Response_DataType',
            'Candidate_Reference_CriteriaType' => '\\StructType\\Candidate_Reference_CriteriaType',
            'Referee_Reference_DataType' => '\\StructType\\Referee_Reference_DataType',
            'Put_Referee_ResponseType' => '\\StructType\\Put_Referee_ResponseType',
            'Get_Referees_RequestType' => '\\StructType\\Get_Referees_RequestType',
            'Referee_Response_DataType' => '\\StructType\\Referee_Response_DataType',
            'Put_Referee_RequestType' => '\\StructType\\Put_Referee_RequestType',
            'Referee_Details_DataType' => '\\StructType\\Referee_Details_DataType',
            'RefereeType' => '\\StructType\\RefereeType',
            'Get_Referees_ResponseType' => '\\StructType\\Get_Referees_ResponseType',
            'Referee_Request_ReferencesType' => '\\StructType\\Referee_Request_ReferencesType',
            'Referee_Request_CriteriaType' => '\\StructType\\Referee_Request_CriteriaType',
            'Referee_Phone_DataType' => '\\StructType\\Referee_Phone_DataType',
            'Referee_DataType' => '\\StructType\\Referee_DataType',
            'Recruiting_Self-Service_Schedule_Time_Block_ContainerType' => '\\StructType\\Recruiting_Self_Service_Schedule_Time_Block_ContainerType',
            'Recruiting_Self-Service_Schedule_Time_Block_Container_DataType' => '\\StructType\\Recruiting_Self_Service_Schedule_Time_Block_Container_DataType',
            'Get_External_Reference_ResponseType' => '\\StructType\\Get_External_Reference_ResponseType',
            'External_Reference_Response_DataType' => '\\StructType\\External_Reference_Response_DataType',
            'Reference_Participant_Detail_Event_DataType' => '\\StructType\\Reference_Participant_Detail_Event_DataType',
            'External_ReferenceType' => '\\StructType\\External_ReferenceType',
            'Get_External_Reference_RequestType' => '\\StructType\\Get_External_Reference_RequestType',
            'External_Reference_Request_CriteriaType' => '\\StructType\\External_Reference_Request_CriteriaType',
            'Put_External_Reference_ResponseType' => '\\StructType\\Put_External_Reference_ResponseType',
            'Put_External_Reference_RequestType' => '\\StructType\\Put_External_Reference_RequestType',
            'External_Reference_DataType' => '\\StructType\\External_Reference_DataType',
            'External_Reference_Request_ReferencesType' => '\\StructType\\External_Reference_Request_ReferencesType',
            'Interviewer_DataType' => '\\StructType\\Interviewer_DataType',
            'Web_Conference_Interview_DataType' => '\\StructType\\Web_Conference_Interview_DataType',
            'Get_Web_Conference_Interview_Data_ResponseType' => '\\StructType\\Get_Web_Conference_Interview_Data_ResponseType',
            'Web_Conference_Interview_Data_Response_DataType' => '\\StructType\\Web_Conference_Interview_Data_Response_DataType',
            'Web_Conference_Interview_Data_Request_ReferencesType' => '\\StructType\\Web_Conference_Interview_Data_Request_ReferencesType',
            'Web_Conference_Interview_Session_DataType' => '\\StructType\\Web_Conference_Interview_Session_DataType',
            'Interview_Room_DataType' => '\\StructType\\Interview_Room_DataType',
            'Get_Web_Conference_Interview_Data_RequestType' => '\\StructType\\Get_Web_Conference_Interview_Data_RequestType',
            'Web_Conference_InterviewType' => '\\StructType\\Web_Conference_InterviewType',
            'Put_Web_Conference_Interview_Data_RequestType' => '\\StructType\\Put_Web_Conference_Interview_Data_RequestType',
            'Put_Web_Conference_Interview_Data_ResponseType' => '\\StructType\\Put_Web_Conference_Interview_Data_ResponseType',
            'Notification_Channel_MessageType' => '\\StructType\\Notification_Channel_MessageType',
            'Candidate_Reminder_Settings_DataType' => '\\StructType\\Candidate_Reminder_Settings_DataType',
            'Working_Hours_Details_DataType' => '\\StructType\\Working_Hours_Details_DataType',
            'Contextually_Secured_Organization_Request_ReferencesType' => '\\StructType\\Contextually_Secured_Organization_Request_ReferencesType',
            'RoleObjectIDType' => '\\StructType\\RoleObjectIDType',
            'Process-maintained_RoleObjectIDType' => '\\StructType\\Process_maintained_RoleObjectIDType',
            'Additional_Name_TypeObjectIDType' => '\\StructType\\Additional_Name_TypeObjectIDType',
            'Military_StatusObjectIDType' => '\\StructType\\Military_StatusObjectIDType',
            'Citizenship_StatusObjectIDType' => '\\StructType\\Citizenship_StatusObjectIDType',
            'AuthorityObjectIDType' => '\\StructType\\AuthorityObjectIDType',
            'LocationObjectIDType' => '\\StructType\\LocationObjectIDType',
            'Job_ProfileObjectIDType' => '\\StructType\\Job_ProfileObjectIDType',
            'OrganizationObjectIDType' => '\\StructType\\OrganizationObjectIDType',
            'Organization_TypeObjectIDType' => '\\StructType\\Organization_TypeObjectIDType',
            'Organization_SubtypeObjectIDType' => '\\StructType\\Organization_SubtypeObjectIDType',
            'Language_ProficiencyObjectIDType' => '\\StructType\\Language_ProficiencyObjectIDType',
            'LanguageObjectIDType' => '\\StructType\\LanguageObjectIDType',
            'EthnicityObjectIDType' => '\\StructType\\EthnicityObjectIDType',
            'Marital_StatusObjectIDType' => '\\StructType\\Marital_StatusObjectIDType',
            'GenderObjectIDType' => '\\StructType\\GenderObjectIDType',
            'Instant_Messenger_TypeObjectIDType' => '\\StructType\\Instant_Messenger_TypeObjectIDType',
            'Assignable_RoleObjectIDType' => '\\StructType\\Assignable_RoleObjectIDType',
            'Job_FamilyObjectIDType' => '\\StructType\\Job_FamilyObjectIDType',
            'WorkerObjectIDType' => '\\StructType\\WorkerObjectIDType',
            'Worker_TypeObjectIDType' => '\\StructType\\Worker_TypeObjectIDType',
            'Position_Time_TypeObjectIDType' => '\\StructType\\Position_Time_TypeObjectIDType',
            'Organization_OwnerObjectIDType' => '\\StructType\\Organization_OwnerObjectIDType',
            'Language_Ability_TypeObjectIDType' => '\\StructType\\Language_Ability_TypeObjectIDType',
            'ApplicantObjectIDType' => '\\StructType\\ApplicantObjectIDType',
            'DegreeObjectIDType' => '\\StructType\\DegreeObjectIDType',
            'Field_of_StudyObjectIDType' => '\\StructType\\Field_of_StudyObjectIDType',
            'School_TypeObjectIDType' => '\\StructType\\School_TypeObjectIDType',
            'Compensation_GradeObjectIDType' => '\\StructType\\Compensation_GradeObjectIDType',
            'Compensation_Grade_ProfileObjectIDType' => '\\StructType\\Compensation_Grade_ProfileObjectIDType',
            'Bonus_PlanObjectIDType' => '\\StructType\\Bonus_PlanObjectIDType',
            'Salary_Pay_PlanObjectIDType' => '\\StructType\\Salary_Pay_PlanObjectIDType',
            'FrequencyObjectIDType' => '\\StructType\\FrequencyObjectIDType',
            'Compensation_PackageObjectIDType' => '\\StructType\\Compensation_PackageObjectIDType',
            'Management_LevelObjectIDType' => '\\StructType\\Management_LevelObjectIDType',
            'Applicant_SourceObjectIDType' => '\\StructType\\Applicant_SourceObjectIDType',
            'EventObjectIDType' => '\\StructType\\EventObjectIDType',
            'License_IdentifierObjectIDType' => '\\StructType\\License_IdentifierObjectIDType',
            'Visa_ID_TypeObjectIDType' => '\\StructType\\Visa_ID_TypeObjectIDType',
            'Custom_ID_TypeObjectIDType' => '\\StructType\\Custom_ID_TypeObjectIDType',
            'Work_Experience_QualificationObjectIDType' => '\\StructType\\Work_Experience_QualificationObjectIDType',
            'Work_Experience_RatingObjectIDType' => '\\StructType\\Work_Experience_RatingObjectIDType',
            'Proficiency_RatingObjectIDType' => '\\StructType\\Proficiency_RatingObjectIDType',
            'CompetencyObjectIDType' => '\\StructType\\CompetencyObjectIDType',
            'Proficiency_Rating_BehaviorObjectIDType' => '\\StructType\\Proficiency_Rating_BehaviorObjectIDType',
            'Training_TypeObjectIDType' => '\\StructType\\Training_TypeObjectIDType',
            'Event_Classification_SubcategoryObjectIDType' => '\\StructType\\Event_Classification_SubcategoryObjectIDType',
            'Talent_Qualification_EnabledObjectIDType' => '\\StructType\\Talent_Qualification_EnabledObjectIDType',
            'Workflow_StepObjectIDType' => '\\StructType\\Workflow_StepObjectIDType',
            'Spend_CategoryObjectIDType' => '\\StructType\\Spend_CategoryObjectIDType',
            'One-Time_Payment_PlanObjectIDType' => '\\StructType\\One_Time_Payment_PlanObjectIDType',
            'Mime_TypeObjectIDType' => '\\StructType\\Mime_TypeObjectIDType',
            'External_URLObjectIDType' => '\\StructType\\External_URLObjectIDType',
            'Business_Process_TypeObjectIDType' => '\\StructType\\Business_Process_TypeObjectIDType',
            'Audited_Accounting_WorktagObjectIDType' => '\\StructType\\Audited_Accounting_WorktagObjectIDType',
            'Phone_Device_TypeObjectIDType' => '\\StructType\\Phone_Device_TypeObjectIDType',
            'Applicant_ResumeObjectIDType' => '\\StructType\\Applicant_ResumeObjectIDType',
            'Worker_EventObjectIDType' => '\\StructType\\Worker_EventObjectIDType',
            'Position_Worker_TypeObjectIDType' => '\\StructType\\Position_Worker_TypeObjectIDType',
            'Commission_PlanObjectIDType' => '\\StructType\\Commission_PlanObjectIDType',
            'Earning__All_ObjectIDType' => '\\StructType\\Earning__All_ObjectIDType',
            'SupplierObjectIDType' => '\\StructType\\SupplierObjectIDType',
            'User_LanguageObjectIDType' => '\\StructType\\User_LanguageObjectIDType',
            'Communication_Usage_TypeObjectIDType' => '\\StructType\\Communication_Usage_TypeObjectIDType',
            'Communication_Usage_BehaviorObjectIDType' => '\\StructType\\Communication_Usage_BehaviorObjectIDType',
            'CountryObjectIDType' => '\\StructType\\CountryObjectIDType',
            'Country_RegionObjectIDType' => '\\StructType\\Country_RegionObjectIDType',
            'Country_Phone_CodeObjectIDType' => '\\StructType\\Country_Phone_CodeObjectIDType',
            'Country_Predefined_Person_Name_Component_ValueObjectIDType' => '\\StructType\\Country_Predefined_Person_Name_Component_ValueObjectIDType',
            'CurrencyObjectIDType' => '\\StructType\\CurrencyObjectIDType',
            'Compensation_StepObjectIDType' => '\\StructType\\Compensation_StepObjectIDType',
            'Condition_RuleObjectIDType' => '\\StructType\\Condition_RuleObjectIDType',
            'DisabilityObjectIDType' => '\\StructType\\DisabilityObjectIDType',
            'Pay_GroupObjectIDType' => '\\StructType\\Pay_GroupObjectIDType',
            'Allowance_Unit_PlanObjectIDType' => '\\StructType\\Allowance_Unit_PlanObjectIDType',
            'Salary_Unit_PlanObjectIDType' => '\\StructType\\Salary_Unit_PlanObjectIDType',
            'Allowance_Value_PlanObjectIDType' => '\\StructType\\Allowance_Value_PlanObjectIDType',
            'Day_of_the_WeekObjectIDType' => '\\StructType\\Day_of_the_WeekObjectIDType',
            'Day_of_the_MonthObjectIDType' => '\\StructType\\Day_of_the_MonthObjectIDType',
            'MonthObjectIDType' => '\\StructType\\MonthObjectIDType',
            'Tenanted_Payroll_WorktagObjectIDType' => '\\StructType\\Tenanted_Payroll_WorktagObjectIDType',
            'Location_ContextObjectIDType' => '\\StructType\\Location_ContextObjectIDType',
            'ReligionObjectIDType' => '\\StructType\\ReligionObjectIDType',
            'Supervisory_OrganizationObjectIDType' => '\\StructType\\Supervisory_OrganizationObjectIDType',
            'CompanyObjectIDType' => '\\StructType\\CompanyObjectIDType',
            'Cost_CenterObjectIDType' => '\\StructType\\Cost_CenterObjectIDType',
            'RegionObjectIDType' => '\\StructType\\RegionObjectIDType',
            'Custom_OrganizationObjectIDType' => '\\StructType\\Custom_OrganizationObjectIDType',
            'Time_ZoneObjectIDType' => '\\StructType\\Time_ZoneObjectIDType',
            'Twenty_Four_Hour_TimeObjectIDType' => '\\StructType\\Twenty_Four_Hour_TimeObjectIDType',
            'Transaction_Log_TypeObjectIDType' => '\\StructType\\Transaction_Log_TypeObjectIDType',
            'SubscriberObjectIDType' => '\\StructType\\SubscriberObjectIDType',
            'Job_CategoryObjectIDType' => '\\StructType\\Job_CategoryObjectIDType',
            'Work_ShiftObjectIDType' => '\\StructType\\Work_ShiftObjectIDType',
            'Worker_DocumentObjectIDType' => '\\StructType\\Worker_DocumentObjectIDType',
            'National_ID_TypeObjectIDType' => '\\StructType\\National_ID_TypeObjectIDType',
            'Unique_IdentifierObjectIDType' => '\\StructType\\Unique_IdentifierObjectIDType',
            'Country_SubregionObjectIDType' => '\\StructType\\Country_SubregionObjectIDType',
            'Hukou_TypeObjectIDType' => '\\StructType\\Hukou_TypeObjectIDType',
            'External_Field_and_Parameter_Initialization_ProviderObjectIDType' => '\\StructType\\External_Field_and_Parameter_Initialization_ProviderObjectIDType',
            'Position_ElementObjectIDType' => '\\StructType\\Position_ElementObjectIDType',
            'Employee_Contract_TypeObjectIDType' => '\\StructType\\Employee_Contract_TypeObjectIDType',
            'FundObjectIDType' => '\\StructType\\FundObjectIDType',
            'Integration_Document_FieldObjectIDType' => '\\StructType\\Integration_Document_FieldObjectIDType',
            'Certification_QualificationObjectIDType' => '\\StructType\\Certification_QualificationObjectIDType',
            'AwardObjectIDType' => '\\StructType\\AwardObjectIDType',
            'Professional_Affiliation_QualificationObjectIDType' => '\\StructType\\Professional_Affiliation_QualificationObjectIDType',
            'TrainingObjectIDType' => '\\StructType\\TrainingObjectIDType',
            'Role_AssignerObjectIDType' => '\\StructType\\Role_AssignerObjectIDType',
            'Education_QualificationObjectIDType' => '\\StructType\\Education_QualificationObjectIDType',
            'Internal_Project_ExperienceObjectIDType' => '\\StructType\\Internal_Project_ExperienceObjectIDType',
            'Job_History_QualificationObjectIDType' => '\\StructType\\Job_History_QualificationObjectIDType',
            'PositionObjectIDType' => '\\StructType\\PositionObjectIDType',
            'Position_GroupObjectIDType' => '\\StructType\\Position_GroupObjectIDType',
            'Position_RestrictionsObjectIDType' => '\\StructType\\Position_RestrictionsObjectIDType',
            'Difficulty_to_FillObjectIDType' => '\\StructType\\Difficulty_to_FillObjectIDType',
            'Stock_PlanObjectIDType' => '\\StructType\\Stock_PlanObjectIDType',
            'SchoolObjectIDType' => '\\StructType\\SchoolObjectIDType',
            'CertificationObjectIDType' => '\\StructType\\CertificationObjectIDType',
            'Job_RequisitionObjectIDType' => '\\StructType\\Job_RequisitionObjectIDType',
            'Document_Category__All_ObjectIDType' => '\\StructType\\Document_Category__All_ObjectIDType',
            'Role-Based_Security_Group__Unconstrained_ObjectIDType' => '\\StructType\\Role_Based_Security_Group__Unconstrained_ObjectIDType',
            'Degree_CompletedObjectIDType' => '\\StructType\\Degree_CompletedObjectIDType',
            'Job_Requisition_StatusObjectIDType' => '\\StructType\\Job_Requisition_StatusObjectIDType',
            'UnionObjectIDType' => '\\StructType\\UnionObjectIDType',
            'Recruiting_InstructionObjectIDType' => '\\StructType\\Recruiting_InstructionObjectIDType',
            'ProgramObjectIDType' => '\\StructType\\ProgramObjectIDType',
            'GrantObjectIDType' => '\\StructType\\GrantObjectIDType',
            'Business_UnitObjectIDType' => '\\StructType\\Business_UnitObjectIDType',
            'Social_Network_TypeObjectIDType' => '\\StructType\\Social_Network_TypeObjectIDType',
            'Common_Boolean_EnumerationObjectIDType' => '\\StructType\\Common_Boolean_EnumerationObjectIDType',
            'Government_ID_Type__All_ObjectIDType' => '\\StructType\\Government_ID_Type__All_ObjectIDType',
            'License_ID_Type__All_ObjectIDType' => '\\StructType\\License_ID_Type__All_ObjectIDType',
            'Passport_ID_Type__All_ObjectIDType' => '\\StructType\\Passport_ID_Type__All_ObjectIDType',
            'Costing_Allocation_LevelObjectIDType' => '\\StructType\\Costing_Allocation_LevelObjectIDType',
            'Period_Salary_PlanObjectIDType' => '\\StructType\\Period_Salary_PlanObjectIDType',
            'Compensation_PeriodObjectIDType' => '\\StructType\\Compensation_PeriodObjectIDType',
            'Background_Check_EventObjectIDType' => '\\StructType\\Background_Check_EventObjectIDType',
            'Background_Check_StatusObjectIDType' => '\\StructType\\Background_Check_StatusObjectIDType',
            'Maintained_SkillObjectIDType' => '\\StructType\\Maintained_SkillObjectIDType',
            'Job_History_CompanyObjectIDType' => '\\StructType\\Job_History_CompanyObjectIDType',
            'Political_AffiliationObjectIDType' => '\\StructType\\Political_AffiliationObjectIDType',
            'GiftObjectIDType' => '\\StructType\\GiftObjectIDType',
            'RoleeObjectIDType' => '\\StructType\\RoleeObjectIDType',
            'Address_ReferenceObjectIDType' => '\\StructType\\Address_ReferenceObjectIDType',
            'CandidateObjectIDType' => '\\StructType\\CandidateObjectIDType',
            'Job_ApplicationObjectIDType' => '\\StructType\\Job_ApplicationObjectIDType',
            'Resume_AttachmentObjectIDType' => '\\StructType\\Resume_AttachmentObjectIDType',
            'Employee_Contract_ReasonObjectIDType' => '\\StructType\\Employee_Contract_ReasonObjectIDType',
            'Collective_AgreementObjectIDType' => '\\StructType\\Collective_AgreementObjectIDType',
            'Recruiting_Stage__Workday_Owned_ObjectIDType' => '\\StructType\\Recruiting_Stage__Workday_Owned_ObjectIDType',
            'Web_Service_Background_Process_RuntimeObjectIDType' => '\\StructType\\Web_Service_Background_Process_RuntimeObjectIDType',
            'Military_Service_TypeObjectIDType' => '\\StructType\\Military_Service_TypeObjectIDType',
            'Military_RankObjectIDType' => '\\StructType\\Military_RankObjectIDType',
            'Disability_GradeObjectIDType' => '\\StructType\\Disability_GradeObjectIDType',
            'Disability_Certification_AuthorityObjectIDType' => '\\StructType\\Disability_Certification_AuthorityObjectIDType',
            'Disability_Certification_BasisObjectIDType' => '\\StructType\\Disability_Certification_BasisObjectIDType',
            'Recruiting_EventObjectIDType' => '\\StructType\\Recruiting_EventObjectIDType',
            'Recruiting_Prospect_StatusObjectIDType' => '\\StructType\\Recruiting_Prospect_StatusObjectIDType',
            'Disability_Status_ReferenceObjectIDType' => '\\StructType\\Disability_Status_ReferenceObjectIDType',
            'Military_Service_ReferenceObjectIDType' => '\\StructType\\Military_Service_ReferenceObjectIDType',
            'Grid_ConfigurationObjectIDType' => '\\StructType\\Grid_ConfigurationObjectIDType',
            'National_Identifier_ReferenceObjectIDType' => '\\StructType\\National_Identifier_ReferenceObjectIDType',
            'Government_Identifier_ReferenceObjectIDType' => '\\StructType\\Government_Identifier_ReferenceObjectIDType',
            'Recruiting_DispositionObjectIDType' => '\\StructType\\Recruiting_DispositionObjectIDType',
            'Candidate_AttachmentObjectIDType' => '\\StructType\\Candidate_AttachmentObjectIDType',
            'Passport_Identifier_ReferenceObjectIDType' => '\\StructType\\Passport_Identifier_ReferenceObjectIDType',
            'Visa_Identifier_ReferenceObjectIDType' => '\\StructType\\Visa_Identifier_ReferenceObjectIDType',
            'License_Identifier_ReferenceObjectIDType' => '\\StructType\\License_Identifier_ReferenceObjectIDType',
            'Custom_Identifier_ReferenceObjectIDType' => '\\StructType\\Custom_Identifier_ReferenceObjectIDType',
            'Former_WorkerObjectIDType' => '\\StructType\\Former_WorkerObjectIDType',
            'Communication_Usage_Behavior_TenantedObjectIDType' => '\\StructType\\Communication_Usage_Behavior_TenantedObjectIDType',
            'Job_PostingObjectIDType' => '\\StructType\\Job_PostingObjectIDType',
            'Generic_Job_Posting_SiteObjectIDType' => '\\StructType\\Generic_Job_Posting_SiteObjectIDType',
            'Job_Posting_TemplateObjectIDType' => '\\StructType\\Job_Posting_TemplateObjectIDType',
            'Referral_RelationshipObjectIDType' => '\\StructType\\Referral_RelationshipObjectIDType',
            'Collective_Agreement_FactorObjectIDType' => '\\StructType\\Collective_Agreement_FactorObjectIDType',
            'Collective_Agreement_Factor_OptionObjectIDType' => '\\StructType\\Collective_Agreement_Factor_OptionObjectIDType',
            'Social_Benefits_LocalityObjectIDType' => '\\StructType\\Social_Benefits_LocalityObjectIDType',
            'Recruiting_Assessment_StatusObjectIDType' => '\\StructType\\Recruiting_Assessment_StatusObjectIDType',
            'Recruiting_AssessmentObjectIDType' => '\\StructType\\Recruiting_AssessmentObjectIDType',
            'Background_Check_Package_TestObjectIDType' => '\\StructType\\Background_Check_Package_TestObjectIDType',
            'Background_Check_PackageObjectIDType' => '\\StructType\\Background_Check_PackageObjectIDType',
            'Recruiting_Prospect_TypeObjectIDType' => '\\StructType\\Recruiting_Prospect_TypeObjectIDType',
            'Job_Posting_SiteObjectIDType' => '\\StructType\\Job_Posting_SiteObjectIDType',
            'External_Job_Posting_SiteObjectIDType' => '\\StructType\\External_Job_Posting_SiteObjectIDType',
            'Question_SetupObjectIDType' => '\\StructType\\Question_SetupObjectIDType',
            'Question_Multiple_Choice_AnswerObjectIDType' => '\\StructType\\Question_Multiple_Choice_AnswerObjectIDType',
            'Global_Setup_Data_MappingObjectIDType' => '\\StructType\\Global_Setup_Data_MappingObjectIDType',
            'QuestionnaireObjectIDType' => '\\StructType\\QuestionnaireObjectIDType',
            'Questionnaire_Configuration_TypeObjectIDType' => '\\StructType\\Questionnaire_Configuration_TypeObjectIDType',
            'Interview_Feedback_RatingObjectIDType' => '\\StructType\\Interview_Feedback_RatingObjectIDType',
            'External_Identification_Point__XIP_ObjectIDType' => '\\StructType\\External_Identification_Point__XIP_ObjectIDType',
            'Self-Identification_of_Disability_StatusObjectIDType' => '\\StructType\\Self_Identification_of_Disability_StatusObjectIDType',
            'Static_Candidate_PoolObjectIDType' => '\\StructType\\Static_Candidate_PoolObjectIDType',
            'Event_Attachment_CategoryObjectIDType' => '\\StructType\\Event_Attachment_CategoryObjectIDType',
            'Specialty_ParentObjectIDType' => '\\StructType\\Specialty_ParentObjectIDType',
            'Specialty_ChildObjectIDType' => '\\StructType\\Specialty_ChildObjectIDType',
            'LGBT_IdentificationObjectIDType' => '\\StructType\\LGBT_IdentificationObjectIDType',
            'Recruiting_Assessment_TestObjectIDType' => '\\StructType\\Recruiting_Assessment_TestObjectIDType',
            'Recruiting_Assessment_Test_ResultObjectIDType' => '\\StructType\\Recruiting_Assessment_Test_ResultObjectIDType',
            'Student_Award_SourceObjectIDType' => '\\StructType\\Student_Award_SourceObjectIDType',
            'Job_Requisition_EnabledObjectIDType' => '\\StructType\\Job_Requisition_EnabledObjectIDType',
            'Evergreen_Job_RequisitionObjectIDType' => '\\StructType\\Evergreen_Job_RequisitionObjectIDType',
            'Veteran_StatusObjectIDType' => '\\StructType\\Veteran_StatusObjectIDType',
            'Professional_Affiliation_Relationship_TypeObjectIDType' => '\\StructType\\Professional_Affiliation_Relationship_TypeObjectIDType',
            'Professional_Affiliation_ReferenceObjectIDType' => '\\StructType\\Professional_Affiliation_ReferenceObjectIDType',
            'Professional_Affiliation_Type__All_ObjectIDType' => '\\StructType\\Professional_Affiliation_Type__All_ObjectIDType',
            'Country_CityObjectIDType' => '\\StructType\\Country_CityObjectIDType',
            'Relative_TypeObjectIDType' => '\\StructType\\Relative_TypeObjectIDType',
            'Relative_Name_ReferenceObjectIDType' => '\\StructType\\Relative_Name_ReferenceObjectIDType',
            'Armed_Forces_StatusObjectIDType' => '\\StructType\\Armed_Forces_StatusObjectIDType',
            'Pre-Hire_Probation_Period_UnitObjectIDType' => '\\StructType\\Pre_Hire_Probation_Period_UnitObjectIDType',
            'Recruiting_Agency_SiteObjectIDType' => '\\StructType\\Recruiting_Agency_SiteObjectIDType',
            'Recruiting_Agency_UserObjectIDType' => '\\StructType\\Recruiting_Agency_UserObjectIDType',
            'Recruiting_Agency_TypeObjectIDType' => '\\StructType\\Recruiting_Agency_TypeObjectIDType',
            'Award_and_Activity_TypeObjectIDType' => '\\StructType\\Award_and_Activity_TypeObjectIDType',
            'Recruiting_Agency_Fee_TypeObjectIDType' => '\\StructType\\Recruiting_Agency_Fee_TypeObjectIDType',
            'Merit_PlanObjectIDType' => '\\StructType\\Merit_PlanObjectIDType',
            'Interview_TypeObjectIDType' => '\\StructType\\Interview_TypeObjectIDType',
            'Job_Requisition_Interview_SessionObjectIDType' => '\\StructType\\Job_Requisition_Interview_SessionObjectIDType',
            'Message_TemplateObjectIDType' => '\\StructType\\Message_TemplateObjectIDType',
            'Date_And_Time_UnitObjectIDType' => '\\StructType\\Date_And_Time_UnitObjectIDType',
            'Gender_IdentityObjectIDType' => '\\StructType\\Gender_IdentityObjectIDType',
            'Sexual_OrientationObjectIDType' => '\\StructType\\Sexual_OrientationObjectIDType',
            'PronounObjectIDType' => '\\StructType\\PronounObjectIDType',
            'Job_Family_BaseObjectIDType' => '\\StructType\\Job_Family_BaseObjectIDType',
            'Job_Application_TemplateObjectIDType' => '\\StructType\\Job_Application_TemplateObjectIDType',
            'Email_ReferenceObjectIDType' => '\\StructType\\Email_ReferenceObjectIDType',
            'Candidate_Readiness_StatusObjectIDType' => '\\StructType\\Candidate_Readiness_StatusObjectIDType',
            'Blood_TypeObjectIDType' => '\\StructType\\Blood_TypeObjectIDType',
            'Phone_ReferenceObjectIDType' => '\\StructType\\Phone_ReferenceObjectIDType',
            'Candidate_TagObjectIDType' => '\\StructType\\Candidate_TagObjectIDType',
            'Recruiting_Self-Schedule_CalendarObjectIDType' => '\\StructType\\Recruiting_Self_Schedule_CalendarObjectIDType',
            'Common_Yes_NoObjectIDType' => '\\StructType\\Common_Yes_NoObjectIDType',
            'Recruiting_Self-Schedule_Calendar_TypeObjectIDType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_TypeObjectIDType',
            'Recruiting_Self-Service_Time_BlockObjectIDType' => '\\StructType\\Recruiting_Self_Service_Time_BlockObjectIDType',
            'Recruiting_Self-Service_ScheduleObjectIDType' => '\\StructType\\Recruiting_Self_Service_ScheduleObjectIDType',
            'SkillObjectIDType' => '\\StructType\\SkillObjectIDType',
            'Web_Address_ReferenceObjectIDType' => '\\StructType\\Web_Address_ReferenceObjectIDType',
            'Instant_Messenger_ReferenceObjectIDType' => '\\StructType\\Instant_Messenger_ReferenceObjectIDType',
            'Recruiting_Assessment_Category_Security_SegmentObjectIDType' => '\\StructType\\Recruiting_Assessment_Category_Security_SegmentObjectIDType',
            'Recruiting_Assessment_CategoryObjectIDType' => '\\StructType\\Recruiting_Assessment_CategoryObjectIDType',
            'Candidate_List_Rule_Configuration_SingletonObjectIDType' => '\\StructType\\Candidate_List_Rule_Configuration_SingletonObjectIDType',
            'Notification_Template_AbstractObjectIDType' => '\\StructType\\Notification_Template_AbstractObjectIDType',
            'Interview_RoomObjectIDType' => '\\StructType\\Interview_RoomObjectIDType',
            'BrandObjectIDType' => '\\StructType\\BrandObjectIDType',
            'Calculated_Plan_InterfaceObjectIDType' => '\\StructType\\Calculated_Plan_InterfaceObjectIDType',
            'Referee_Relationship_TypeObjectIDType' => '\\StructType\\Referee_Relationship_TypeObjectIDType',
            'RefereeObjectIDType' => '\\StructType\\RefereeObjectIDType',
            'Masked_ConfigurationObjectIDType' => '\\StructType\\Masked_ConfigurationObjectIDType',
            'Job_Requisition_Masking_Rule_Configuration_SingletonObjectIDType' => '\\StructType\\Job_Requisition_Masking_Rule_Configuration_SingletonObjectIDType',
            'Interview_Session_Order_PreferenceObjectIDType' => '\\StructType\\Interview_Session_Order_PreferenceObjectIDType',
            'Range_of_DatesObjectIDType' => '\\StructType\\Range_of_DatesObjectIDType',
            'Job_Application_Skills_Match_Score_CategoryObjectIDType' => '\\StructType\\Job_Application_Skills_Match_Score_CategoryObjectIDType',
            'Recruiting_Self-Service_Time_Block_ContainerObjectIDType' => '\\StructType\\Recruiting_Self_Service_Time_Block_ContainerObjectIDType',
            'Interview_Custom_Integration_EventObjectIDType' => '\\StructType\\Interview_Custom_Integration_EventObjectIDType',
            'Ethnicity_DetailsObjectIDType' => '\\StructType\\Ethnicity_DetailsObjectIDType',
            'Aboriginal_Indigenous_DetailsObjectIDType' => '\\StructType\\Aboriginal_Indigenous_DetailsObjectIDType',
            'Aboriginal_Indigenous_Identification_SelectionObjectIDType' => '\\StructType\\Aboriginal_Indigenous_Identification_SelectionObjectIDType',
            'RoleObjectType' => '\\StructType\\RoleObjectType',
            'Process-maintained_RoleObjectType' => '\\StructType\\Process_maintained_RoleObjectType',
            'Additional_Name_TypeObjectType' => '\\StructType\\Additional_Name_TypeObjectType',
            'Military_StatusObjectType' => '\\StructType\\Military_StatusObjectType',
            'Citizenship_StatusObjectType' => '\\StructType\\Citizenship_StatusObjectType',
            'AuthorityObjectType' => '\\StructType\\AuthorityObjectType',
            'LocationObjectType' => '\\StructType\\LocationObjectType',
            'Job_ProfileObjectType' => '\\StructType\\Job_ProfileObjectType',
            'OrganizationObjectType' => '\\StructType\\OrganizationObjectType',
            'Organization_TypeObjectType' => '\\StructType\\Organization_TypeObjectType',
            'Organization_SubtypeObjectType' => '\\StructType\\Organization_SubtypeObjectType',
            'Language_ProficiencyObjectType' => '\\StructType\\Language_ProficiencyObjectType',
            'LanguageObjectType' => '\\StructType\\LanguageObjectType',
            'EthnicityObjectType' => '\\StructType\\EthnicityObjectType',
            'Marital_StatusObjectType' => '\\StructType\\Marital_StatusObjectType',
            'GenderObjectType' => '\\StructType\\GenderObjectType',
            'Instant_Messenger_TypeObjectType' => '\\StructType\\Instant_Messenger_TypeObjectType',
            'Assignable_RoleObjectType' => '\\StructType\\Assignable_RoleObjectType',
            'Job_FamilyObjectType' => '\\StructType\\Job_FamilyObjectType',
            'WorkerObjectType' => '\\StructType\\WorkerObjectType',
            'Worker_TypeObjectType' => '\\StructType\\Worker_TypeObjectType',
            'Position_Time_TypeObjectType' => '\\StructType\\Position_Time_TypeObjectType',
            'Organization_OwnerObjectType' => '\\StructType\\Organization_OwnerObjectType',
            'Language_Ability_TypeObjectType' => '\\StructType\\Language_Ability_TypeObjectType',
            'ApplicantObjectType' => '\\StructType\\ApplicantObjectType',
            'DegreeObjectType' => '\\StructType\\DegreeObjectType',
            'Field_of_StudyObjectType' => '\\StructType\\Field_of_StudyObjectType',
            'School_TypeObjectType' => '\\StructType\\School_TypeObjectType',
            'Compensation_GradeObjectType' => '\\StructType\\Compensation_GradeObjectType',
            'Compensation_Grade_ProfileObjectType' => '\\StructType\\Compensation_Grade_ProfileObjectType',
            'Bonus_PlanObjectType' => '\\StructType\\Bonus_PlanObjectType',
            'Salary_Pay_PlanObjectType' => '\\StructType\\Salary_Pay_PlanObjectType',
            'FrequencyObjectType' => '\\StructType\\FrequencyObjectType',
            'Compensation_PackageObjectType' => '\\StructType\\Compensation_PackageObjectType',
            'Management_LevelObjectType' => '\\StructType\\Management_LevelObjectType',
            'Applicant_SourceObjectType' => '\\StructType\\Applicant_SourceObjectType',
            'EventObjectType' => '\\StructType\\EventObjectType',
            'License_IdentifierObjectType' => '\\StructType\\License_IdentifierObjectType',
            'Visa_ID_TypeObjectType' => '\\StructType\\Visa_ID_TypeObjectType',
            'Custom_ID_TypeObjectType' => '\\StructType\\Custom_ID_TypeObjectType',
            'Work_Experience_QualificationObjectType' => '\\StructType\\Work_Experience_QualificationObjectType',
            'Work_Experience_RatingObjectType' => '\\StructType\\Work_Experience_RatingObjectType',
            'Proficiency_RatingObjectType' => '\\StructType\\Proficiency_RatingObjectType',
            'CompetencyObjectType' => '\\StructType\\CompetencyObjectType',
            'Proficiency_Rating_BehaviorObjectType' => '\\StructType\\Proficiency_Rating_BehaviorObjectType',
            'Training_TypeObjectType' => '\\StructType\\Training_TypeObjectType',
            'Event_Classification_SubcategoryObjectType' => '\\StructType\\Event_Classification_SubcategoryObjectType',
            'Talent_Qualification_EnabledObjectType' => '\\StructType\\Talent_Qualification_EnabledObjectType',
            'Workflow_StepObjectType' => '\\StructType\\Workflow_StepObjectType',
            'Spend_CategoryObjectType' => '\\StructType\\Spend_CategoryObjectType',
            'One-Time_Payment_PlanObjectType' => '\\StructType\\One_Time_Payment_PlanObjectType',
            'Mime_TypeObjectType' => '\\StructType\\Mime_TypeObjectType',
            'External_URLObjectType' => '\\StructType\\External_URLObjectType',
            'Business_Process_TypeObjectType' => '\\StructType\\Business_Process_TypeObjectType',
            'Audited_Accounting_WorktagObjectType' => '\\StructType\\Audited_Accounting_WorktagObjectType',
            'Phone_Device_TypeObjectType' => '\\StructType\\Phone_Device_TypeObjectType',
            'Applicant_ResumeObjectType' => '\\StructType\\Applicant_ResumeObjectType',
            'Worker_EventObjectType' => '\\StructType\\Worker_EventObjectType',
            'Position_Worker_TypeObjectType' => '\\StructType\\Position_Worker_TypeObjectType',
            'Commission_PlanObjectType' => '\\StructType\\Commission_PlanObjectType',
            'Earning__All_ObjectType' => '\\StructType\\Earning__All_ObjectType',
            'SupplierObjectType' => '\\StructType\\SupplierObjectType',
            'User_LanguageObjectType' => '\\StructType\\User_LanguageObjectType',
            'Communication_Usage_TypeObjectType' => '\\StructType\\Communication_Usage_TypeObjectType',
            'Communication_Usage_BehaviorObjectType' => '\\StructType\\Communication_Usage_BehaviorObjectType',
            'CountryObjectType' => '\\StructType\\CountryObjectType',
            'Country_RegionObjectType' => '\\StructType\\Country_RegionObjectType',
            'Country_Phone_CodeObjectType' => '\\StructType\\Country_Phone_CodeObjectType',
            'Country_Predefined_Person_Name_Component_ValueObjectType' => '\\StructType\\Country_Predefined_Person_Name_Component_ValueObjectType',
            'CurrencyObjectType' => '\\StructType\\CurrencyObjectType',
            'Compensation_StepObjectType' => '\\StructType\\Compensation_StepObjectType',
            'Condition_RuleObjectType' => '\\StructType\\Condition_RuleObjectType',
            'DisabilityObjectType' => '\\StructType\\DisabilityObjectType',
            'Pay_GroupObjectType' => '\\StructType\\Pay_GroupObjectType',
            'Allowance_Unit_PlanObjectType' => '\\StructType\\Allowance_Unit_PlanObjectType',
            'Salary_Unit_PlanObjectType' => '\\StructType\\Salary_Unit_PlanObjectType',
            'Allowance_Value_PlanObjectType' => '\\StructType\\Allowance_Value_PlanObjectType',
            'Day_of_the_WeekObjectType' => '\\StructType\\Day_of_the_WeekObjectType',
            'Day_of_the_MonthObjectType' => '\\StructType\\Day_of_the_MonthObjectType',
            'MonthObjectType' => '\\StructType\\MonthObjectType',
            'Tenanted_Payroll_WorktagObjectType' => '\\StructType\\Tenanted_Payroll_WorktagObjectType',
            'Location_ContextObjectType' => '\\StructType\\Location_ContextObjectType',
            'ReligionObjectType' => '\\StructType\\ReligionObjectType',
            'Supervisory_OrganizationObjectType' => '\\StructType\\Supervisory_OrganizationObjectType',
            'CompanyObjectType' => '\\StructType\\CompanyObjectType',
            'Cost_CenterObjectType' => '\\StructType\\Cost_CenterObjectType',
            'RegionObjectType' => '\\StructType\\RegionObjectType',
            'Custom_OrganizationObjectType' => '\\StructType\\Custom_OrganizationObjectType',
            'Time_ZoneObjectType' => '\\StructType\\Time_ZoneObjectType',
            'Twenty_Four_Hour_TimeObjectType' => '\\StructType\\Twenty_Four_Hour_TimeObjectType',
            'Transaction_Log_TypeObjectType' => '\\StructType\\Transaction_Log_TypeObjectType',
            'SubscriberObjectType' => '\\StructType\\SubscriberObjectType',
            'Job_CategoryObjectType' => '\\StructType\\Job_CategoryObjectType',
            'Work_ShiftObjectType' => '\\StructType\\Work_ShiftObjectType',
            'Worker_DocumentObjectType' => '\\StructType\\Worker_DocumentObjectType',
            'National_ID_TypeObjectType' => '\\StructType\\National_ID_TypeObjectType',
            'Unique_IdentifierObjectType' => '\\StructType\\Unique_IdentifierObjectType',
            'Country_SubregionObjectType' => '\\StructType\\Country_SubregionObjectType',
            'Hukou_TypeObjectType' => '\\StructType\\Hukou_TypeObjectType',
            'External_Field_and_Parameter_Initialization_ProviderObjectType' => '\\StructType\\External_Field_and_Parameter_Initialization_ProviderObjectType',
            'Position_ElementObjectType' => '\\StructType\\Position_ElementObjectType',
            'Employee_Contract_TypeObjectType' => '\\StructType\\Employee_Contract_TypeObjectType',
            'FundObjectType' => '\\StructType\\FundObjectType',
            'Integration_Document_FieldObjectType' => '\\StructType\\Integration_Document_FieldObjectType',
            'Certification_QualificationObjectType' => '\\StructType\\Certification_QualificationObjectType',
            'AwardObjectType' => '\\StructType\\AwardObjectType',
            'Professional_Affiliation_QualificationObjectType' => '\\StructType\\Professional_Affiliation_QualificationObjectType',
            'TrainingObjectType' => '\\StructType\\TrainingObjectType',
            'Role_AssignerObjectType' => '\\StructType\\Role_AssignerObjectType',
            'Education_QualificationObjectType' => '\\StructType\\Education_QualificationObjectType',
            'Internal_Project_ExperienceObjectType' => '\\StructType\\Internal_Project_ExperienceObjectType',
            'Job_History_QualificationObjectType' => '\\StructType\\Job_History_QualificationObjectType',
            'PositionObjectType' => '\\StructType\\PositionObjectType',
            'Position_GroupObjectType' => '\\StructType\\Position_GroupObjectType',
            'Position_RestrictionsObjectType' => '\\StructType\\Position_RestrictionsObjectType',
            'Difficulty_to_FillObjectType' => '\\StructType\\Difficulty_to_FillObjectType',
            'Stock_PlanObjectType' => '\\StructType\\Stock_PlanObjectType',
            'SchoolObjectType' => '\\StructType\\SchoolObjectType',
            'CertificationObjectType' => '\\StructType\\CertificationObjectType',
            'Job_RequisitionObjectType' => '\\StructType\\Job_RequisitionObjectType',
            'Document_Category__All_ObjectType' => '\\StructType\\Document_Category__All_ObjectType',
            'Role-Based_Security_Group__Unconstrained_ObjectType' => '\\StructType\\Role_Based_Security_Group__Unconstrained_ObjectType',
            'Degree_CompletedObjectType' => '\\StructType\\Degree_CompletedObjectType',
            'Job_Requisition_StatusObjectType' => '\\StructType\\Job_Requisition_StatusObjectType',
            'UnionObjectType' => '\\StructType\\UnionObjectType',
            'Recruiting_InstructionObjectType' => '\\StructType\\Recruiting_InstructionObjectType',
            'ProgramObjectType' => '\\StructType\\ProgramObjectType',
            'GrantObjectType' => '\\StructType\\GrantObjectType',
            'Business_UnitObjectType' => '\\StructType\\Business_UnitObjectType',
            'Social_Network_TypeObjectType' => '\\StructType\\Social_Network_TypeObjectType',
            'Common_Boolean_EnumerationObjectType' => '\\StructType\\Common_Boolean_EnumerationObjectType',
            'Government_ID_Type__All_ObjectType' => '\\StructType\\Government_ID_Type__All_ObjectType',
            'License_ID_Type__All_ObjectType' => '\\StructType\\License_ID_Type__All_ObjectType',
            'Passport_ID_Type__All_ObjectType' => '\\StructType\\Passport_ID_Type__All_ObjectType',
            'Costing_Allocation_LevelObjectType' => '\\StructType\\Costing_Allocation_LevelObjectType',
            'Period_Salary_PlanObjectType' => '\\StructType\\Period_Salary_PlanObjectType',
            'Compensation_PeriodObjectType' => '\\StructType\\Compensation_PeriodObjectType',
            'Background_Check_EventObjectType' => '\\StructType\\Background_Check_EventObjectType',
            'Background_Check_StatusObjectType' => '\\StructType\\Background_Check_StatusObjectType',
            'Maintained_SkillObjectType' => '\\StructType\\Maintained_SkillObjectType',
            'Job_History_CompanyObjectType' => '\\StructType\\Job_History_CompanyObjectType',
            'Political_AffiliationObjectType' => '\\StructType\\Political_AffiliationObjectType',
            'GiftObjectType' => '\\StructType\\GiftObjectType',
            'RoleeObjectType' => '\\StructType\\RoleeObjectType',
            'Address_ReferenceObjectType' => '\\StructType\\Address_ReferenceObjectType',
            'CandidateObjectType' => '\\StructType\\CandidateObjectType',
            'Job_ApplicationObjectType' => '\\StructType\\Job_ApplicationObjectType',
            'Resume_AttachmentObjectType' => '\\StructType\\Resume_AttachmentObjectType',
            'Employee_Contract_ReasonObjectType' => '\\StructType\\Employee_Contract_ReasonObjectType',
            'Collective_AgreementObjectType' => '\\StructType\\Collective_AgreementObjectType',
            'Recruiting_Stage__Workday_Owned_ObjectType' => '\\StructType\\Recruiting_Stage__Workday_Owned_ObjectType',
            'Web_Service_Background_Process_RuntimeObjectType' => '\\StructType\\Web_Service_Background_Process_RuntimeObjectType',
            'Military_Service_TypeObjectType' => '\\StructType\\Military_Service_TypeObjectType',
            'Military_RankObjectType' => '\\StructType\\Military_RankObjectType',
            'Disability_GradeObjectType' => '\\StructType\\Disability_GradeObjectType',
            'Disability_Certification_AuthorityObjectType' => '\\StructType\\Disability_Certification_AuthorityObjectType',
            'Disability_Certification_BasisObjectType' => '\\StructType\\Disability_Certification_BasisObjectType',
            'Recruiting_EventObjectType' => '\\StructType\\Recruiting_EventObjectType',
            'Recruiting_Prospect_StatusObjectType' => '\\StructType\\Recruiting_Prospect_StatusObjectType',
            'Disability_Status_ReferenceObjectType' => '\\StructType\\Disability_Status_ReferenceObjectType',
            'Military_Service_ReferenceObjectType' => '\\StructType\\Military_Service_ReferenceObjectType',
            'Grid_ConfigurationObjectType' => '\\StructType\\Grid_ConfigurationObjectType',
            'National_Identifier_ReferenceObjectType' => '\\StructType\\National_Identifier_ReferenceObjectType',
            'Government_Identifier_ReferenceObjectType' => '\\StructType\\Government_Identifier_ReferenceObjectType',
            'Recruiting_DispositionObjectType' => '\\StructType\\Recruiting_DispositionObjectType',
            'Candidate_AttachmentObjectType' => '\\StructType\\Candidate_AttachmentObjectType',
            'Passport_Identifier_ReferenceObjectType' => '\\StructType\\Passport_Identifier_ReferenceObjectType',
            'Visa_Identifier_ReferenceObjectType' => '\\StructType\\Visa_Identifier_ReferenceObjectType',
            'License_Identifier_ReferenceObjectType' => '\\StructType\\License_Identifier_ReferenceObjectType',
            'Custom_Identifier_ReferenceObjectType' => '\\StructType\\Custom_Identifier_ReferenceObjectType',
            'Former_WorkerObjectType' => '\\StructType\\Former_WorkerObjectType',
            'Communication_Usage_Behavior_TenantedObjectType' => '\\StructType\\Communication_Usage_Behavior_TenantedObjectType',
            'Job_PostingObjectType' => '\\StructType\\Job_PostingObjectType',
            'Generic_Job_Posting_SiteObjectType' => '\\StructType\\Generic_Job_Posting_SiteObjectType',
            'Job_Posting_TemplateObjectType' => '\\StructType\\Job_Posting_TemplateObjectType',
            'Referral_RelationshipObjectType' => '\\StructType\\Referral_RelationshipObjectType',
            'Collective_Agreement_FactorObjectType' => '\\StructType\\Collective_Agreement_FactorObjectType',
            'Collective_Agreement_Factor_OptionObjectType' => '\\StructType\\Collective_Agreement_Factor_OptionObjectType',
            'Social_Benefits_LocalityObjectType' => '\\StructType\\Social_Benefits_LocalityObjectType',
            'Recruiting_Assessment_StatusObjectType' => '\\StructType\\Recruiting_Assessment_StatusObjectType',
            'Recruiting_AssessmentObjectType' => '\\StructType\\Recruiting_AssessmentObjectType',
            'Background_Check_Package_TestObjectType' => '\\StructType\\Background_Check_Package_TestObjectType',
            'Background_Check_PackageObjectType' => '\\StructType\\Background_Check_PackageObjectType',
            'Recruiting_Prospect_TypeObjectType' => '\\StructType\\Recruiting_Prospect_TypeObjectType',
            'Job_Posting_SiteObjectType' => '\\StructType\\Job_Posting_SiteObjectType',
            'External_Job_Posting_SiteObjectType' => '\\StructType\\External_Job_Posting_SiteObjectType',
            'Question_SetupObjectType' => '\\StructType\\Question_SetupObjectType',
            'Question_Multiple_Choice_AnswerObjectType' => '\\StructType\\Question_Multiple_Choice_AnswerObjectType',
            'Global_Setup_Data_MappingObjectType' => '\\StructType\\Global_Setup_Data_MappingObjectType',
            'QuestionnaireObjectType' => '\\StructType\\QuestionnaireObjectType',
            'Questionnaire_Configuration_TypeObjectType' => '\\StructType\\Questionnaire_Configuration_TypeObjectType',
            'Interview_Feedback_RatingObjectType' => '\\StructType\\Interview_Feedback_RatingObjectType',
            'External_Identification_Point__XIP_ObjectType' => '\\StructType\\External_Identification_Point__XIP_ObjectType',
            'Self-Identification_of_Disability_StatusObjectType' => '\\StructType\\Self_Identification_of_Disability_StatusObjectType',
            'Static_Candidate_PoolObjectType' => '\\StructType\\Static_Candidate_PoolObjectType',
            'Event_Attachment_CategoryObjectType' => '\\StructType\\Event_Attachment_CategoryObjectType',
            'Specialty_ParentObjectType' => '\\StructType\\Specialty_ParentObjectType',
            'Specialty_ChildObjectType' => '\\StructType\\Specialty_ChildObjectType',
            'LGBT_IdentificationObjectType' => '\\StructType\\LGBT_IdentificationObjectType',
            'Recruiting_Assessment_TestObjectType' => '\\StructType\\Recruiting_Assessment_TestObjectType',
            'Recruiting_Assessment_Test_ResultObjectType' => '\\StructType\\Recruiting_Assessment_Test_ResultObjectType',
            'Student_Award_SourceObjectType' => '\\StructType\\Student_Award_SourceObjectType',
            'Job_Requisition_EnabledObjectType' => '\\StructType\\Job_Requisition_EnabledObjectType',
            'Evergreen_Job_RequisitionObjectType' => '\\StructType\\Evergreen_Job_RequisitionObjectType',
            'Veteran_StatusObjectType' => '\\StructType\\Veteran_StatusObjectType',
            'Professional_Affiliation_Relationship_TypeObjectType' => '\\StructType\\Professional_Affiliation_Relationship_TypeObjectType',
            'Professional_Affiliation_ReferenceObjectType' => '\\StructType\\Professional_Affiliation_ReferenceObjectType',
            'Professional_Affiliation_Type__All_ObjectType' => '\\StructType\\Professional_Affiliation_Type__All_ObjectType',
            'Country_CityObjectType' => '\\StructType\\Country_CityObjectType',
            'Relative_TypeObjectType' => '\\StructType\\Relative_TypeObjectType',
            'Relative_Name_ReferenceObjectType' => '\\StructType\\Relative_Name_ReferenceObjectType',
            'Armed_Forces_StatusObjectType' => '\\StructType\\Armed_Forces_StatusObjectType',
            'Pre-Hire_Probation_Period_UnitObjectType' => '\\StructType\\Pre_Hire_Probation_Period_UnitObjectType',
            'Recruiting_Agency_SiteObjectType' => '\\StructType\\Recruiting_Agency_SiteObjectType',
            'Recruiting_Agency_UserObjectType' => '\\StructType\\Recruiting_Agency_UserObjectType',
            'Recruiting_Agency_TypeObjectType' => '\\StructType\\Recruiting_Agency_TypeObjectType',
            'Award_and_Activity_TypeObjectType' => '\\StructType\\Award_and_Activity_TypeObjectType',
            'Recruiting_Agency_Fee_TypeObjectType' => '\\StructType\\Recruiting_Agency_Fee_TypeObjectType',
            'Merit_PlanObjectType' => '\\StructType\\Merit_PlanObjectType',
            'Interview_TypeObjectType' => '\\StructType\\Interview_TypeObjectType',
            'Job_Requisition_Interview_SessionObjectType' => '\\StructType\\Job_Requisition_Interview_SessionObjectType',
            'Message_TemplateObjectType' => '\\StructType\\Message_TemplateObjectType',
            'Date_And_Time_UnitObjectType' => '\\StructType\\Date_And_Time_UnitObjectType',
            'Gender_IdentityObjectType' => '\\StructType\\Gender_IdentityObjectType',
            'Sexual_OrientationObjectType' => '\\StructType\\Sexual_OrientationObjectType',
            'PronounObjectType' => '\\StructType\\PronounObjectType',
            'Job_Family_BaseObjectType' => '\\StructType\\Job_Family_BaseObjectType',
            'Job_Application_TemplateObjectType' => '\\StructType\\Job_Application_TemplateObjectType',
            'Email_ReferenceObjectType' => '\\StructType\\Email_ReferenceObjectType',
            'Candidate_Readiness_StatusObjectType' => '\\StructType\\Candidate_Readiness_StatusObjectType',
            'Blood_TypeObjectType' => '\\StructType\\Blood_TypeObjectType',
            'Phone_ReferenceObjectType' => '\\StructType\\Phone_ReferenceObjectType',
            'Candidate_TagObjectType' => '\\StructType\\Candidate_TagObjectType',
            'Recruiting_Self-Schedule_CalendarObjectType' => '\\StructType\\Recruiting_Self_Schedule_CalendarObjectType',
            'Common_Yes_NoObjectType' => '\\StructType\\Common_Yes_NoObjectType',
            'Recruiting_Self-Schedule_Calendar_TypeObjectType' => '\\StructType\\Recruiting_Self_Schedule_Calendar_TypeObjectType',
            'Recruiting_Self-Service_Time_BlockObjectType' => '\\StructType\\Recruiting_Self_Service_Time_BlockObjectType',
            'Recruiting_Self-Service_ScheduleObjectType' => '\\StructType\\Recruiting_Self_Service_ScheduleObjectType',
            'SkillObjectType' => '\\StructType\\SkillObjectType',
            'Web_Address_ReferenceObjectType' => '\\StructType\\Web_Address_ReferenceObjectType',
            'Instant_Messenger_ReferenceObjectType' => '\\StructType\\Instant_Messenger_ReferenceObjectType',
            'Recruiting_Assessment_Category_Security_SegmentObjectType' => '\\StructType\\Recruiting_Assessment_Category_Security_SegmentObjectType',
            'Recruiting_Assessment_CategoryObjectType' => '\\StructType\\Recruiting_Assessment_CategoryObjectType',
            'Candidate_List_Rule_Configuration_SingletonObjectType' => '\\StructType\\Candidate_List_Rule_Configuration_SingletonObjectType',
            'Notification_Template_AbstractObjectType' => '\\StructType\\Notification_Template_AbstractObjectType',
            'Interview_RoomObjectType' => '\\StructType\\Interview_RoomObjectType',
            'BrandObjectType' => '\\StructType\\BrandObjectType',
            'Calculated_Plan_InterfaceObjectType' => '\\StructType\\Calculated_Plan_InterfaceObjectType',
            'Referee_Relationship_TypeObjectType' => '\\StructType\\Referee_Relationship_TypeObjectType',
            'RefereeObjectType' => '\\StructType\\RefereeObjectType',
            'Masked_ConfigurationObjectType' => '\\StructType\\Masked_ConfigurationObjectType',
            'Job_Requisition_Masking_Rule_Configuration_SingletonObjectType' => '\\StructType\\Job_Requisition_Masking_Rule_Configuration_SingletonObjectType',
            'Interview_Session_Order_PreferenceObjectType' => '\\StructType\\Interview_Session_Order_PreferenceObjectType',
            'Range_of_DatesObjectType' => '\\StructType\\Range_of_DatesObjectType',
            'Job_Application_Skills_Match_Score_CategoryObjectType' => '\\StructType\\Job_Application_Skills_Match_Score_CategoryObjectType',
            'Recruiting_Self-Service_Time_Block_ContainerObjectType' => '\\StructType\\Recruiting_Self_Service_Time_Block_ContainerObjectType',
            'Interview_Custom_Integration_EventObjectType' => '\\StructType\\Interview_Custom_Integration_EventObjectType',
            'Ethnicity_DetailsObjectType' => '\\StructType\\Ethnicity_DetailsObjectType',
            'Aboriginal_Indigenous_DetailsObjectType' => '\\StructType\\Aboriginal_Indigenous_DetailsObjectType',
            'Aboriginal_Indigenous_Identification_SelectionObjectType' => '\\StructType\\Aboriginal_Indigenous_Identification_SelectionObjectType',
            'Validation_FaultType' => '\\StructType\\Validation_FaultType',
            'Processing_FaultType' => '\\StructType\\Processing_FaultType',
            'Validation_ErrorType' => '\\StructType\\Validation_ErrorType',
        );
    }
}
