<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Button_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains the data for the buttons of brand.
 * @subpackage Structs
 */
class Button_DataType extends AbstractStructBase
{
    /**
     * The Button_Shape_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to button shape for brand.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Button_Shape_Reference;
    /**
     * The Primary_Buttons_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Primary_Buttons_DataType
     */
    public $Primary_Buttons_Data;
    /**
     * The Secondary_Buttons_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Secondary_Buttons_DataType
     */
    public $Secondary_Buttons_Data;
    /**
     * Constructor method for Button_DataType
     * @uses Button_DataType::setButton_Shape_Reference()
     * @uses Button_DataType::setPrimary_Buttons_Data()
     * @uses Button_DataType::setSecondary_Buttons_Data()
     * @param \StructType\Unique_IdentifierObjectType $button_Shape_Reference
     * @param \StructType\Primary_Buttons_DataType $primary_Buttons_Data
     * @param \StructType\Secondary_Buttons_DataType $secondary_Buttons_Data
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $button_Shape_Reference = null, \StructType\Primary_Buttons_DataType $primary_Buttons_Data = null, \StructType\Secondary_Buttons_DataType $secondary_Buttons_Data = null)
    {
        $this
            ->setButton_Shape_Reference($button_Shape_Reference)
            ->setPrimary_Buttons_Data($primary_Buttons_Data)
            ->setSecondary_Buttons_Data($secondary_Buttons_Data);
    }
    /**
     * Get Button_Shape_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getButton_Shape_Reference()
    {
        return $this->Button_Shape_Reference;
    }
    /**
     * Set Button_Shape_Reference value
     * @param \StructType\Unique_IdentifierObjectType $button_Shape_Reference
     * @return \StructType\Button_DataType
     */
    public function setButton_Shape_Reference(\StructType\Unique_IdentifierObjectType $button_Shape_Reference = null)
    {
        $this->Button_Shape_Reference = $button_Shape_Reference;
        return $this;
    }
    /**
     * Get Primary_Buttons_Data value
     * @return \StructType\Primary_Buttons_DataType|null
     */
    public function getPrimary_Buttons_Data()
    {
        return $this->Primary_Buttons_Data;
    }
    /**
     * Set Primary_Buttons_Data value
     * @param \StructType\Primary_Buttons_DataType $primary_Buttons_Data
     * @return \StructType\Button_DataType
     */
    public function setPrimary_Buttons_Data(\StructType\Primary_Buttons_DataType $primary_Buttons_Data = null)
    {
        $this->Primary_Buttons_Data = $primary_Buttons_Data;
        return $this;
    }
    /**
     * Get Secondary_Buttons_Data value
     * @return \StructType\Secondary_Buttons_DataType|null
     */
    public function getSecondary_Buttons_Data()
    {
        return $this->Secondary_Buttons_Data;
    }
    /**
     * Set Secondary_Buttons_Data value
     * @param \StructType\Secondary_Buttons_DataType $secondary_Buttons_Data
     * @return \StructType\Button_DataType
     */
    public function setSecondary_Buttons_Data(\StructType\Secondary_Buttons_DataType $secondary_Buttons_Data = null)
    {
        $this->Secondary_Buttons_Data = $secondary_Buttons_Data;
        return $this;
    }
}
