<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Candidate_Pool_Membership_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Candidate pool membership and readiness status for the candidate.
 * @subpackage Structs
 */
class Candidate_Pool_Membership_DataType extends AbstractStructBase
{
    /**
     * The Static_Candidate_Pool_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the static candidate pool for the candidate.
     * @var \StructType\Static_Candidate_PoolObjectType
     */
    public $Static_Candidate_Pool_Reference;
    /**
     * The Readiness_Status_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the candidate readiness status for the pool for candidate.
     * - minOccurs: 0
     * @var \StructType\Candidate_Readiness_StatusObjectType
     */
    public $Readiness_Status_Reference;
    /**
     * Constructor method for Candidate_Pool_Membership_DataType
     * @uses Candidate_Pool_Membership_DataType::setStatic_Candidate_Pool_Reference()
     * @uses Candidate_Pool_Membership_DataType::setReadiness_Status_Reference()
     * @param \StructType\Static_Candidate_PoolObjectType $static_Candidate_Pool_Reference
     * @param \StructType\Candidate_Readiness_StatusObjectType $readiness_Status_Reference
     */
    public function __construct(\StructType\Static_Candidate_PoolObjectType $static_Candidate_Pool_Reference = null, \StructType\Candidate_Readiness_StatusObjectType $readiness_Status_Reference = null)
    {
        $this
            ->setStatic_Candidate_Pool_Reference($static_Candidate_Pool_Reference)
            ->setReadiness_Status_Reference($readiness_Status_Reference);
    }
    /**
     * Get Static_Candidate_Pool_Reference value
     * @return \StructType\Static_Candidate_PoolObjectType|null
     */
    public function getStatic_Candidate_Pool_Reference()
    {
        return $this->Static_Candidate_Pool_Reference;
    }
    /**
     * Set Static_Candidate_Pool_Reference value
     * @param \StructType\Static_Candidate_PoolObjectType $static_Candidate_Pool_Reference
     * @return \StructType\Candidate_Pool_Membership_DataType
     */
    public function setStatic_Candidate_Pool_Reference(\StructType\Static_Candidate_PoolObjectType $static_Candidate_Pool_Reference = null)
    {
        $this->Static_Candidate_Pool_Reference = $static_Candidate_Pool_Reference;
        return $this;
    }
    /**
     * Get Readiness_Status_Reference value
     * @return \StructType\Candidate_Readiness_StatusObjectType|null
     */
    public function getReadiness_Status_Reference()
    {
        return $this->Readiness_Status_Reference;
    }
    /**
     * Set Readiness_Status_Reference value
     * @param \StructType\Candidate_Readiness_StatusObjectType $readiness_Status_Reference
     * @return \StructType\Candidate_Pool_Membership_DataType
     */
    public function setReadiness_Status_Reference(\StructType\Candidate_Readiness_StatusObjectType $readiness_Status_Reference = null)
    {
        $this->Readiness_Status_Reference = $readiness_Status_Reference;
        return $this;
    }
}
