<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Candidate_Reference_CriteriaType StructType
 * Meta information extracted from the WSDL
 * - documentation: The candidate for the reference check event.
 * @subpackage Structs
 */
class Candidate_Reference_CriteriaType extends AbstractStructBase
{
    /**
     * The Candidate_Reference
     * Meta information extracted from the WSDL
     * - documentation: The candidate for the reference check event.
     * @var \StructType\CandidateObjectType
     */
    public $Candidate_Reference;
    /**
     * The Job_Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: The job that the candidate applied for.
     * - minOccurs: 0
     * @var \StructType\Job_Requisition_EnabledObjectType
     */
    public $Job_Requisition_Reference;
    /**
     * Constructor method for Candidate_Reference_CriteriaType
     * @uses Candidate_Reference_CriteriaType::setCandidate_Reference()
     * @uses Candidate_Reference_CriteriaType::setJob_Requisition_Reference()
     * @param \StructType\CandidateObjectType $candidate_Reference
     * @param \StructType\Job_Requisition_EnabledObjectType $job_Requisition_Reference
     */
    public function __construct(\StructType\CandidateObjectType $candidate_Reference = null, \StructType\Job_Requisition_EnabledObjectType $job_Requisition_Reference = null)
    {
        $this
            ->setCandidate_Reference($candidate_Reference)
            ->setJob_Requisition_Reference($job_Requisition_Reference);
    }
    /**
     * Get Candidate_Reference value
     * @return \StructType\CandidateObjectType|null
     */
    public function getCandidate_Reference()
    {
        return $this->Candidate_Reference;
    }
    /**
     * Set Candidate_Reference value
     * @param \StructType\CandidateObjectType $candidate_Reference
     * @return \StructType\Candidate_Reference_CriteriaType
     */
    public function setCandidate_Reference(\StructType\CandidateObjectType $candidate_Reference = null)
    {
        $this->Candidate_Reference = $candidate_Reference;
        return $this;
    }
    /**
     * Get Job_Requisition_Reference value
     * @return \StructType\Job_Requisition_EnabledObjectType|null
     */
    public function getJob_Requisition_Reference()
    {
        return $this->Job_Requisition_Reference;
    }
    /**
     * Set Job_Requisition_Reference value
     * @param \StructType\Job_Requisition_EnabledObjectType $job_Requisition_Reference
     * @return \StructType\Candidate_Reference_CriteriaType
     */
    public function setJob_Requisition_Reference(\StructType\Job_Requisition_EnabledObjectType $job_Requisition_Reference = null)
    {
        $this->Job_Requisition_Reference = $job_Requisition_Reference;
        return $this;
    }
}
