<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Candidate_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains candidate references.
 * @subpackage Structs
 */
class Candidate_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Candidate_Reference
     * Meta information extracted from the WSDL
     * - documentation: Candidate Request References
     * - maxOccurs: unbounded
     * @var \StructType\CandidateObjectType[]
     */
    public $Candidate_Reference;
    /**
     * The Skip_Non_Existing_Instances
     * @var bool
     */
    public $Skip_Non_Existing_Instances;
    /**
     * Constructor method for Candidate_Request_ReferencesType
     * @uses Candidate_Request_ReferencesType::setCandidate_Reference()
     * @uses Candidate_Request_ReferencesType::setSkip_Non_Existing_Instances()
     * @param \StructType\CandidateObjectType[] $candidate_Reference
     * @param bool $skip_Non_Existing_Instances
     */
    public function __construct(array $candidate_Reference = array(), $skip_Non_Existing_Instances = null)
    {
        $this
            ->setCandidate_Reference($candidate_Reference)
            ->setSkip_Non_Existing_Instances($skip_Non_Existing_Instances);
    }
    /**
     * Get Candidate_Reference value
     * @return \StructType\CandidateObjectType[]|null
     */
    public function getCandidate_Reference()
    {
        return $this->Candidate_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setCandidate_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCandidate_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCandidate_ReferenceForArrayConstraintsFromSetCandidate_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $candidate_Request_ReferencesTypeCandidate_ReferenceItem) {
            // validation for constraint: itemType
            if (!$candidate_Request_ReferencesTypeCandidate_ReferenceItem instanceof \StructType\CandidateObjectType) {
                $invalidValues[] = is_object($candidate_Request_ReferencesTypeCandidate_ReferenceItem) ? get_class($candidate_Request_ReferencesTypeCandidate_ReferenceItem) : sprintf('%s(%s)', gettype($candidate_Request_ReferencesTypeCandidate_ReferenceItem), var_export($candidate_Request_ReferencesTypeCandidate_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Candidate_Reference property can only contain items of type \StructType\CandidateObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Candidate_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\CandidateObjectType[] $candidate_Reference
     * @return \StructType\Candidate_Request_ReferencesType
     */
    public function setCandidate_Reference(array $candidate_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($candidate_ReferenceArrayErrorMessage = self::validateCandidate_ReferenceForArrayConstraintsFromSetCandidate_Reference($candidate_Reference))) {
            throw new \InvalidArgumentException($candidate_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Candidate_Reference = $candidate_Reference;
        return $this;
    }
    /**
     * Add item to Candidate_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\CandidateObjectType $item
     * @return \StructType\Candidate_Request_ReferencesType
     */
    public function addToCandidate_Reference(\StructType\CandidateObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CandidateObjectType) {
            throw new \InvalidArgumentException(sprintf('The Candidate_Reference property can only contain items of type \StructType\CandidateObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Candidate_Reference[] = $item;
        return $this;
    }
    /**
     * Get Skip_Non_Existing_Instances value
     * @return bool|null
     */
    public function getSkip_Non_Existing_Instances()
    {
        return $this->Skip_Non_Existing_Instances;
    }
    /**
     * Set Skip_Non_Existing_Instances value
     * @param bool $skip_Non_Existing_Instances
     * @return \StructType\Candidate_Request_ReferencesType
     */
    public function setSkip_Non_Existing_Instances($skip_Non_Existing_Instances = null)
    {
        // validation for constraint: boolean
        if (!is_null($skip_Non_Existing_Instances) && !is_bool($skip_Non_Existing_Instances)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($skip_Non_Existing_Instances, true), gettype($skip_Non_Existing_Instances)), __LINE__);
        }
        $this->Skip_Non_Existing_Instances = $skip_Non_Existing_Instances;
        return $this;
    }
}
