<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Close_Evergreen_Requisition_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper for Close Evergreen Requisition Web Service
 * @subpackage Structs
 */
class Close_Evergreen_Requisition_RequestType extends AbstractStructBase
{
    /**
     * The Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - documentation: Container for the processing options for a business process. If no options are submitted (or the options are submitted as 'false') then the business process is simply initiated as if it where submitted on-line with approvals,
     * reviews, notifications and to-do's in place.
     * - minOccurs: 0
     * @var \StructType\Business_Process_ParametersType
     */
    public $Business_Process_Parameters;
    /**
     * The Close_Evergreen_Requisition_Data
     * Meta information extracted from the WSDL
     * - documentation: Wrapper element for the closing of an Evergreen Requisition
     * @var \StructType\Close_Evergreen_Requisition_DataType
     */
    public $Close_Evergreen_Requisition_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Close_Evergreen_Requisition_RequestType
     * @uses Close_Evergreen_Requisition_RequestType::setBusiness_Process_Parameters()
     * @uses Close_Evergreen_Requisition_RequestType::setClose_Evergreen_Requisition_Data()
     * @uses Close_Evergreen_Requisition_RequestType::setVersion()
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @param \StructType\Close_Evergreen_Requisition_DataType $close_Evergreen_Requisition_Data
     * @param string $version
     */
    public function __construct(\StructType\Business_Process_ParametersType $business_Process_Parameters = null, \StructType\Close_Evergreen_Requisition_DataType $close_Evergreen_Requisition_Data = null, $version = null)
    {
        $this
            ->setBusiness_Process_Parameters($business_Process_Parameters)
            ->setClose_Evergreen_Requisition_Data($close_Evergreen_Requisition_Data)
            ->setVersion($version);
    }
    /**
     * Get Business_Process_Parameters value
     * @return \StructType\Business_Process_ParametersType|null
     */
    public function getBusiness_Process_Parameters()
    {
        return $this->Business_Process_Parameters;
    }
    /**
     * Set Business_Process_Parameters value
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @return \StructType\Close_Evergreen_Requisition_RequestType
     */
    public function setBusiness_Process_Parameters(\StructType\Business_Process_ParametersType $business_Process_Parameters = null)
    {
        $this->Business_Process_Parameters = $business_Process_Parameters;
        return $this;
    }
    /**
     * Get Close_Evergreen_Requisition_Data value
     * @return \StructType\Close_Evergreen_Requisition_DataType|null
     */
    public function getClose_Evergreen_Requisition_Data()
    {
        return $this->Close_Evergreen_Requisition_Data;
    }
    /**
     * Set Close_Evergreen_Requisition_Data value
     * @param \StructType\Close_Evergreen_Requisition_DataType $close_Evergreen_Requisition_Data
     * @return \StructType\Close_Evergreen_Requisition_RequestType
     */
    public function setClose_Evergreen_Requisition_Data(\StructType\Close_Evergreen_Requisition_DataType $close_Evergreen_Requisition_Data = null)
    {
        $this->Close_Evergreen_Requisition_Data = $close_Evergreen_Requisition_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Close_Evergreen_Requisition_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
