<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Close_Evergreen_Requisition_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Responds with the event id for the Close Evergreen Job Requisition Event and the Evergreen Requisition Reference.
 * @subpackage Structs
 */
class Close_Evergreen_Requisition_ResponseType extends AbstractStructBase
{
    /**
     * The Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the Close Evergreen Job Requisition Event.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Event_Reference;
    /**
     * The Evergreen_Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the closed Evergreen Requisition.
     * - minOccurs: 0
     * @var \StructType\Evergreen_Job_RequisitionObjectType
     */
    public $Evergreen_Requisition_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Close_Evergreen_Requisition_ResponseType
     * @uses Close_Evergreen_Requisition_ResponseType::setEvent_Reference()
     * @uses Close_Evergreen_Requisition_ResponseType::setEvergreen_Requisition_Reference()
     * @uses Close_Evergreen_Requisition_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $event_Reference
     * @param \StructType\Evergreen_Job_RequisitionObjectType $evergreen_Requisition_Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $event_Reference = null, \StructType\Evergreen_Job_RequisitionObjectType $evergreen_Requisition_Reference = null, $version = null)
    {
        $this
            ->setEvent_Reference($event_Reference)
            ->setEvergreen_Requisition_Reference($evergreen_Requisition_Reference)
            ->setVersion($version);
    }
    /**
     * Get Event_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getEvent_Reference()
    {
        return $this->Event_Reference;
    }
    /**
     * Set Event_Reference value
     * @param \StructType\Unique_IdentifierObjectType $event_Reference
     * @return \StructType\Close_Evergreen_Requisition_ResponseType
     */
    public function setEvent_Reference(\StructType\Unique_IdentifierObjectType $event_Reference = null)
    {
        $this->Event_Reference = $event_Reference;
        return $this;
    }
    /**
     * Get Evergreen_Requisition_Reference value
     * @return \StructType\Evergreen_Job_RequisitionObjectType|null
     */
    public function getEvergreen_Requisition_Reference()
    {
        return $this->Evergreen_Requisition_Reference;
    }
    /**
     * Set Evergreen_Requisition_Reference value
     * @param \StructType\Evergreen_Job_RequisitionObjectType $evergreen_Requisition_Reference
     * @return \StructType\Close_Evergreen_Requisition_ResponseType
     */
    public function setEvergreen_Requisition_Reference(\StructType\Evergreen_Job_RequisitionObjectType $evergreen_Requisition_Reference = null)
    {
        $this->Evergreen_Requisition_Reference = $evergreen_Requisition_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Close_Evergreen_Requisition_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
