<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Communication_Usage_BehaviorObjectType StructType
 * @subpackage Structs
 */
class Communication_Usage_BehaviorObjectType extends AbstractStructBase
{
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Communication_Usage_BehaviorObjectIDType[]
     */
    public $ID;
    /**
     * The Descriptor
     * Meta information extracted from the WSDL
     * - documentation: Display information used to describe an instance of an object. This 'optional' information is for outbound descriptive purposes only and is not processed on inbound Workday Web Services requests.
     * @var string
     */
    public $Descriptor;
    /**
     * Constructor method for Communication_Usage_BehaviorObjectType
     * @uses Communication_Usage_BehaviorObjectType::setID()
     * @uses Communication_Usage_BehaviorObjectType::setDescriptor()
     * @param \StructType\Communication_Usage_BehaviorObjectIDType[] $iD
     * @param string $descriptor
     */
    public function __construct(array $iD = array(), $descriptor = null)
    {
        $this
            ->setID($iD)
            ->setDescriptor($descriptor);
    }
    /**
     * Get ID value
     * @return \StructType\Communication_Usage_BehaviorObjectIDType[]|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * This method is responsible for validating the values passed to the setID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIDForArrayConstraintsFromSetID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $communication_Usage_BehaviorObjectTypeIDItem) {
            // validation for constraint: itemType
            if (!$communication_Usage_BehaviorObjectTypeIDItem instanceof \StructType\Communication_Usage_BehaviorObjectIDType) {
                $invalidValues[] = is_object($communication_Usage_BehaviorObjectTypeIDItem) ? get_class($communication_Usage_BehaviorObjectTypeIDItem) : sprintf('%s(%s)', gettype($communication_Usage_BehaviorObjectTypeIDItem), var_export($communication_Usage_BehaviorObjectTypeIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ID property can only contain items of type \StructType\Communication_Usage_BehaviorObjectIDType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ID value
     * @throws \InvalidArgumentException
     * @param \StructType\Communication_Usage_BehaviorObjectIDType[] $iD
     * @return \StructType\Communication_Usage_BehaviorObjectType
     */
    public function setID(array $iD = array())
    {
        // validation for constraint: array
        if ('' !== ($iDArrayErrorMessage = self::validateIDForArrayConstraintsFromSetID($iD))) {
            throw new \InvalidArgumentException($iDArrayErrorMessage, __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Add item to ID value
     * @throws \InvalidArgumentException
     * @param \StructType\Communication_Usage_BehaviorObjectIDType $item
     * @return \StructType\Communication_Usage_BehaviorObjectType
     */
    public function addToID(\StructType\Communication_Usage_BehaviorObjectIDType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Communication_Usage_BehaviorObjectIDType) {
            throw new \InvalidArgumentException(sprintf('The ID property can only contain items of type \StructType\Communication_Usage_BehaviorObjectIDType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ID[] = $item;
        return $this;
    }
    /**
     * Get Descriptor value
     * @return string|null
     */
    public function getDescriptor()
    {
        return $this->Descriptor;
    }
    /**
     * Set Descriptor value
     * @param string $descriptor
     * @return \StructType\Communication_Usage_BehaviorObjectType
     */
    public function setDescriptor($descriptor = null)
    {
        // validation for constraint: string
        if (!is_null($descriptor) && !is_string($descriptor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descriptor, true), gettype($descriptor)), __LINE__);
        }
        $this->Descriptor = $descriptor;
        return $this;
    }
}
