<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_Maintain_Candidate_List_Assignment_ResponseType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Get Maintain Candidate List Assignment Response
 * @subpackage Structs
 */
class Get_Maintain_Candidate_List_Assignment_ResponseType extends AbstractStructBase
{
    /**
     * The Response_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to existing Candidate List Assignment
     * - minOccurs: 0
     * @var \StructType\Candidate_List_Assignment_Request_ReferencesType
     */
    public $Response_Reference;
    /**
     * The Response_Filter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Response_FilterType
     */
    public $Response_Filter;
    /**
     * The Response_Group
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Maintain_Candidate_List_Assignment_Response_GroupType
     */
    public $Response_Group;
    /**
     * The Response_Results
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Response_ResultsType
     */
    public $Response_Results;
    /**
     * The Response_Data
     * Meta information extracted from the WSDL
     * - documentation: Candidate List Assignment Response Data
     * - minOccurs: 0
     * @var \StructType\Maintain_Candidate_List_Assignment_Response_DataType
     */
    public $Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Get_Maintain_Candidate_List_Assignment_ResponseType
     * @uses Get_Maintain_Candidate_List_Assignment_ResponseType::setResponse_Reference()
     * @uses Get_Maintain_Candidate_List_Assignment_ResponseType::setResponse_Filter()
     * @uses Get_Maintain_Candidate_List_Assignment_ResponseType::setResponse_Group()
     * @uses Get_Maintain_Candidate_List_Assignment_ResponseType::setResponse_Results()
     * @uses Get_Maintain_Candidate_List_Assignment_ResponseType::setResponse_Data()
     * @uses Get_Maintain_Candidate_List_Assignment_ResponseType::setVersion()
     * @param \StructType\Candidate_List_Assignment_Request_ReferencesType $response_Reference
     * @param \StructType\Response_FilterType $response_Filter
     * @param \StructType\Maintain_Candidate_List_Assignment_Response_GroupType $response_Group
     * @param \StructType\Response_ResultsType $response_Results
     * @param \StructType\Maintain_Candidate_List_Assignment_Response_DataType $response_Data
     * @param string $version
     */
    public function __construct(\StructType\Candidate_List_Assignment_Request_ReferencesType $response_Reference = null, \StructType\Response_FilterType $response_Filter = null, \StructType\Maintain_Candidate_List_Assignment_Response_GroupType $response_Group = null, \StructType\Response_ResultsType $response_Results = null, \StructType\Maintain_Candidate_List_Assignment_Response_DataType $response_Data = null, $version = null)
    {
        $this
            ->setResponse_Reference($response_Reference)
            ->setResponse_Filter($response_Filter)
            ->setResponse_Group($response_Group)
            ->setResponse_Results($response_Results)
            ->setResponse_Data($response_Data)
            ->setVersion($version);
    }
    /**
     * Get Response_Reference value
     * @return \StructType\Candidate_List_Assignment_Request_ReferencesType|null
     */
    public function getResponse_Reference()
    {
        return $this->Response_Reference;
    }
    /**
     * Set Response_Reference value
     * @param \StructType\Candidate_List_Assignment_Request_ReferencesType $response_Reference
     * @return \StructType\Get_Maintain_Candidate_List_Assignment_ResponseType
     */
    public function setResponse_Reference(\StructType\Candidate_List_Assignment_Request_ReferencesType $response_Reference = null)
    {
        $this->Response_Reference = $response_Reference;
        return $this;
    }
    /**
     * Get Response_Filter value
     * @return \StructType\Response_FilterType|null
     */
    public function getResponse_Filter()
    {
        return $this->Response_Filter;
    }
    /**
     * Set Response_Filter value
     * @param \StructType\Response_FilterType $response_Filter
     * @return \StructType\Get_Maintain_Candidate_List_Assignment_ResponseType
     */
    public function setResponse_Filter(\StructType\Response_FilterType $response_Filter = null)
    {
        $this->Response_Filter = $response_Filter;
        return $this;
    }
    /**
     * Get Response_Group value
     * @return \StructType\Maintain_Candidate_List_Assignment_Response_GroupType|null
     */
    public function getResponse_Group()
    {
        return $this->Response_Group;
    }
    /**
     * Set Response_Group value
     * @param \StructType\Maintain_Candidate_List_Assignment_Response_GroupType $response_Group
     * @return \StructType\Get_Maintain_Candidate_List_Assignment_ResponseType
     */
    public function setResponse_Group(\StructType\Maintain_Candidate_List_Assignment_Response_GroupType $response_Group = null)
    {
        $this->Response_Group = $response_Group;
        return $this;
    }
    /**
     * Get Response_Results value
     * @return \StructType\Response_ResultsType|null
     */
    public function getResponse_Results()
    {
        return $this->Response_Results;
    }
    /**
     * Set Response_Results value
     * @param \StructType\Response_ResultsType $response_Results
     * @return \StructType\Get_Maintain_Candidate_List_Assignment_ResponseType
     */
    public function setResponse_Results(\StructType\Response_ResultsType $response_Results = null)
    {
        $this->Response_Results = $response_Results;
        return $this;
    }
    /**
     * Get Response_Data value
     * @return \StructType\Maintain_Candidate_List_Assignment_Response_DataType|null
     */
    public function getResponse_Data()
    {
        return $this->Response_Data;
    }
    /**
     * Set Response_Data value
     * @param \StructType\Maintain_Candidate_List_Assignment_Response_DataType $response_Data
     * @return \StructType\Get_Maintain_Candidate_List_Assignment_ResponseType
     */
    public function setResponse_Data(\StructType\Maintain_Candidate_List_Assignment_Response_DataType $response_Data = null)
    {
        $this->Response_Data = $response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Get_Maintain_Candidate_List_Assignment_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
