<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_Veteran_Statuses_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains request reference, criteria, filter and response group for getting Veteran Status data.
 * @subpackage Structs
 */
class Get_Veteran_Statuses_ResponseType extends AbstractStructBase
{
    /**
     * The Request_References
     * Meta information extracted from the WSDL
     * - documentation: Contains Veteran Status references.
     * - minOccurs: 0
     * @var \StructType\Veteran_Status_Request_ReferencesType
     */
    public $Request_References;
    /**
     * The Request_Criteria
     * Meta information extracted from the WSDL
     * - documentation: Utilize the following criteria options to search for Veteran Statuses within the Workday system. The Veteran Status references that are returned are those that satisfy ALL criteria included in the request. Therefore, the result set
     * will become more limited with every criterium that is populated.
     * - minOccurs: 0
     * @var \StructType\Veteran_Status_Request_CriteriaType
     */
    public $Request_Criteria;
    /**
     * The Response_Filter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Response_FilterType
     */
    public $Response_Filter;
    /**
     * The Response_Results
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Response_ResultsType
     */
    public $Response_Results;
    /**
     * The Response_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains Veteran Status data.
     * - minOccurs: 0
     * @var \StructType\Veteran_Status_Response_DataType
     */
    public $Response_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Get_Veteran_Statuses_ResponseType
     * @uses Get_Veteran_Statuses_ResponseType::setRequest_References()
     * @uses Get_Veteran_Statuses_ResponseType::setRequest_Criteria()
     * @uses Get_Veteran_Statuses_ResponseType::setResponse_Filter()
     * @uses Get_Veteran_Statuses_ResponseType::setResponse_Results()
     * @uses Get_Veteran_Statuses_ResponseType::setResponse_Data()
     * @uses Get_Veteran_Statuses_ResponseType::setVersion()
     * @param \StructType\Veteran_Status_Request_ReferencesType $request_References
     * @param \StructType\Veteran_Status_Request_CriteriaType $request_Criteria
     * @param \StructType\Response_FilterType $response_Filter
     * @param \StructType\Response_ResultsType $response_Results
     * @param \StructType\Veteran_Status_Response_DataType $response_Data
     * @param string $version
     */
    public function __construct(\StructType\Veteran_Status_Request_ReferencesType $request_References = null, \StructType\Veteran_Status_Request_CriteriaType $request_Criteria = null, \StructType\Response_FilterType $response_Filter = null, \StructType\Response_ResultsType $response_Results = null, \StructType\Veteran_Status_Response_DataType $response_Data = null, $version = null)
    {
        $this
            ->setRequest_References($request_References)
            ->setRequest_Criteria($request_Criteria)
            ->setResponse_Filter($response_Filter)
            ->setResponse_Results($response_Results)
            ->setResponse_Data($response_Data)
            ->setVersion($version);
    }
    /**
     * Get Request_References value
     * @return \StructType\Veteran_Status_Request_ReferencesType|null
     */
    public function getRequest_References()
    {
        return $this->Request_References;
    }
    /**
     * Set Request_References value
     * @param \StructType\Veteran_Status_Request_ReferencesType $request_References
     * @return \StructType\Get_Veteran_Statuses_ResponseType
     */
    public function setRequest_References(\StructType\Veteran_Status_Request_ReferencesType $request_References = null)
    {
        $this->Request_References = $request_References;
        return $this;
    }
    /**
     * Get Request_Criteria value
     * @return \StructType\Veteran_Status_Request_CriteriaType|null
     */
    public function getRequest_Criteria()
    {
        return $this->Request_Criteria;
    }
    /**
     * Set Request_Criteria value
     * @param \StructType\Veteran_Status_Request_CriteriaType $request_Criteria
     * @return \StructType\Get_Veteran_Statuses_ResponseType
     */
    public function setRequest_Criteria(\StructType\Veteran_Status_Request_CriteriaType $request_Criteria = null)
    {
        $this->Request_Criteria = $request_Criteria;
        return $this;
    }
    /**
     * Get Response_Filter value
     * @return \StructType\Response_FilterType|null
     */
    public function getResponse_Filter()
    {
        return $this->Response_Filter;
    }
    /**
     * Set Response_Filter value
     * @param \StructType\Response_FilterType $response_Filter
     * @return \StructType\Get_Veteran_Statuses_ResponseType
     */
    public function setResponse_Filter(\StructType\Response_FilterType $response_Filter = null)
    {
        $this->Response_Filter = $response_Filter;
        return $this;
    }
    /**
     * Get Response_Results value
     * @return \StructType\Response_ResultsType|null
     */
    public function getResponse_Results()
    {
        return $this->Response_Results;
    }
    /**
     * Set Response_Results value
     * @param \StructType\Response_ResultsType $response_Results
     * @return \StructType\Get_Veteran_Statuses_ResponseType
     */
    public function setResponse_Results(\StructType\Response_ResultsType $response_Results = null)
    {
        $this->Response_Results = $response_Results;
        return $this;
    }
    /**
     * Get Response_Data value
     * @return \StructType\Veteran_Status_Response_DataType|null
     */
    public function getResponse_Data()
    {
        return $this->Response_Data;
    }
    /**
     * Set Response_Data value
     * @param \StructType\Veteran_Status_Response_DataType $response_Data
     * @return \StructType\Get_Veteran_Statuses_ResponseType
     */
    public function setResponse_Data(\StructType\Veteran_Status_Response_DataType $response_Data = null)
    {
        $this->Response_Data = $response_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Get_Veteran_Statuses_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
