<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Interview_Feedback_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains the interview reference.
 * @subpackage Structs
 */
class Interview_Feedback_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Interview_Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: Interview Feedback Request Reference
     * - maxOccurs: unbounded
     * @var \StructType\Unique_IdentifierObjectType[]
     */
    public $Interview_Event_Reference;
    /**
     * Constructor method for Interview_Feedback_Request_ReferencesType
     * @uses Interview_Feedback_Request_ReferencesType::setInterview_Event_Reference()
     * @param \StructType\Unique_IdentifierObjectType[] $interview_Event_Reference
     */
    public function __construct(array $interview_Event_Reference = array())
    {
        $this
            ->setInterview_Event_Reference($interview_Event_Reference);
    }
    /**
     * Get Interview_Event_Reference value
     * @return \StructType\Unique_IdentifierObjectType[]|null
     */
    public function getInterview_Event_Reference()
    {
        return $this->Interview_Event_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setInterview_Event_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterview_Event_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterview_Event_ReferenceForArrayConstraintsFromSetInterview_Event_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $interview_Feedback_Request_ReferencesTypeInterview_Event_ReferenceItem) {
            // validation for constraint: itemType
            if (!$interview_Feedback_Request_ReferencesTypeInterview_Event_ReferenceItem instanceof \StructType\Unique_IdentifierObjectType) {
                $invalidValues[] = is_object($interview_Feedback_Request_ReferencesTypeInterview_Event_ReferenceItem) ? get_class($interview_Feedback_Request_ReferencesTypeInterview_Event_ReferenceItem) : sprintf('%s(%s)', gettype($interview_Feedback_Request_ReferencesTypeInterview_Event_ReferenceItem), var_export($interview_Feedback_Request_ReferencesTypeInterview_Event_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Interview_Event_Reference property can only contain items of type \StructType\Unique_IdentifierObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Interview_Event_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Unique_IdentifierObjectType[] $interview_Event_Reference
     * @return \StructType\Interview_Feedback_Request_ReferencesType
     */
    public function setInterview_Event_Reference(array $interview_Event_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($interview_Event_ReferenceArrayErrorMessage = self::validateInterview_Event_ReferenceForArrayConstraintsFromSetInterview_Event_Reference($interview_Event_Reference))) {
            throw new \InvalidArgumentException($interview_Event_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Interview_Event_Reference = $interview_Event_Reference;
        return $this;
    }
    /**
     * Add item to Interview_Event_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Unique_IdentifierObjectType $item
     * @return \StructType\Interview_Feedback_Request_ReferencesType
     */
    public function addToInterview_Event_Reference(\StructType\Unique_IdentifierObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Unique_IdentifierObjectType) {
            throw new \InvalidArgumentException(sprintf('The Interview_Event_Reference property can only contain items of type \StructType\Unique_IdentifierObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Interview_Event_Reference[] = $item;
        return $this;
    }
}
