<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Interview_Questionnaire_DataType StructType
 * Meta information extracted from the WSDL
 * - documentation: Interview Feedback Details
 * @subpackage Structs
 */
class Interview_Questionnaire_DataType extends AbstractStructBase
{
    /**
     * The Questionnaires_Response_Data
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Questionnaires_Response_DataType[]
     */
    public $Questionnaires_Response_Data;
    /**
     * Constructor method for Interview_Questionnaire_DataType
     * @uses Interview_Questionnaire_DataType::setQuestionnaires_Response_Data()
     * @param \StructType\Questionnaires_Response_DataType[] $questionnaires_Response_Data
     */
    public function __construct(array $questionnaires_Response_Data = array())
    {
        $this
            ->setQuestionnaires_Response_Data($questionnaires_Response_Data);
    }
    /**
     * Get Questionnaires_Response_Data value
     * @return \StructType\Questionnaires_Response_DataType[]|null
     */
    public function getQuestionnaires_Response_Data()
    {
        return $this->Questionnaires_Response_Data;
    }
    /**
     * This method is responsible for validating the values passed to the setQuestionnaires_Response_Data method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuestionnaires_Response_Data method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuestionnaires_Response_DataForArrayConstraintsFromSetQuestionnaires_Response_Data(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $interview_Questionnaire_DataTypeQuestionnaires_Response_DataItem) {
            // validation for constraint: itemType
            if (!$interview_Questionnaire_DataTypeQuestionnaires_Response_DataItem instanceof \StructType\Questionnaires_Response_DataType) {
                $invalidValues[] = is_object($interview_Questionnaire_DataTypeQuestionnaires_Response_DataItem) ? get_class($interview_Questionnaire_DataTypeQuestionnaires_Response_DataItem) : sprintf('%s(%s)', gettype($interview_Questionnaire_DataTypeQuestionnaires_Response_DataItem), var_export($interview_Questionnaire_DataTypeQuestionnaires_Response_DataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Questionnaires_Response_Data property can only contain items of type \StructType\Questionnaires_Response_DataType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Questionnaires_Response_Data value
     * @throws \InvalidArgumentException
     * @param \StructType\Questionnaires_Response_DataType[] $questionnaires_Response_Data
     * @return \StructType\Interview_Questionnaire_DataType
     */
    public function setQuestionnaires_Response_Data(array $questionnaires_Response_Data = array())
    {
        // validation for constraint: array
        if ('' !== ($questionnaires_Response_DataArrayErrorMessage = self::validateQuestionnaires_Response_DataForArrayConstraintsFromSetQuestionnaires_Response_Data($questionnaires_Response_Data))) {
            throw new \InvalidArgumentException($questionnaires_Response_DataArrayErrorMessage, __LINE__);
        }
        $this->Questionnaires_Response_Data = $questionnaires_Response_Data;
        return $this;
    }
    /**
     * Add item to Questionnaires_Response_Data value
     * @throws \InvalidArgumentException
     * @param \StructType\Questionnaires_Response_DataType $item
     * @return \StructType\Interview_Questionnaire_DataType
     */
    public function addToQuestionnaires_Response_Data(\StructType\Questionnaires_Response_DataType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Questionnaires_Response_DataType) {
            throw new \InvalidArgumentException(sprintf('The Questionnaires_Response_Data property can only contain items of type \StructType\Questionnaires_Response_DataType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Questionnaires_Response_Data[] = $item;
        return $this;
    }
}
