<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Job_Application_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Job Application Reference
 * @subpackage Structs
 */
class Job_Application_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Job_Application_Reference
     * Meta information extracted from the WSDL
     * - documentation: Job Application Reference
     * - maxOccurs: unbounded
     * @var \StructType\Job_ApplicationObjectType[]
     */
    public $Job_Application_Reference;
    /**
     * Constructor method for Job_Application_Request_ReferencesType
     * @uses Job_Application_Request_ReferencesType::setJob_Application_Reference()
     * @param \StructType\Job_ApplicationObjectType[] $job_Application_Reference
     */
    public function __construct(array $job_Application_Reference = array())
    {
        $this
            ->setJob_Application_Reference($job_Application_Reference);
    }
    /**
     * Get Job_Application_Reference value
     * @return \StructType\Job_ApplicationObjectType[]|null
     */
    public function getJob_Application_Reference()
    {
        return $this->Job_Application_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setJob_Application_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJob_Application_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJob_Application_ReferenceForArrayConstraintsFromSetJob_Application_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $job_Application_Request_ReferencesTypeJob_Application_ReferenceItem) {
            // validation for constraint: itemType
            if (!$job_Application_Request_ReferencesTypeJob_Application_ReferenceItem instanceof \StructType\Job_ApplicationObjectType) {
                $invalidValues[] = is_object($job_Application_Request_ReferencesTypeJob_Application_ReferenceItem) ? get_class($job_Application_Request_ReferencesTypeJob_Application_ReferenceItem) : sprintf('%s(%s)', gettype($job_Application_Request_ReferencesTypeJob_Application_ReferenceItem), var_export($job_Application_Request_ReferencesTypeJob_Application_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Job_Application_Reference property can only contain items of type \StructType\Job_ApplicationObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Job_Application_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Job_ApplicationObjectType[] $job_Application_Reference
     * @return \StructType\Job_Application_Request_ReferencesType
     */
    public function setJob_Application_Reference(array $job_Application_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($job_Application_ReferenceArrayErrorMessage = self::validateJob_Application_ReferenceForArrayConstraintsFromSetJob_Application_Reference($job_Application_Reference))) {
            throw new \InvalidArgumentException($job_Application_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Job_Application_Reference = $job_Application_Reference;
        return $this;
    }
    /**
     * Add item to Job_Application_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Job_ApplicationObjectType $item
     * @return \StructType\Job_Application_Request_ReferencesType
     */
    public function addToJob_Application_Reference(\StructType\Job_ApplicationObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Job_ApplicationObjectType) {
            throw new \InvalidArgumentException(sprintf('The Job_Application_Reference property can only contain items of type \StructType\Job_ApplicationObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Job_Application_Reference[] = $item;
        return $this;
    }
}
