<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Job_Application_Template_Translation_Response_DataType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains translations for the Job Application Template
 * @subpackage Structs
 */
class Job_Application_Template_Translation_Response_DataType extends AbstractStructBase
{
    /**
     * The Job_Application_Template_Translation
     * Meta information extracted from the WSDL
     * - documentation: Contains translations for the Job Application Template for all translated languages or specified languages
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Job_Application_Template_TranslationType[]
     */
    public $Job_Application_Template_Translation;
    /**
     * Constructor method for Job_Application_Template_Translation_Response_DataType
     * @uses Job_Application_Template_Translation_Response_DataType::setJob_Application_Template_Translation()
     * @param \StructType\Job_Application_Template_TranslationType[] $job_Application_Template_Translation
     */
    public function __construct(array $job_Application_Template_Translation = array())
    {
        $this
            ->setJob_Application_Template_Translation($job_Application_Template_Translation);
    }
    /**
     * Get Job_Application_Template_Translation value
     * @return \StructType\Job_Application_Template_TranslationType[]|null
     */
    public function getJob_Application_Template_Translation()
    {
        return $this->Job_Application_Template_Translation;
    }
    /**
     * This method is responsible for validating the values passed to the setJob_Application_Template_Translation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJob_Application_Template_Translation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJob_Application_Template_TranslationForArrayConstraintsFromSetJob_Application_Template_Translation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $job_Application_Template_Translation_Response_DataTypeJob_Application_Template_TranslationItem) {
            // validation for constraint: itemType
            if (!$job_Application_Template_Translation_Response_DataTypeJob_Application_Template_TranslationItem instanceof \StructType\Job_Application_Template_TranslationType) {
                $invalidValues[] = is_object($job_Application_Template_Translation_Response_DataTypeJob_Application_Template_TranslationItem) ? get_class($job_Application_Template_Translation_Response_DataTypeJob_Application_Template_TranslationItem) : sprintf('%s(%s)', gettype($job_Application_Template_Translation_Response_DataTypeJob_Application_Template_TranslationItem), var_export($job_Application_Template_Translation_Response_DataTypeJob_Application_Template_TranslationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Job_Application_Template_Translation property can only contain items of type \StructType\Job_Application_Template_TranslationType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Job_Application_Template_Translation value
     * @throws \InvalidArgumentException
     * @param \StructType\Job_Application_Template_TranslationType[] $job_Application_Template_Translation
     * @return \StructType\Job_Application_Template_Translation_Response_DataType
     */
    public function setJob_Application_Template_Translation(array $job_Application_Template_Translation = array())
    {
        // validation for constraint: array
        if ('' !== ($job_Application_Template_TranslationArrayErrorMessage = self::validateJob_Application_Template_TranslationForArrayConstraintsFromSetJob_Application_Template_Translation($job_Application_Template_Translation))) {
            throw new \InvalidArgumentException($job_Application_Template_TranslationArrayErrorMessage, __LINE__);
        }
        $this->Job_Application_Template_Translation = $job_Application_Template_Translation;
        return $this;
    }
    /**
     * Add item to Job_Application_Template_Translation value
     * @throws \InvalidArgumentException
     * @param \StructType\Job_Application_Template_TranslationType $item
     * @return \StructType\Job_Application_Template_Translation_Response_DataType
     */
    public function addToJob_Application_Template_Translation(\StructType\Job_Application_Template_TranslationType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Job_Application_Template_TranslationType) {
            throw new \InvalidArgumentException(sprintf('The Job_Application_Template_Translation property can only contain items of type \StructType\Job_Application_Template_TranslationType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Job_Application_Template_Translation[] = $item;
        return $this;
    }
}
