<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Job_PostingType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains each Job Posting based on the Request References or Request Criteria.
 * @subpackage Structs
 */
class Job_PostingType extends AbstractStructBase
{
    /**
     * The Job_Posting_Reference
     * Meta information extracted from the WSDL
     * - documentation: A unique identifier to reference a Job Posting.
     * - minOccurs: 0
     * @var \StructType\Job_PostingObjectType
     */
    public $Job_Posting_Reference;
    /**
     * The Job_Posting_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains the detailed information about a Job Posting.
     * - minOccurs: 0
     * @var \StructType\Job_Posting_Data_WWSType
     */
    public $Job_Posting_Data;
    /**
     * Constructor method for Job_PostingType
     * @uses Job_PostingType::setJob_Posting_Reference()
     * @uses Job_PostingType::setJob_Posting_Data()
     * @param \StructType\Job_PostingObjectType $job_Posting_Reference
     * @param \StructType\Job_Posting_Data_WWSType $job_Posting_Data
     */
    public function __construct(\StructType\Job_PostingObjectType $job_Posting_Reference = null, \StructType\Job_Posting_Data_WWSType $job_Posting_Data = null)
    {
        $this
            ->setJob_Posting_Reference($job_Posting_Reference)
            ->setJob_Posting_Data($job_Posting_Data);
    }
    /**
     * Get Job_Posting_Reference value
     * @return \StructType\Job_PostingObjectType|null
     */
    public function getJob_Posting_Reference()
    {
        return $this->Job_Posting_Reference;
    }
    /**
     * Set Job_Posting_Reference value
     * @param \StructType\Job_PostingObjectType $job_Posting_Reference
     * @return \StructType\Job_PostingType
     */
    public function setJob_Posting_Reference(\StructType\Job_PostingObjectType $job_Posting_Reference = null)
    {
        $this->Job_Posting_Reference = $job_Posting_Reference;
        return $this;
    }
    /**
     * Get Job_Posting_Data value
     * @return \StructType\Job_Posting_Data_WWSType|null
     */
    public function getJob_Posting_Data()
    {
        return $this->Job_Posting_Data;
    }
    /**
     * Set Job_Posting_Data value
     * @param \StructType\Job_Posting_Data_WWSType $job_Posting_Data
     * @return \StructType\Job_PostingType
     */
    public function setJob_Posting_Data(\StructType\Job_Posting_Data_WWSType $job_Posting_Data = null)
    {
        $this->Job_Posting_Data = $job_Posting_Data;
        return $this;
    }
}
