<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Job_Posting_SiteType StructType
 * Meta information extracted from the WSDL
 * - documentation: Container which holds each individual Job Posting Site Data
 * @subpackage Structs
 */
class Job_Posting_SiteType extends AbstractStructBase
{
    /**
     * The Job_Posting_Site_Reference
     * Meta information extracted from the WSDL
     * - documentation: Job Posting Site(s) returned by the GET
     * - minOccurs: 0
     * @var \StructType\Job_Posting_SiteObjectType
     */
    public $Job_Posting_Site_Reference;
    /**
     * The Job_Posting_Site_Data
     * Meta information extracted from the WSDL
     * - documentation: Response Container which holds all details for the Job Posting Site(s) returned by the GET
     * - minOccurs: 0
     * @var \StructType\Job_Posting_Site_Detail_DataType
     */
    public $Job_Posting_Site_Data;
    /**
     * Constructor method for Job_Posting_SiteType
     * @uses Job_Posting_SiteType::setJob_Posting_Site_Reference()
     * @uses Job_Posting_SiteType::setJob_Posting_Site_Data()
     * @param \StructType\Job_Posting_SiteObjectType $job_Posting_Site_Reference
     * @param \StructType\Job_Posting_Site_Detail_DataType $job_Posting_Site_Data
     */
    public function __construct(\StructType\Job_Posting_SiteObjectType $job_Posting_Site_Reference = null, \StructType\Job_Posting_Site_Detail_DataType $job_Posting_Site_Data = null)
    {
        $this
            ->setJob_Posting_Site_Reference($job_Posting_Site_Reference)
            ->setJob_Posting_Site_Data($job_Posting_Site_Data);
    }
    /**
     * Get Job_Posting_Site_Reference value
     * @return \StructType\Job_Posting_SiteObjectType|null
     */
    public function getJob_Posting_Site_Reference()
    {
        return $this->Job_Posting_Site_Reference;
    }
    /**
     * Set Job_Posting_Site_Reference value
     * @param \StructType\Job_Posting_SiteObjectType $job_Posting_Site_Reference
     * @return \StructType\Job_Posting_SiteType
     */
    public function setJob_Posting_Site_Reference(\StructType\Job_Posting_SiteObjectType $job_Posting_Site_Reference = null)
    {
        $this->Job_Posting_Site_Reference = $job_Posting_Site_Reference;
        return $this;
    }
    /**
     * Get Job_Posting_Site_Data value
     * @return \StructType\Job_Posting_Site_Detail_DataType|null
     */
    public function getJob_Posting_Site_Data()
    {
        return $this->Job_Posting_Site_Data;
    }
    /**
     * Set Job_Posting_Site_Data value
     * @param \StructType\Job_Posting_Site_Detail_DataType $job_Posting_Site_Data
     * @return \StructType\Job_Posting_SiteType
     */
    public function setJob_Posting_Site_Data(\StructType\Job_Posting_Site_Detail_DataType $job_Posting_Site_Data = null)
    {
        $this->Job_Posting_Site_Data = $job_Posting_Site_Data;
        return $this;
    }
}
