<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Job_RequisitionType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains each Job Requisition based on the Request References or Request Criteria.
 * @subpackage Structs
 */
class Job_RequisitionType extends AbstractStructBase
{
    /**
     * The Job_Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: A unique identifier to reference a Job Requisition.
     * - minOccurs: 0
     * @var \StructType\Job_RequisitionObjectType
     */
    public $Job_Requisition_Reference;
    /**
     * The Job_Requisition_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains the detailed information about a Job Requisition.
     * - minOccurs: 0
     * @var \StructType\Job_Requisition_Data_2Type
     */
    public $Job_Requisition_Data;
    /**
     * Constructor method for Job_RequisitionType
     * @uses Job_RequisitionType::setJob_Requisition_Reference()
     * @uses Job_RequisitionType::setJob_Requisition_Data()
     * @param \StructType\Job_RequisitionObjectType $job_Requisition_Reference
     * @param \StructType\Job_Requisition_Data_2Type $job_Requisition_Data
     */
    public function __construct(\StructType\Job_RequisitionObjectType $job_Requisition_Reference = null, \StructType\Job_Requisition_Data_2Type $job_Requisition_Data = null)
    {
        $this
            ->setJob_Requisition_Reference($job_Requisition_Reference)
            ->setJob_Requisition_Data($job_Requisition_Data);
    }
    /**
     * Get Job_Requisition_Reference value
     * @return \StructType\Job_RequisitionObjectType|null
     */
    public function getJob_Requisition_Reference()
    {
        return $this->Job_Requisition_Reference;
    }
    /**
     * Set Job_Requisition_Reference value
     * @param \StructType\Job_RequisitionObjectType $job_Requisition_Reference
     * @return \StructType\Job_RequisitionType
     */
    public function setJob_Requisition_Reference(\StructType\Job_RequisitionObjectType $job_Requisition_Reference = null)
    {
        $this->Job_Requisition_Reference = $job_Requisition_Reference;
        return $this;
    }
    /**
     * Get Job_Requisition_Data value
     * @return \StructType\Job_Requisition_Data_2Type|null
     */
    public function getJob_Requisition_Data()
    {
        return $this->Job_Requisition_Data;
    }
    /**
     * Set Job_Requisition_Data value
     * @param \StructType\Job_Requisition_Data_2Type $job_Requisition_Data
     * @return \StructType\Job_RequisitionType
     */
    public function setJob_Requisition_Data(\StructType\Job_Requisition_Data_2Type $job_Requisition_Data = null)
    {
        $this->Job_Requisition_Data = $job_Requisition_Data;
        return $this;
    }
}
