<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Job_Requisition_Interview_Team_Request_ReferencesType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Wrapper element containing references to specific job requisitions.
 * @subpackage Structs
 */
class Job_Requisition_Interview_Team_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Job_Requisition_Interview_Team_Reference
     * Meta information extracted from the WSDL
     * - documentation: Job requisition reference.
     * - maxOccurs: unbounded
     * @var \StructType\Job_Requisition_EnabledObjectType[]
     */
    public $Job_Requisition_Interview_Team_Reference;
    /**
     * Constructor method for Job_Requisition_Interview_Team_Request_ReferencesType
     * @uses Job_Requisition_Interview_Team_Request_ReferencesType::setJob_Requisition_Interview_Team_Reference()
     * @param \StructType\Job_Requisition_EnabledObjectType[] $job_Requisition_Interview_Team_Reference
     */
    public function __construct(array $job_Requisition_Interview_Team_Reference = array())
    {
        $this
            ->setJob_Requisition_Interview_Team_Reference($job_Requisition_Interview_Team_Reference);
    }
    /**
     * Get Job_Requisition_Interview_Team_Reference value
     * @return \StructType\Job_Requisition_EnabledObjectType[]|null
     */
    public function getJob_Requisition_Interview_Team_Reference()
    {
        return $this->Job_Requisition_Interview_Team_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setJob_Requisition_Interview_Team_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJob_Requisition_Interview_Team_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJob_Requisition_Interview_Team_ReferenceForArrayConstraintsFromSetJob_Requisition_Interview_Team_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $job_Requisition_Interview_Team_Request_ReferencesTypeJob_Requisition_Interview_Team_ReferenceItem) {
            // validation for constraint: itemType
            if (!$job_Requisition_Interview_Team_Request_ReferencesTypeJob_Requisition_Interview_Team_ReferenceItem instanceof \StructType\Job_Requisition_EnabledObjectType) {
                $invalidValues[] = is_object($job_Requisition_Interview_Team_Request_ReferencesTypeJob_Requisition_Interview_Team_ReferenceItem) ? get_class($job_Requisition_Interview_Team_Request_ReferencesTypeJob_Requisition_Interview_Team_ReferenceItem) : sprintf('%s(%s)', gettype($job_Requisition_Interview_Team_Request_ReferencesTypeJob_Requisition_Interview_Team_ReferenceItem), var_export($job_Requisition_Interview_Team_Request_ReferencesTypeJob_Requisition_Interview_Team_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Job_Requisition_Interview_Team_Reference property can only contain items of type \StructType\Job_Requisition_EnabledObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Job_Requisition_Interview_Team_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Job_Requisition_EnabledObjectType[] $job_Requisition_Interview_Team_Reference
     * @return \StructType\Job_Requisition_Interview_Team_Request_ReferencesType
     */
    public function setJob_Requisition_Interview_Team_Reference(array $job_Requisition_Interview_Team_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($job_Requisition_Interview_Team_ReferenceArrayErrorMessage = self::validateJob_Requisition_Interview_Team_ReferenceForArrayConstraintsFromSetJob_Requisition_Interview_Team_Reference($job_Requisition_Interview_Team_Reference))) {
            throw new \InvalidArgumentException($job_Requisition_Interview_Team_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Job_Requisition_Interview_Team_Reference = $job_Requisition_Interview_Team_Reference;
        return $this;
    }
    /**
     * Add item to Job_Requisition_Interview_Team_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Job_Requisition_EnabledObjectType $item
     * @return \StructType\Job_Requisition_Interview_Team_Request_ReferencesType
     */
    public function addToJob_Requisition_Interview_Team_Reference(\StructType\Job_Requisition_EnabledObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Job_Requisition_EnabledObjectType) {
            throw new \InvalidArgumentException(sprintf('The Job_Requisition_Interview_Team_Reference property can only contain items of type \StructType\Job_Requisition_EnabledObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Job_Requisition_Interview_Team_Reference[] = $item;
        return $this;
    }
}
