<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Manage_Job_Requisition_Freeze_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Responds with the event id for the Freeze Job Requisition Event, the Job Requisition Reference, and the frozen/unfrozen state of the job requisition.
 * @subpackage Structs
 */
class Manage_Job_Requisition_Freeze_ResponseType extends AbstractStructBase
{
    /**
     * The Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the Freeze Job Requisition Event
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Event_Reference;
    /**
     * The Job_Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the job requisition to be frozen/unfrozen.
     * - minOccurs: 0
     * @var \StructType\Job_RequisitionObjectType
     */
    public $Job_Requisition_Reference;
    /**
     * The Frozen
     * Meta information extracted from the WSDL
     * - documentation: True if job requisition is frozen, false if not frozen.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $Frozen;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Manage_Job_Requisition_Freeze_ResponseType
     * @uses Manage_Job_Requisition_Freeze_ResponseType::setEvent_Reference()
     * @uses Manage_Job_Requisition_Freeze_ResponseType::setJob_Requisition_Reference()
     * @uses Manage_Job_Requisition_Freeze_ResponseType::setFrozen()
     * @uses Manage_Job_Requisition_Freeze_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $event_Reference
     * @param \StructType\Job_RequisitionObjectType $job_Requisition_Reference
     * @param bool $frozen
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $event_Reference = null, \StructType\Job_RequisitionObjectType $job_Requisition_Reference = null, $frozen = null, $version = null)
    {
        $this
            ->setEvent_Reference($event_Reference)
            ->setJob_Requisition_Reference($job_Requisition_Reference)
            ->setFrozen($frozen)
            ->setVersion($version);
    }
    /**
     * Get Event_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getEvent_Reference()
    {
        return $this->Event_Reference;
    }
    /**
     * Set Event_Reference value
     * @param \StructType\Unique_IdentifierObjectType $event_Reference
     * @return \StructType\Manage_Job_Requisition_Freeze_ResponseType
     */
    public function setEvent_Reference(\StructType\Unique_IdentifierObjectType $event_Reference = null)
    {
        $this->Event_Reference = $event_Reference;
        return $this;
    }
    /**
     * Get Job_Requisition_Reference value
     * @return \StructType\Job_RequisitionObjectType|null
     */
    public function getJob_Requisition_Reference()
    {
        return $this->Job_Requisition_Reference;
    }
    /**
     * Set Job_Requisition_Reference value
     * @param \StructType\Job_RequisitionObjectType $job_Requisition_Reference
     * @return \StructType\Manage_Job_Requisition_Freeze_ResponseType
     */
    public function setJob_Requisition_Reference(\StructType\Job_RequisitionObjectType $job_Requisition_Reference = null)
    {
        $this->Job_Requisition_Reference = $job_Requisition_Reference;
        return $this;
    }
    /**
     * Get Frozen value
     * @return bool|null
     */
    public function getFrozen()
    {
        return $this->Frozen;
    }
    /**
     * Set Frozen value
     * @param bool $frozen
     * @return \StructType\Manage_Job_Requisition_Freeze_ResponseType
     */
    public function setFrozen($frozen = null)
    {
        // validation for constraint: boolean
        if (!is_null($frozen) && !is_bool($frozen)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($frozen, true), gettype($frozen)), __LINE__);
        }
        $this->Frozen = $frozen;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Manage_Job_Requisition_Freeze_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
