<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Move_Candidate_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: A request to move a Candidate from a stage to next possible stage or to a disposition stage.
 * @subpackage Structs
 */
class Move_Candidate_RequestType extends AbstractStructBase
{
    /**
     * The Dynamic_Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Dynamic_Business_Process_ParametersType
     */
    public $Dynamic_Business_Process_Parameters;
    /**
     * The Move_Candidate_Data
     * @var \StructType\Move_Candidate_DataType
     */
    public $Move_Candidate_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Move_Candidate_RequestType
     * @uses Move_Candidate_RequestType::setDynamic_Business_Process_Parameters()
     * @uses Move_Candidate_RequestType::setMove_Candidate_Data()
     * @uses Move_Candidate_RequestType::setVersion()
     * @param \StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters
     * @param \StructType\Move_Candidate_DataType $move_Candidate_Data
     * @param string $version
     */
    public function __construct(\StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters = null, \StructType\Move_Candidate_DataType $move_Candidate_Data = null, $version = null)
    {
        $this
            ->setDynamic_Business_Process_Parameters($dynamic_Business_Process_Parameters)
            ->setMove_Candidate_Data($move_Candidate_Data)
            ->setVersion($version);
    }
    /**
     * Get Dynamic_Business_Process_Parameters value
     * @return \StructType\Dynamic_Business_Process_ParametersType|null
     */
    public function getDynamic_Business_Process_Parameters()
    {
        return $this->Dynamic_Business_Process_Parameters;
    }
    /**
     * Set Dynamic_Business_Process_Parameters value
     * @param \StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters
     * @return \StructType\Move_Candidate_RequestType
     */
    public function setDynamic_Business_Process_Parameters(\StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters = null)
    {
        $this->Dynamic_Business_Process_Parameters = $dynamic_Business_Process_Parameters;
        return $this;
    }
    /**
     * Get Move_Candidate_Data value
     * @return \StructType\Move_Candidate_DataType|null
     */
    public function getMove_Candidate_Data()
    {
        return $this->Move_Candidate_Data;
    }
    /**
     * Set Move_Candidate_Data value
     * @param \StructType\Move_Candidate_DataType $move_Candidate_Data
     * @return \StructType\Move_Candidate_RequestType
     */
    public function setMove_Candidate_Data(\StructType\Move_Candidate_DataType $move_Candidate_Data = null)
    {
        $this->Move_Candidate_Data = $move_Candidate_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Move_Candidate_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
