<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Move_Job_Requisition_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Move a job requisition from one Job Management Organization to another Job Management Organization using the Move Job Requisition business process.
 * @subpackage Structs
 */
class Move_Job_Requisition_RequestType extends AbstractStructBase
{
    /**
     * The Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Business_Process_ParametersType
     */
    public $Business_Process_Parameters;
    /**
     * The Move_Job_Requisition_Data
     * @var \StructType\Move_Job_Requisition_DataType
     */
    public $Move_Job_Requisition_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Move_Job_Requisition_RequestType
     * @uses Move_Job_Requisition_RequestType::setBusiness_Process_Parameters()
     * @uses Move_Job_Requisition_RequestType::setMove_Job_Requisition_Data()
     * @uses Move_Job_Requisition_RequestType::setVersion()
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @param \StructType\Move_Job_Requisition_DataType $move_Job_Requisition_Data
     * @param string $version
     */
    public function __construct(\StructType\Business_Process_ParametersType $business_Process_Parameters = null, \StructType\Move_Job_Requisition_DataType $move_Job_Requisition_Data = null, $version = null)
    {
        $this
            ->setBusiness_Process_Parameters($business_Process_Parameters)
            ->setMove_Job_Requisition_Data($move_Job_Requisition_Data)
            ->setVersion($version);
    }
    /**
     * Get Business_Process_Parameters value
     * @return \StructType\Business_Process_ParametersType|null
     */
    public function getBusiness_Process_Parameters()
    {
        return $this->Business_Process_Parameters;
    }
    /**
     * Set Business_Process_Parameters value
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @return \StructType\Move_Job_Requisition_RequestType
     */
    public function setBusiness_Process_Parameters(\StructType\Business_Process_ParametersType $business_Process_Parameters = null)
    {
        $this->Business_Process_Parameters = $business_Process_Parameters;
        return $this;
    }
    /**
     * Get Move_Job_Requisition_Data value
     * @return \StructType\Move_Job_Requisition_DataType|null
     */
    public function getMove_Job_Requisition_Data()
    {
        return $this->Move_Job_Requisition_Data;
    }
    /**
     * Set Move_Job_Requisition_Data value
     * @param \StructType\Move_Job_Requisition_DataType $move_Job_Requisition_Data
     * @return \StructType\Move_Job_Requisition_RequestType
     */
    public function setMove_Job_Requisition_Data(\StructType\Move_Job_Requisition_DataType $move_Job_Requisition_Data = null)
    {
        $this->Move_Job_Requisition_Data = $move_Job_Requisition_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Move_Job_Requisition_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
