<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Move_Job_Requisition_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: The response to a Move Job Requisition Request. The response contains the ID of a Move Job Requisition Event if the business process was initiated successfully.
 * @subpackage Structs
 */
class Move_Job_Requisition_ResponseType extends AbstractStructBase
{
    /**
     * The Move_Job_Requisition_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Move Job Requisition Event created by the web service.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Move_Job_Requisition_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Move_Job_Requisition_ResponseType
     * @uses Move_Job_Requisition_ResponseType::setMove_Job_Requisition_Reference()
     * @uses Move_Job_Requisition_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $move_Job_Requisition_Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $move_Job_Requisition_Reference = null, $version = null)
    {
        $this
            ->setMove_Job_Requisition_Reference($move_Job_Requisition_Reference)
            ->setVersion($version);
    }
    /**
     * Get Move_Job_Requisition_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getMove_Job_Requisition_Reference()
    {
        return $this->Move_Job_Requisition_Reference;
    }
    /**
     * Set Move_Job_Requisition_Reference value
     * @param \StructType\Unique_IdentifierObjectType $move_Job_Requisition_Reference
     * @return \StructType\Move_Job_Requisition_ResponseType
     */
    public function setMove_Job_Requisition_Reference(\StructType\Unique_IdentifierObjectType $move_Job_Requisition_Reference = null)
    {
        $this->Move_Job_Requisition_Reference = $move_Job_Requisition_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Move_Job_Requisition_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
