<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Background_Check_Package_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing the response of the request to create or update a Background Check Package.
 * @subpackage Structs
 */
class Put_Background_Check_Package_ResponseType extends AbstractStructBase
{
    /**
     * The Background_Check_Package_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the Background Check Package.
     * - minOccurs: 0
     * @var \StructType\Background_Check_PackageObjectType
     */
    public $Background_Check_Package_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Background_Check_Package_ResponseType
     * @uses Put_Background_Check_Package_ResponseType::setBackground_Check_Package_Reference()
     * @uses Put_Background_Check_Package_ResponseType::setVersion()
     * @param \StructType\Background_Check_PackageObjectType $background_Check_Package_Reference
     * @param string $version
     */
    public function __construct(\StructType\Background_Check_PackageObjectType $background_Check_Package_Reference = null, $version = null)
    {
        $this
            ->setBackground_Check_Package_Reference($background_Check_Package_Reference)
            ->setVersion($version);
    }
    /**
     * Get Background_Check_Package_Reference value
     * @return \StructType\Background_Check_PackageObjectType|null
     */
    public function getBackground_Check_Package_Reference()
    {
        return $this->Background_Check_Package_Reference;
    }
    /**
     * Set Background_Check_Package_Reference value
     * @param \StructType\Background_Check_PackageObjectType $background_Check_Package_Reference
     * @return \StructType\Put_Background_Check_Package_ResponseType
     */
    public function setBackground_Check_Package_Reference(\StructType\Background_Check_PackageObjectType $background_Check_Package_Reference = null)
    {
        $this->Background_Check_Package_Reference = $background_Check_Package_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Background_Check_Package_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
