<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Candidate_Photo_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains information about the candidate photo.
 * @subpackage Structs
 */
class Put_Candidate_Photo_RequestType extends AbstractStructBase
{
    /**
     * The Candidate_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to a Candidate.
     * - minOccurs: 0
     * @var \StructType\CandidateObjectType
     */
    public $Candidate_Reference;
    /**
     * The Candidate_Photo_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Candidate_Photo_DataType
     */
    public $Candidate_Photo_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Candidate_Photo_RequestType
     * @uses Put_Candidate_Photo_RequestType::setCandidate_Reference()
     * @uses Put_Candidate_Photo_RequestType::setCandidate_Photo_Data()
     * @uses Put_Candidate_Photo_RequestType::setVersion()
     * @param \StructType\CandidateObjectType $candidate_Reference
     * @param \StructType\Candidate_Photo_DataType $candidate_Photo_Data
     * @param string $version
     */
    public function __construct(\StructType\CandidateObjectType $candidate_Reference = null, \StructType\Candidate_Photo_DataType $candidate_Photo_Data = null, $version = null)
    {
        $this
            ->setCandidate_Reference($candidate_Reference)
            ->setCandidate_Photo_Data($candidate_Photo_Data)
            ->setVersion($version);
    }
    /**
     * Get Candidate_Reference value
     * @return \StructType\CandidateObjectType|null
     */
    public function getCandidate_Reference()
    {
        return $this->Candidate_Reference;
    }
    /**
     * Set Candidate_Reference value
     * @param \StructType\CandidateObjectType $candidate_Reference
     * @return \StructType\Put_Candidate_Photo_RequestType
     */
    public function setCandidate_Reference(\StructType\CandidateObjectType $candidate_Reference = null)
    {
        $this->Candidate_Reference = $candidate_Reference;
        return $this;
    }
    /**
     * Get Candidate_Photo_Data value
     * @return \StructType\Candidate_Photo_DataType|null
     */
    public function getCandidate_Photo_Data()
    {
        return $this->Candidate_Photo_Data;
    }
    /**
     * Set Candidate_Photo_Data value
     * @param \StructType\Candidate_Photo_DataType $candidate_Photo_Data
     * @return \StructType\Put_Candidate_Photo_RequestType
     */
    public function setCandidate_Photo_Data(\StructType\Candidate_Photo_DataType $candidate_Photo_Data = null)
    {
        $this->Candidate_Photo_Data = $candidate_Photo_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Candidate_Photo_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
