<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_External_Reference_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: The successfully added or updated reference check data.
 * @subpackage Structs
 */
class Put_External_Reference_ResponseType extends AbstractStructBase
{
    /**
     * The Reference_Check_Event_Reference
     * Meta information extracted from the WSDL
     * - documentation: The Reference ID of the Reference Check Event.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Reference_Check_Event_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_External_Reference_ResponseType
     * @uses Put_External_Reference_ResponseType::setReference_Check_Event_Reference()
     * @uses Put_External_Reference_ResponseType::setVersion()
     * @param \StructType\Unique_IdentifierObjectType $reference_Check_Event_Reference
     * @param string $version
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $reference_Check_Event_Reference = null, $version = null)
    {
        $this
            ->setReference_Check_Event_Reference($reference_Check_Event_Reference)
            ->setVersion($version);
    }
    /**
     * Get Reference_Check_Event_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getReference_Check_Event_Reference()
    {
        return $this->Reference_Check_Event_Reference;
    }
    /**
     * Set Reference_Check_Event_Reference value
     * @param \StructType\Unique_IdentifierObjectType $reference_Check_Event_Reference
     * @return \StructType\Put_External_Reference_ResponseType
     */
    public function setReference_Check_Event_Reference(\StructType\Unique_IdentifierObjectType $reference_Check_Event_Reference = null)
    {
        $this->Reference_Check_Event_Reference = $reference_Check_Event_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_External_Reference_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
