<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Interview_Feedback_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: A request to submit interview feedback for one or more interviewers.
 * @subpackage Structs
 */
class Put_Interview_Feedback_RequestType extends AbstractStructBase
{
    /**
     * The Dynamic_Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Dynamic_Business_Process_ParametersType
     */
    public $Dynamic_Business_Process_Parameters;
    /**
     * The Interview_Feedback_Data
     * @var \StructType\Interview_Feedback_DataType
     */
    public $Interview_Feedback_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Interview_Feedback_RequestType
     * @uses Put_Interview_Feedback_RequestType::setDynamic_Business_Process_Parameters()
     * @uses Put_Interview_Feedback_RequestType::setInterview_Feedback_Data()
     * @uses Put_Interview_Feedback_RequestType::setVersion()
     * @param \StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters
     * @param \StructType\Interview_Feedback_DataType $interview_Feedback_Data
     * @param string $version
     */
    public function __construct(\StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters = null, \StructType\Interview_Feedback_DataType $interview_Feedback_Data = null, $version = null)
    {
        $this
            ->setDynamic_Business_Process_Parameters($dynamic_Business_Process_Parameters)
            ->setInterview_Feedback_Data($interview_Feedback_Data)
            ->setVersion($version);
    }
    /**
     * Get Dynamic_Business_Process_Parameters value
     * @return \StructType\Dynamic_Business_Process_ParametersType|null
     */
    public function getDynamic_Business_Process_Parameters()
    {
        return $this->Dynamic_Business_Process_Parameters;
    }
    /**
     * Set Dynamic_Business_Process_Parameters value
     * @param \StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters
     * @return \StructType\Put_Interview_Feedback_RequestType
     */
    public function setDynamic_Business_Process_Parameters(\StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters = null)
    {
        $this->Dynamic_Business_Process_Parameters = $dynamic_Business_Process_Parameters;
        return $this;
    }
    /**
     * Get Interview_Feedback_Data value
     * @return \StructType\Interview_Feedback_DataType|null
     */
    public function getInterview_Feedback_Data()
    {
        return $this->Interview_Feedback_Data;
    }
    /**
     * Set Interview_Feedback_Data value
     * @param \StructType\Interview_Feedback_DataType $interview_Feedback_Data
     * @return \StructType\Put_Interview_Feedback_RequestType
     */
    public function setInterview_Feedback_Data(\StructType\Interview_Feedback_DataType $interview_Feedback_Data = null)
    {
        $this->Interview_Feedback_Data = $interview_Feedback_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Interview_Feedback_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
