<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Job_Application_Additional_Data_ResponseType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains Job Application Additional data
 * @subpackage Structs
 */
class Put_Job_Application_Additional_Data_ResponseType extends AbstractStructBase
{
    /**
     * The Job_Application_Additional_Data_Reference
     * Meta information extracted from the WSDL
     * - documentation: Job Application Reference
     * - minOccurs: 0
     * @var \StructType\Job_ApplicationObjectType
     */
    public $Job_Application_Additional_Data_Reference;
    /**
     * The Job_Application_Additional_Data
     * Meta information extracted from the WSDL
     * - documentation: Job Application Additional Data
     * - minOccurs: 0
     * @var \StructType\Non_Effective_Dated_Web_Service_Additional_DataType
     */
    public $Job_Application_Additional_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Job_Application_Additional_Data_ResponseType
     * @uses Put_Job_Application_Additional_Data_ResponseType::setJob_Application_Additional_Data_Reference()
     * @uses Put_Job_Application_Additional_Data_ResponseType::setJob_Application_Additional_Data()
     * @uses Put_Job_Application_Additional_Data_ResponseType::setVersion()
     * @param \StructType\Job_ApplicationObjectType $job_Application_Additional_Data_Reference
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $job_Application_Additional_Data
     * @param string $version
     */
    public function __construct(\StructType\Job_ApplicationObjectType $job_Application_Additional_Data_Reference = null, \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $job_Application_Additional_Data = null, $version = null)
    {
        $this
            ->setJob_Application_Additional_Data_Reference($job_Application_Additional_Data_Reference)
            ->setJob_Application_Additional_Data($job_Application_Additional_Data)
            ->setVersion($version);
    }
    /**
     * Get Job_Application_Additional_Data_Reference value
     * @return \StructType\Job_ApplicationObjectType|null
     */
    public function getJob_Application_Additional_Data_Reference()
    {
        return $this->Job_Application_Additional_Data_Reference;
    }
    /**
     * Set Job_Application_Additional_Data_Reference value
     * @param \StructType\Job_ApplicationObjectType $job_Application_Additional_Data_Reference
     * @return \StructType\Put_Job_Application_Additional_Data_ResponseType
     */
    public function setJob_Application_Additional_Data_Reference(\StructType\Job_ApplicationObjectType $job_Application_Additional_Data_Reference = null)
    {
        $this->Job_Application_Additional_Data_Reference = $job_Application_Additional_Data_Reference;
        return $this;
    }
    /**
     * Get Job_Application_Additional_Data value
     * @return \StructType\Non_Effective_Dated_Web_Service_Additional_DataType|null
     */
    public function getJob_Application_Additional_Data()
    {
        return $this->Job_Application_Additional_Data;
    }
    /**
     * Set Job_Application_Additional_Data value
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $job_Application_Additional_Data
     * @return \StructType\Put_Job_Application_Additional_Data_ResponseType
     */
    public function setJob_Application_Additional_Data(\StructType\Non_Effective_Dated_Web_Service_Additional_DataType $job_Application_Additional_Data = null)
    {
        $this->Job_Application_Additional_Data = $job_Application_Additional_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Job_Application_Additional_Data_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
