<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Maintain_Candidate_List_Assignment_RequestType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Maintain Candidate List Assignment Request
 * @subpackage Structs
 */
class Put_Maintain_Candidate_List_Assignment_RequestType extends AbstractStructBase
{
    /**
     * The Candidate_List_Assignment_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference to the existing Candidate List Assignment
     * - minOccurs: 0
     * @var \StructType\Candidate_List_Rule_Configuration_SingletonObjectType
     */
    public $Candidate_List_Assignment_Reference;
    /**
     * The Maintain_Candidate_List_Assignment_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains the Condition Rules for Maintain Candidate List Assignment
     * @var \StructType\Maintain_Candidate_List_Assignment_DataType
     */
    public $Maintain_Candidate_List_Assignment_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Maintain_Candidate_List_Assignment_RequestType
     * @uses Put_Maintain_Candidate_List_Assignment_RequestType::setCandidate_List_Assignment_Reference()
     * @uses Put_Maintain_Candidate_List_Assignment_RequestType::setMaintain_Candidate_List_Assignment_Data()
     * @uses Put_Maintain_Candidate_List_Assignment_RequestType::setVersion()
     * @param \StructType\Candidate_List_Rule_Configuration_SingletonObjectType $candidate_List_Assignment_Reference
     * @param \StructType\Maintain_Candidate_List_Assignment_DataType $maintain_Candidate_List_Assignment_Data
     * @param string $version
     */
    public function __construct(\StructType\Candidate_List_Rule_Configuration_SingletonObjectType $candidate_List_Assignment_Reference = null, \StructType\Maintain_Candidate_List_Assignment_DataType $maintain_Candidate_List_Assignment_Data = null, $version = null)
    {
        $this
            ->setCandidate_List_Assignment_Reference($candidate_List_Assignment_Reference)
            ->setMaintain_Candidate_List_Assignment_Data($maintain_Candidate_List_Assignment_Data)
            ->setVersion($version);
    }
    /**
     * Get Candidate_List_Assignment_Reference value
     * @return \StructType\Candidate_List_Rule_Configuration_SingletonObjectType|null
     */
    public function getCandidate_List_Assignment_Reference()
    {
        return $this->Candidate_List_Assignment_Reference;
    }
    /**
     * Set Candidate_List_Assignment_Reference value
     * @param \StructType\Candidate_List_Rule_Configuration_SingletonObjectType $candidate_List_Assignment_Reference
     * @return \StructType\Put_Maintain_Candidate_List_Assignment_RequestType
     */
    public function setCandidate_List_Assignment_Reference(\StructType\Candidate_List_Rule_Configuration_SingletonObjectType $candidate_List_Assignment_Reference = null)
    {
        $this->Candidate_List_Assignment_Reference = $candidate_List_Assignment_Reference;
        return $this;
    }
    /**
     * Get Maintain_Candidate_List_Assignment_Data value
     * @return \StructType\Maintain_Candidate_List_Assignment_DataType|null
     */
    public function getMaintain_Candidate_List_Assignment_Data()
    {
        return $this->Maintain_Candidate_List_Assignment_Data;
    }
    /**
     * Set Maintain_Candidate_List_Assignment_Data value
     * @param \StructType\Maintain_Candidate_List_Assignment_DataType $maintain_Candidate_List_Assignment_Data
     * @return \StructType\Put_Maintain_Candidate_List_Assignment_RequestType
     */
    public function setMaintain_Candidate_List_Assignment_Data(\StructType\Maintain_Candidate_List_Assignment_DataType $maintain_Candidate_List_Assignment_Data = null)
    {
        $this->Maintain_Candidate_List_Assignment_Data = $maintain_Candidate_List_Assignment_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Maintain_Candidate_List_Assignment_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
