<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Masked_Recruiting_Configuration_ResponseType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Container for Masked Configuration Response element
 * @subpackage Structs
 */
class Put_Masked_Recruiting_Configuration_ResponseType extends AbstractStructBase
{
    /**
     * The Masked_Configuration_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference of Masked Configuration
     * - minOccurs: 0
     * @var \StructType\Masked_ConfigurationObjectType
     */
    public $Masked_Configuration_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Masked_Recruiting_Configuration_ResponseType
     * @uses Put_Masked_Recruiting_Configuration_ResponseType::setMasked_Configuration_Reference()
     * @uses Put_Masked_Recruiting_Configuration_ResponseType::setVersion()
     * @param \StructType\Masked_ConfigurationObjectType $masked_Configuration_Reference
     * @param string $version
     */
    public function __construct(\StructType\Masked_ConfigurationObjectType $masked_Configuration_Reference = null, $version = null)
    {
        $this
            ->setMasked_Configuration_Reference($masked_Configuration_Reference)
            ->setVersion($version);
    }
    /**
     * Get Masked_Configuration_Reference value
     * @return \StructType\Masked_ConfigurationObjectType|null
     */
    public function getMasked_Configuration_Reference()
    {
        return $this->Masked_Configuration_Reference;
    }
    /**
     * Set Masked_Configuration_Reference value
     * @param \StructType\Masked_ConfigurationObjectType $masked_Configuration_Reference
     * @return \StructType\Put_Masked_Recruiting_Configuration_ResponseType
     */
    public function setMasked_Configuration_Reference(\StructType\Masked_ConfigurationObjectType $masked_Configuration_Reference = null)
    {
        $this->Masked_Configuration_Reference = $masked_Configuration_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Masked_Recruiting_Configuration_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
