<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Recruiting_Agency_Additional_Data_ResponseType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Custom Object Information for Recruiting Agency.
 * @subpackage Structs
 */
class Put_Recruiting_Agency_Additional_Data_ResponseType extends AbstractStructBase
{
    /**
     * The Recruiting_Agency_Additional_Data_Reference
     * Meta information extracted from the WSDL
     * - documentation: Recruiting Agency Additional Data
     * - minOccurs: 0
     * @var \StructType\Recruiting_Agency_SiteObjectType
     */
    public $Recruiting_Agency_Additional_Data_Reference;
    /**
     * The Recruiting_Agency_Additional_Data
     * Meta information extracted from the WSDL
     * - documentation: Additional Data Reference
     * - minOccurs: 0
     * @var \StructType\Non_Effective_Dated_Web_Service_Additional_DataType
     */
    public $Recruiting_Agency_Additional_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Recruiting_Agency_Additional_Data_ResponseType
     * @uses Put_Recruiting_Agency_Additional_Data_ResponseType::setRecruiting_Agency_Additional_Data_Reference()
     * @uses Put_Recruiting_Agency_Additional_Data_ResponseType::setRecruiting_Agency_Additional_Data()
     * @uses Put_Recruiting_Agency_Additional_Data_ResponseType::setVersion()
     * @param \StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Additional_Data_Reference
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $recruiting_Agency_Additional_Data
     * @param string $version
     */
    public function __construct(\StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Additional_Data_Reference = null, \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $recruiting_Agency_Additional_Data = null, $version = null)
    {
        $this
            ->setRecruiting_Agency_Additional_Data_Reference($recruiting_Agency_Additional_Data_Reference)
            ->setRecruiting_Agency_Additional_Data($recruiting_Agency_Additional_Data)
            ->setVersion($version);
    }
    /**
     * Get Recruiting_Agency_Additional_Data_Reference value
     * @return \StructType\Recruiting_Agency_SiteObjectType|null
     */
    public function getRecruiting_Agency_Additional_Data_Reference()
    {
        return $this->Recruiting_Agency_Additional_Data_Reference;
    }
    /**
     * Set Recruiting_Agency_Additional_Data_Reference value
     * @param \StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Additional_Data_Reference
     * @return \StructType\Put_Recruiting_Agency_Additional_Data_ResponseType
     */
    public function setRecruiting_Agency_Additional_Data_Reference(\StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Additional_Data_Reference = null)
    {
        $this->Recruiting_Agency_Additional_Data_Reference = $recruiting_Agency_Additional_Data_Reference;
        return $this;
    }
    /**
     * Get Recruiting_Agency_Additional_Data value
     * @return \StructType\Non_Effective_Dated_Web_Service_Additional_DataType|null
     */
    public function getRecruiting_Agency_Additional_Data()
    {
        return $this->Recruiting_Agency_Additional_Data;
    }
    /**
     * Set Recruiting_Agency_Additional_Data value
     * @param \StructType\Non_Effective_Dated_Web_Service_Additional_DataType $recruiting_Agency_Additional_Data
     * @return \StructType\Put_Recruiting_Agency_Additional_Data_ResponseType
     */
    public function setRecruiting_Agency_Additional_Data(\StructType\Non_Effective_Dated_Web_Service_Additional_DataType $recruiting_Agency_Additional_Data = null)
    {
        $this->Recruiting_Agency_Additional_Data = $recruiting_Agency_Additional_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Recruiting_Agency_Additional_Data_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
