<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Recruiting_Agency_ResponseType StructType
 * Meta information extracted from the WSDL
 * - documentation: Put Recruiting Agency Response
 * @subpackage Structs
 */
class Put_Recruiting_Agency_ResponseType extends AbstractStructBase
{
    /**
     * The Recruiting_Agency_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference element representing a unique instance of Recruiting Agency Site.
     * - minOccurs: 0
     * @var \StructType\Recruiting_Agency_SiteObjectType
     */
    public $Recruiting_Agency_Reference;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Recruiting_Agency_ResponseType
     * @uses Put_Recruiting_Agency_ResponseType::setRecruiting_Agency_Reference()
     * @uses Put_Recruiting_Agency_ResponseType::setVersion()
     * @param \StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Reference
     * @param string $version
     */
    public function __construct(\StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Reference = null, $version = null)
    {
        $this
            ->setRecruiting_Agency_Reference($recruiting_Agency_Reference)
            ->setVersion($version);
    }
    /**
     * Get Recruiting_Agency_Reference value
     * @return \StructType\Recruiting_Agency_SiteObjectType|null
     */
    public function getRecruiting_Agency_Reference()
    {
        return $this->Recruiting_Agency_Reference;
    }
    /**
     * Set Recruiting_Agency_Reference value
     * @param \StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Reference
     * @return \StructType\Put_Recruiting_Agency_ResponseType
     */
    public function setRecruiting_Agency_Reference(\StructType\Recruiting_Agency_SiteObjectType $recruiting_Agency_Reference = null)
    {
        $this->Recruiting_Agency_Reference = $recruiting_Agency_Reference;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Recruiting_Agency_ResponseType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
