<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for QuestionnaireType StructType
 * Meta information extracted from the WSDL
 * - documentation: The questionnaire reference and all data associated with it.
 * @subpackage Structs
 */
class QuestionnaireType extends AbstractStructBase
{
    /**
     * The Questionnaire_Reference
     * Meta information extracted from the WSDL
     * - documentation: The questionnaire reference.
     * - minOccurs: 0
     * @var \StructType\QuestionnaireObjectType
     */
    public $Questionnaire_Reference;
    /**
     * The Questionnaire_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Questionnaire_DataType
     */
    public $Questionnaire_Data;
    /**
     * Constructor method for QuestionnaireType
     * @uses QuestionnaireType::setQuestionnaire_Reference()
     * @uses QuestionnaireType::setQuestionnaire_Data()
     * @param \StructType\QuestionnaireObjectType $questionnaire_Reference
     * @param \StructType\Questionnaire_DataType $questionnaire_Data
     */
    public function __construct(\StructType\QuestionnaireObjectType $questionnaire_Reference = null, \StructType\Questionnaire_DataType $questionnaire_Data = null)
    {
        $this
            ->setQuestionnaire_Reference($questionnaire_Reference)
            ->setQuestionnaire_Data($questionnaire_Data);
    }
    /**
     * Get Questionnaire_Reference value
     * @return \StructType\QuestionnaireObjectType|null
     */
    public function getQuestionnaire_Reference()
    {
        return $this->Questionnaire_Reference;
    }
    /**
     * Set Questionnaire_Reference value
     * @param \StructType\QuestionnaireObjectType $questionnaire_Reference
     * @return \StructType\QuestionnaireType
     */
    public function setQuestionnaire_Reference(\StructType\QuestionnaireObjectType $questionnaire_Reference = null)
    {
        $this->Questionnaire_Reference = $questionnaire_Reference;
        return $this;
    }
    /**
     * Get Questionnaire_Data value
     * @return \StructType\Questionnaire_DataType|null
     */
    public function getQuestionnaire_Data()
    {
        return $this->Questionnaire_Data;
    }
    /**
     * Set Questionnaire_Data value
     * @param \StructType\Questionnaire_DataType $questionnaire_Data
     * @return \StructType\QuestionnaireType
     */
    public function setQuestionnaire_Data(\StructType\Questionnaire_DataType $questionnaire_Data = null)
    {
        $this->Questionnaire_Data = $questionnaire_Data;
        return $this;
    }
}
