<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Recruiting_Agency_Request_ReferencesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Recruiting Agency Reference.
 * @subpackage Structs
 */
class Recruiting_Agency_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Recruiting_Agency_Reference
     * Meta information extracted from the WSDL
     * - documentation: Recruiting Agency User Reference
     * - maxOccurs: unbounded
     * @var \StructType\Recruiting_Agency_SiteObjectType[]
     */
    public $Recruiting_Agency_Reference;
    /**
     * Constructor method for Recruiting_Agency_Request_ReferencesType
     * @uses Recruiting_Agency_Request_ReferencesType::setRecruiting_Agency_Reference()
     * @param \StructType\Recruiting_Agency_SiteObjectType[] $recruiting_Agency_Reference
     */
    public function __construct(array $recruiting_Agency_Reference = array())
    {
        $this
            ->setRecruiting_Agency_Reference($recruiting_Agency_Reference);
    }
    /**
     * Get Recruiting_Agency_Reference value
     * @return \StructType\Recruiting_Agency_SiteObjectType[]|null
     */
    public function getRecruiting_Agency_Reference()
    {
        return $this->Recruiting_Agency_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setRecruiting_Agency_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRecruiting_Agency_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRecruiting_Agency_ReferenceForArrayConstraintsFromSetRecruiting_Agency_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $recruiting_Agency_Request_ReferencesTypeRecruiting_Agency_ReferenceItem) {
            // validation for constraint: itemType
            if (!$recruiting_Agency_Request_ReferencesTypeRecruiting_Agency_ReferenceItem instanceof \StructType\Recruiting_Agency_SiteObjectType) {
                $invalidValues[] = is_object($recruiting_Agency_Request_ReferencesTypeRecruiting_Agency_ReferenceItem) ? get_class($recruiting_Agency_Request_ReferencesTypeRecruiting_Agency_ReferenceItem) : sprintf('%s(%s)', gettype($recruiting_Agency_Request_ReferencesTypeRecruiting_Agency_ReferenceItem), var_export($recruiting_Agency_Request_ReferencesTypeRecruiting_Agency_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Recruiting_Agency_Reference property can only contain items of type \StructType\Recruiting_Agency_SiteObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Recruiting_Agency_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Recruiting_Agency_SiteObjectType[] $recruiting_Agency_Reference
     * @return \StructType\Recruiting_Agency_Request_ReferencesType
     */
    public function setRecruiting_Agency_Reference(array $recruiting_Agency_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($recruiting_Agency_ReferenceArrayErrorMessage = self::validateRecruiting_Agency_ReferenceForArrayConstraintsFromSetRecruiting_Agency_Reference($recruiting_Agency_Reference))) {
            throw new \InvalidArgumentException($recruiting_Agency_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Recruiting_Agency_Reference = $recruiting_Agency_Reference;
        return $this;
    }
    /**
     * Add item to Recruiting_Agency_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Recruiting_Agency_SiteObjectType $item
     * @return \StructType\Recruiting_Agency_Request_ReferencesType
     */
    public function addToRecruiting_Agency_Reference(\StructType\Recruiting_Agency_SiteObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Recruiting_Agency_SiteObjectType) {
            throw new \InvalidArgumentException(sprintf('The Recruiting_Agency_Reference property can only contain items of type \StructType\Recruiting_Agency_SiteObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Recruiting_Agency_Reference[] = $item;
        return $this;
    }
}
