<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for
 * Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType
 * StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing references to Recruiting Assessment Category Security Segments to retrieve.
 * @subpackage Structs
 */
class Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType extends AbstractStructBase
{
    /**
     * The Recruiting_Assessment_Category_Security_Segment_Reference
     * Meta information extracted from the WSDL
     * - documentation: References to Recruiting Assessment Category Security Segments to retrieve.
     * - maxOccurs: unbounded
     * @var \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType[]
     */
    public $Recruiting_Assessment_Category_Security_Segment_Reference;
    /**
     * Constructor method for
     * Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType
     * @uses Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType::setRecruiting_Assessment_Category_Security_Segment_Reference()
     * @param \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType[] $recruiting_Assessment_Category_Security_Segment_Reference
     */
    public function __construct(array $recruiting_Assessment_Category_Security_Segment_Reference = array())
    {
        $this
            ->setRecruiting_Assessment_Category_Security_Segment_Reference($recruiting_Assessment_Category_Security_Segment_Reference);
    }
    /**
     * Get Recruiting_Assessment_Category_Security_Segment_Reference value
     * @return \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType[]|null
     */
    public function getRecruiting_Assessment_Category_Security_Segment_Reference()
    {
        return $this->Recruiting_Assessment_Category_Security_Segment_Reference;
    }
    /**
     * This method is responsible for validating the values passed to the setRecruiting_Assessment_Category_Security_Segment_Reference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRecruiting_Assessment_Category_Security_Segment_Reference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRecruiting_Assessment_Category_Security_Segment_ReferenceForArrayConstraintsFromSetRecruiting_Assessment_Category_Security_Segment_Reference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $recruiting_Assessment_Category_Security_Segment_Request_ReferencesTypeRecruiting_Assessment_Category_Security_Segment_ReferenceItem) {
            // validation for constraint: itemType
            if (!$recruiting_Assessment_Category_Security_Segment_Request_ReferencesTypeRecruiting_Assessment_Category_Security_Segment_ReferenceItem instanceof \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType) {
                $invalidValues[] = is_object($recruiting_Assessment_Category_Security_Segment_Request_ReferencesTypeRecruiting_Assessment_Category_Security_Segment_ReferenceItem) ? get_class($recruiting_Assessment_Category_Security_Segment_Request_ReferencesTypeRecruiting_Assessment_Category_Security_Segment_ReferenceItem) : sprintf('%s(%s)', gettype($recruiting_Assessment_Category_Security_Segment_Request_ReferencesTypeRecruiting_Assessment_Category_Security_Segment_ReferenceItem), var_export($recruiting_Assessment_Category_Security_Segment_Request_ReferencesTypeRecruiting_Assessment_Category_Security_Segment_ReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Recruiting_Assessment_Category_Security_Segment_Reference property can only contain items of type \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Recruiting_Assessment_Category_Security_Segment_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType[] $recruiting_Assessment_Category_Security_Segment_Reference
     * @return \StructType\Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType
     */
    public function setRecruiting_Assessment_Category_Security_Segment_Reference(array $recruiting_Assessment_Category_Security_Segment_Reference = array())
    {
        // validation for constraint: array
        if ('' !== ($recruiting_Assessment_Category_Security_Segment_ReferenceArrayErrorMessage = self::validateRecruiting_Assessment_Category_Security_Segment_ReferenceForArrayConstraintsFromSetRecruiting_Assessment_Category_Security_Segment_Reference($recruiting_Assessment_Category_Security_Segment_Reference))) {
            throw new \InvalidArgumentException($recruiting_Assessment_Category_Security_Segment_ReferenceArrayErrorMessage, __LINE__);
        }
        $this->Recruiting_Assessment_Category_Security_Segment_Reference = $recruiting_Assessment_Category_Security_Segment_Reference;
        return $this;
    }
    /**
     * Add item to Recruiting_Assessment_Category_Security_Segment_Reference value
     * @throws \InvalidArgumentException
     * @param \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType $item
     * @return \StructType\Recruiting_Assessment_Category_Security_Segment_Request_ReferencesType
     */
    public function addToRecruiting_Assessment_Category_Security_Segment_Reference(\StructType\Recruiting_Assessment_Category_Security_SegmentObjectType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType) {
            throw new \InvalidArgumentException(sprintf('The Recruiting_Assessment_Category_Security_Segment_Reference property can only contain items of type \StructType\Recruiting_Assessment_Category_Security_SegmentObjectType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Recruiting_Assessment_Category_Security_Segment_Reference[] = $item;
        return $this;
    }
}
