<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Role_AssignmentType StructType
 * Meta information extracted from the WSDL
 * - documentation: Encapsulating Element for all Organization Role Assignment data.
 * @subpackage Structs
 */
class Role_AssignmentType extends AbstractStructBase
{
    /**
     * The Role_Assignment_Reference
     * Meta information extracted from the WSDL
     * - documentation: Workday ID for Role Assignment.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Role_Assignment_Reference;
    /**
     * The Role_Assignment_Data
     * @var \StructType\Organization_Role_Assignment_DataType
     */
    public $Role_Assignment_Data;
    /**
     * Constructor method for Role_AssignmentType
     * @uses Role_AssignmentType::setRole_Assignment_Reference()
     * @uses Role_AssignmentType::setRole_Assignment_Data()
     * @param \StructType\Unique_IdentifierObjectType $role_Assignment_Reference
     * @param \StructType\Organization_Role_Assignment_DataType $role_Assignment_Data
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $role_Assignment_Reference = null, \StructType\Organization_Role_Assignment_DataType $role_Assignment_Data = null)
    {
        $this
            ->setRole_Assignment_Reference($role_Assignment_Reference)
            ->setRole_Assignment_Data($role_Assignment_Data);
    }
    /**
     * Get Role_Assignment_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getRole_Assignment_Reference()
    {
        return $this->Role_Assignment_Reference;
    }
    /**
     * Set Role_Assignment_Reference value
     * @param \StructType\Unique_IdentifierObjectType $role_Assignment_Reference
     * @return \StructType\Role_AssignmentType
     */
    public function setRole_Assignment_Reference(\StructType\Unique_IdentifierObjectType $role_Assignment_Reference = null)
    {
        $this->Role_Assignment_Reference = $role_Assignment_Reference;
        return $this;
    }
    /**
     * Get Role_Assignment_Data value
     * @return \StructType\Organization_Role_Assignment_DataType|null
     */
    public function getRole_Assignment_Data()
    {
        return $this->Role_Assignment_Data;
    }
    /**
     * Set Role_Assignment_Data value
     * @param \StructType\Organization_Role_Assignment_DataType $role_Assignment_Data
     * @return \StructType\Role_AssignmentType
     */
    public function setRole_Assignment_Data(\StructType\Organization_Role_Assignment_DataType $role_Assignment_Data = null)
    {
        $this->Role_Assignment_Data = $role_Assignment_Data;
        return $this;
    }
}
