<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Skill_Profile_for_JobType StructType
 * Meta information extracted from the WSDL
 * - documentation: Contains the Position's Skill information.
 * @subpackage Structs
 */
class Skill_Profile_for_JobType extends AbstractStructBase
{
    /**
     * The Skill_Profile_Reference
     * Meta information extracted from the WSDL
     * - documentation: Reference for the Skill profile.
     * - minOccurs: 0
     * @var \StructType\Unique_IdentifierObjectType
     */
    public $Skill_Profile_Reference;
    /**
     * The Skill_Profile_Data
     * Meta information extracted from the WSDL
     * - documentation: Contains the Skill profile's information for a position.
     * - minOccurs: 0
     * @var \StructType\Skill_Profile_for_Job_DataType
     */
    public $Skill_Profile_Data;
    /**
     * Constructor method for Skill_Profile_for_JobType
     * @uses Skill_Profile_for_JobType::setSkill_Profile_Reference()
     * @uses Skill_Profile_for_JobType::setSkill_Profile_Data()
     * @param \StructType\Unique_IdentifierObjectType $skill_Profile_Reference
     * @param \StructType\Skill_Profile_for_Job_DataType $skill_Profile_Data
     */
    public function __construct(\StructType\Unique_IdentifierObjectType $skill_Profile_Reference = null, \StructType\Skill_Profile_for_Job_DataType $skill_Profile_Data = null)
    {
        $this
            ->setSkill_Profile_Reference($skill_Profile_Reference)
            ->setSkill_Profile_Data($skill_Profile_Data);
    }
    /**
     * Get Skill_Profile_Reference value
     * @return \StructType\Unique_IdentifierObjectType|null
     */
    public function getSkill_Profile_Reference()
    {
        return $this->Skill_Profile_Reference;
    }
    /**
     * Set Skill_Profile_Reference value
     * @param \StructType\Unique_IdentifierObjectType $skill_Profile_Reference
     * @return \StructType\Skill_Profile_for_JobType
     */
    public function setSkill_Profile_Reference(\StructType\Unique_IdentifierObjectType $skill_Profile_Reference = null)
    {
        $this->Skill_Profile_Reference = $skill_Profile_Reference;
        return $this;
    }
    /**
     * Get Skill_Profile_Data value
     * @return \StructType\Skill_Profile_for_Job_DataType|null
     */
    public function getSkill_Profile_Data()
    {
        return $this->Skill_Profile_Data;
    }
    /**
     * Set Skill_Profile_Data value
     * @param \StructType\Skill_Profile_for_Job_DataType $skill_Profile_Data
     * @return \StructType\Skill_Profile_for_JobType
     */
    public function setSkill_Profile_Data(\StructType\Skill_Profile_for_Job_DataType $skill_Profile_Data = null)
    {
        $this->Skill_Profile_Data = $skill_Profile_Data;
        return $this;
    }
}
