<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Unpost_Job_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Unposts a Jop Posting.
 * @subpackage Structs
 */
class Unpost_Job_RequestType extends AbstractStructBase
{
    /**
     * The Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Business_Process_ParametersType
     */
    public $Business_Process_Parameters;
    /**
     * The Unpost_Job_Data
     * Meta information extracted from the WSDL
     * - documentation: Data for unposting a job.
     * @var \StructType\Unpost_Job_Business_Process_DataType
     */
    public $Unpost_Job_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Unpost_Job_RequestType
     * @uses Unpost_Job_RequestType::setBusiness_Process_Parameters()
     * @uses Unpost_Job_RequestType::setUnpost_Job_Data()
     * @uses Unpost_Job_RequestType::setVersion()
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @param \StructType\Unpost_Job_Business_Process_DataType $unpost_Job_Data
     * @param string $version
     */
    public function __construct(\StructType\Business_Process_ParametersType $business_Process_Parameters = null, \StructType\Unpost_Job_Business_Process_DataType $unpost_Job_Data = null, $version = null)
    {
        $this
            ->setBusiness_Process_Parameters($business_Process_Parameters)
            ->setUnpost_Job_Data($unpost_Job_Data)
            ->setVersion($version);
    }
    /**
     * Get Business_Process_Parameters value
     * @return \StructType\Business_Process_ParametersType|null
     */
    public function getBusiness_Process_Parameters()
    {
        return $this->Business_Process_Parameters;
    }
    /**
     * Set Business_Process_Parameters value
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @return \StructType\Unpost_Job_RequestType
     */
    public function setBusiness_Process_Parameters(\StructType\Business_Process_ParametersType $business_Process_Parameters = null)
    {
        $this->Business_Process_Parameters = $business_Process_Parameters;
        return $this;
    }
    /**
     * Get Unpost_Job_Data value
     * @return \StructType\Unpost_Job_Business_Process_DataType|null
     */
    public function getUnpost_Job_Data()
    {
        return $this->Unpost_Job_Data;
    }
    /**
     * Set Unpost_Job_Data value
     * @param \StructType\Unpost_Job_Business_Process_DataType $unpost_Job_Data
     * @return \StructType\Unpost_Job_RequestType
     */
    public function setUnpost_Job_Data(\StructType\Unpost_Job_Business_Process_DataType $unpost_Job_Data = null)
    {
        $this->Unpost_Job_Data = $unpost_Job_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Unpost_Job_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
