<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Update_Job_Posting_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Run an Update Job Posting Event.
 * @subpackage Structs
 */
class Update_Job_Posting_RequestType extends AbstractStructBase
{
    /**
     * The Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Business_Process_ParametersType
     */
    public $Business_Process_Parameters;
    /**
     * The Update_Job_Posting_Data
     * @var \StructType\Update_Job_Posting_Business_Process_DataType
     */
    public $Update_Job_Posting_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Update_Job_Posting_RequestType
     * @uses Update_Job_Posting_RequestType::setBusiness_Process_Parameters()
     * @uses Update_Job_Posting_RequestType::setUpdate_Job_Posting_Data()
     * @uses Update_Job_Posting_RequestType::setVersion()
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @param \StructType\Update_Job_Posting_Business_Process_DataType $update_Job_Posting_Data
     * @param string $version
     */
    public function __construct(\StructType\Business_Process_ParametersType $business_Process_Parameters = null, \StructType\Update_Job_Posting_Business_Process_DataType $update_Job_Posting_Data = null, $version = null)
    {
        $this
            ->setBusiness_Process_Parameters($business_Process_Parameters)
            ->setUpdate_Job_Posting_Data($update_Job_Posting_Data)
            ->setVersion($version);
    }
    /**
     * Get Business_Process_Parameters value
     * @return \StructType\Business_Process_ParametersType|null
     */
    public function getBusiness_Process_Parameters()
    {
        return $this->Business_Process_Parameters;
    }
    /**
     * Set Business_Process_Parameters value
     * @param \StructType\Business_Process_ParametersType $business_Process_Parameters
     * @return \StructType\Update_Job_Posting_RequestType
     */
    public function setBusiness_Process_Parameters(\StructType\Business_Process_ParametersType $business_Process_Parameters = null)
    {
        $this->Business_Process_Parameters = $business_Process_Parameters;
        return $this;
    }
    /**
     * Get Update_Job_Posting_Data value
     * @return \StructType\Update_Job_Posting_Business_Process_DataType|null
     */
    public function getUpdate_Job_Posting_Data()
    {
        return $this->Update_Job_Posting_Data;
    }
    /**
     * Set Update_Job_Posting_Data value
     * @param \StructType\Update_Job_Posting_Business_Process_DataType $update_Job_Posting_Data
     * @return \StructType\Update_Job_Posting_RequestType
     */
    public function setUpdate_Job_Posting_Data(\StructType\Update_Job_Posting_Business_Process_DataType $update_Job_Posting_Data = null)
    {
        $this->Update_Job_Posting_Data = $update_Job_Posting_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Update_Job_Posting_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
